// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(h) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function Ee(e, n) {
        return n.indexOf(e) >= 0;
    }
    function ce(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function K(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = K(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function ae(e, n, t) {
        if (t) for (var i in e) {
            if (Ne(e, i) && !Ne(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (Ne(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (Ne(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Se() {}
    function Te() {
        return false;
    }
    function Oe() {
        return true;
    }
    function De() {
        return this;
    }
    function Ae() {
        return null;
    }
    var ze = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === o) continue;
                if (r instanceof a) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === o || e instanceof a;
        };
        e.splice = function(e) {
            return new a(e);
        };
        var o = e.skip = {};
        function a(e) {
            this.v = e;
        }
        return e;
    }();
    function $e(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function je(e, i) {
        return e.replace(/\{([^}]+)\}/g, function(e, n) {
            var t = i[n];
            return t instanceof He ? t.print_to_string() : t;
        });
    }
    function Me(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function qe(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function Fe(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function Ce() {
        this._values = Object.create(null);
        this._size = 0;
    }
    Ce.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new Ce();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    Ce.fromObject = function(e) {
        var n = new Ce();
        n._size = t(n._values, e);
        return n;
    };
    function Ne(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function Pe(e) {
        var n = e.parent(-1);
        for (var t = 0, i; i = e.parent(t++); n = i) {
            if (i.TYPE == "Call") {
                if (i.expression === n) continue;
            } else if (i instanceof Hn) {
                if (i.left === n) continue;
            } else if (i instanceof In) {
                if (i.condition === n) continue;
            } else if (i instanceof Mn) {
                if (i.expression === n) continue;
            } else if (i instanceof jn) {
                if (i.expressions[0] === n) continue;
            } else if (i instanceof Ie) {
                return i.body === n;
            } else if (i instanceof Pn) {
                if (i.expression === n) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = He;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var o = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            o.push("this.", e, "=props.", e, ";");
        });
        var a = i && new i();
        if (a && a.initialize || t && t.initialize) o.push("this.initialize();");
        o.push("}}");
        var s = new Function(o.join(""))();
        if (a) {
            s.prototype = a;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (Ne(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof h !== "undefined") {
            h["AST_" + e] = s;
        }
        return s;
    }
    var Q = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var He = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Tt(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: Se,
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new wt(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(je("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    (He.log_function = function(n, e) {
        if (!n) {
            He.info = He.warn = Se;
            return;
        }
        var t = Object.create(null);
        He.info = e ? function(e, n) {
            i("INFO: " + je(e, n));
        } : Se;
        He.warn = function(e, n) {
            i("WARN: " + je(e, n));
        };
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var o = [];
    He.enable_validation = function() {
        He.disable_validation();
        (function e(n) {
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof He) {
                    t.validate();
                } else if (!(t === null || n && ze.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            o.push(function() {
                n.prototype.transform = i;
            });
            n.SUBCLASSES.forEach(e);
        })(this);
    };
    He.disable_validation = function() {
        var e;
        while (e = o.pop()) e();
    };
    var Ie = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var Re = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Ie);
    var Ue = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Ie);
    var Be = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Ie);
    function a(e, n) {
        if (!(e[n] instanceof He)) throw new Error(n + " must be AST_Node");
        if (e[n] instanceof Ie && !(e[n] instanceof fn)) {
            throw new Error(n + " cannot be AST_Statement");
        }
    }
    var Ye = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            a(this, "body");
        }
    }, Ie);
    var Le = i("BlockScope", "enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Object/S] a map of name -> SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof Le)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof rn)) throw new Error("must be contained within AST_Scope");
        }
    }, Ie);
    function Ve(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var We = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Ve(n, e);
            });
        },
        _validate: function() {
            this.body.forEach(function(e) {
                if (!(e instanceof Ie)) throw new Error("body must be AST_Statement[]");
                if (e instanceof fn) throw new Error("body cannot contain AST_Function");
            });
        }
    }, Le);
    var Je = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, We);
    var k = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (!(this.body instanceof Ie)) throw new Error("body must be AST_Statement");
            if (this.body instanceof fn) throw new Error("body cannot be AST_Function");
        }
    }, Le);
    var Ge = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new wt(function(e) {
                    if (e instanceof hn) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof rn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof se)) throw new Error("label must be AST_Label");
        }
    }, k);
    var Xe = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, k);
    var Ke = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            a(this, "condition");
        }
    }, Xe);
    var Qe = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, Ke);
    var Ze = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, Ke);
    var en = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof He)) throw new Error("init must be AST_Node");
                if (this.init instanceof Ie && !(this.init instanceof Sn || this.init instanceof fn)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) a(this, "condition");
            if (this.step != null) a(this, "step");
        }
    }, Xe);
    var nn = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init instanceof Sn) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                f(this.init, function(e) {
                    if (!(e instanceof Mn || e instanceof st)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            a(this, "object");
        }
    }, Xe);
    var tn = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            a(this, "expression");
        }
    }, k);
    var rn = i("Scope", "uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: De
    }, We);
    var on = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name -> SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return St([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Tt(function(e) {
                if (e instanceof Ue && e.value == "$ORIG") {
                    return ze.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return St([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Tt(function(e) {
                if (e instanceof Ue && e.value == "$ORIG") {
                    return ze.splice(t);
                }
            }));
        }
    }, rn);
    var an = i("Lambda", "name argnames length_read uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            name: "[AST_SymbolDeclaration?] the name of this function",
            argnames: "[(AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new wt(function(e) {
                if (e instanceof Ln) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof it) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                Ve(e, n);
            });
        },
        _validate: function() {
            this.argnames.forEach(function(e) {
                f(e, function(e) {
                    if (!(e instanceof it)) throw new Error("argnames must be AST_SymbolFunarg[]");
                });
            });
        }
    }, rn);
    var sn = i("Accessor", null, {
        $documentation: "A setter/getter function.  The `name` property is always null.",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, an);
    var fn = i("Function", "inlined", {
        $documentation: "A function expression",
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof ot)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, an);
    var un = i("Defun", "inlined", {
        $documentation: "A function definition",
        _validate: function() {
            if (!(this.name instanceof rt)) throw new Error("name must be AST_SymbolDefun");
        }
    }, an);
    var cn = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, Ie);
    var ln = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        }
    }, cn);
    var pn = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) a(this, "value");
        }
    }, ln);
    var dn = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            a(this, "value");
        }
    }, ln);
    var hn = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.label != null) {
                if (!(this.label instanceof fe)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, cn);
    var vn = i("Break", null, {
        $documentation: "A `break` statement"
    }, hn);
    var _n = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, hn);
    var mn = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            a(this, "condition");
            if (this.alternative != null) {
                if (!(this.alternative instanceof Ie)) throw new Error("alternative must be AST_Statement");
                if (this.alternative instanceof fn) throw new error("alternative cannot be AST_Function");
            }
        }
    }, k);
    var gn = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Ve(n, e);
            });
        },
        _validate: function() {
            a(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof bn)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, We);
    var bn = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, We);
    var yn = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, bn);
    var wn = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                Ve(n, e);
            });
        },
        _validate: function() {
            a(this, "expression");
        }
    }, bn);
    var xn = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                Ve(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof kn)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof En)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, We);
    var kn = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[AST_SymbolCatch?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                Ve(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) {
                if (!(this.argname instanceof at)) throw new Error("argname must be AST_SymbolCatch");
            }
        }
    }, We);
    var En = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, We);
    var Sn = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, Ie);
    var Tn = i("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof An)) throw new Error("definitions must be AST_VarDef[]");
                f(e.name, function(e) {
                    if (!(e instanceof et)) throw new Error("name must be AST_SymbolConst");
                });
                if (e.value != null) a(e, "value");
            });
        }
    }, Sn);
    var On = i("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof An)) throw new Error("definitions must be AST_VarDef[]");
                f(e.name, function(e) {
                    if (!(e instanceof nt)) throw new Error("name must be AST_SymbolLet");
                });
                if (e.value != null) a(e, "value");
            });
        }
    }, Sn);
    var Dn = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof An)) throw new Error("definitions must be AST_VarDef[]");
                f(e.name, function(e) {
                    if (!(e instanceof tt)) throw new Error("name must be AST_SymbolVar");
                });
                if (e.value != null) a(e, "value");
            });
        }
    }, Sn);
    var An = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        }
    });
    function s(e, n) {
        e[n].forEach(function(e) {
            if (!(e instanceof He)) throw new Error(n + " must be AST_Node[]");
            if (e instanceof Ie && !(e instanceof fn)) {
                throw new Error(n + " cannot contain AST_Statement");
            }
        });
    }
    var zn = i("Call", "expression args pure", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            a(this, "expression");
            s(this, "args");
        }
    });
    var $n = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, zn);
    var jn = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            s(this, "expressions");
        }
    });
    var Mn = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof ut) {
                return e.value;
            }
            if (e instanceof Nn && e.operator == "void" && e.expression instanceof ut) {
                return;
            }
            return e;
        },
        _validate: function() {
            a(this, "expression");
        }
    });
    var qn = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Mn);
    var Fn = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            a(this, "property");
        }
    }, Mn);
    var Cn = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.operator != "string") throw new Error("operator must be string");
            a(this, "expression");
        }
    });
    var Nn = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, Cn);
    var Pn = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, Cn);
    var Hn = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            a(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            a(this, "right");
        }
    });
    var In = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            a(this, "condition");
            a(this, "consequent");
            a(this, "alternative");
        }
    });
    var Rn = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof Bn) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                f(this.left, function(e) {
                    if (!(e instanceof Mn || e instanceof st)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            }
        }
    }, Hn);
    var Un = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "elements");
        }
    });
    var Bn = i("Destructured", null, {
        $documentation: "Base class for destructured literal"
    });
    function f(e, n) {
        if (e instanceof Yn) return e.elements.forEach(function(e) {
            if (!(e instanceof _t)) f(e, n);
        });
        if (e instanceof Vn) return e.properties.forEach(function(e) {
            f(e.value, n);
        });
        n(e);
    }
    var Yn = i("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        }
    }, Bn);
    var Ln = i("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof He) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof He)) throw new Error("key must be string or AST_Node");
                a(this, "key");
            }
            a(this, "value");
        }
    });
    var Vn = i("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Ln)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, Bn);
    var Wn = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[AST_ObjectProperty*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Jn)) throw new Error("properties must be AST_ObjectProperty[]");
            });
        }
    });
    var Jn = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof He) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof He)) throw new Error("key must be string or AST_Node");
                a(this, "key");
            }
            if (!(this.value instanceof He)) throw new Error("value must be AST_Node");
        }
    });
    var Gn = i("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            a(this, "value");
        }
    }, Jn);
    var Xn = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof sn)) throw new Error("value must be AST_Accessor");
        }
    }, Jn);
    var Kn = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof sn)) throw new Error("value must be AST_Accessor");
        }
    }, Jn);
    var Qn = i("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var Zn = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Qn);
    var et = i("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, Zn);
    var nt = i("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, Zn);
    var tt = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, Zn);
    var it = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, tt);
    var rt = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, Zn);
    var ot = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, Zn);
    var at = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, Zn);
    var se = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Qn);
    var st = i("SymbolRef", "fixed", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Qn);
    var fe = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Qn);
    var ft = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.name !== "this") throw new Error('name must be "this"');
        }
    }, Qn);
    var ut = i("Constant", null, {
        $documentation: "Base class for all constants"
    });
    var ct = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, ut);
    var lt = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
        }
    }, ut);
    var pt = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, ut);
    var v = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, ut);
    var dt = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, v);
    var ht = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, v);
    var vt = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, v);
    var _t = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, v);
    var mt = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, v);
    var gt = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, v);
    var bt = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, gt);
    var yt = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, gt);
    function wt(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    wt.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Se);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof an) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof Ue && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof an) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof rn) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof Ue)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Ge && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof Xe || e instanceof vn && i instanceof gn) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof In && t.condition === e || t instanceof Ke && t.condition === e || t instanceof en && t.condition === e || t instanceof mn && t.condition === e || t instanceof pn && t.in_bool || t instanceof jn && t.tail_node() !== e || t instanceof Ye || t instanceof Nn && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof Hn && (t.operator == "&&" || t.operator == "||") || t instanceof In || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof pn) {
                    var i;
                    do {
                        i = this.parent(++n);
                        if (!i) return false;
                    } while (!(i instanceof an));
                    if (i.name) return false;
                    e = this.parent(++n);
                    if (!e || e.TYPE != "Call" || e.expression !== i) return false;
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var ue = "break case catch const continue debugger default delete do else finally for function if in instanceof let new return switch throw try typeof var void while with";
    var j = "false null true";
    var E = [ "abstract boolean byte char class double enum export extends final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", j, ue ].join(" ");
    var M = "return new delete throw else case";
    ue = qe(ue);
    E = qe(E);
    M = qe(M);
    j = qe(j);
    var u = /^0b([01]+)$/i;
    var c = /^0x([0-9a-f]+)$/i;
    var l = /^0o?([0-7]+)$/i;
    var q = qe([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var F = "\n\r\u2028\u2029";
    var C = "+-*&%=<>!?|~^";
    var N = "[{(,;:";
    var P = N + ")}]";
    var H = F + "  \t\f\v​             　\ufeff";
    var I = qe(e("./'\"" + C + P + H));
    F = qe(e(F));
    C = qe(e(C));
    N = qe(e(N));
    P = qe(e(P));
    H = qe(e(H));
    function Z(e) {
        return e >= 55296 && e <= 56319;
    }
    function ee(e) {
        return e >= 56320 && e <= 57343;
    }
    function R(e) {
        return e >= 48 && e <= 57;
    }
    function ne(e) {
        return !I[e];
    }
    function xt(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function U(e) {
        var n;
        if (n = u.exec(e)) return parseInt(n[1], 2);
        if (n = c.exec(e)) return parseInt(n[1], 16);
        if (n = l.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function kt(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    kt.prototype = Object.create(Error.prototype);
    kt.prototype.constructor = kt;
    kt.prototype.name = "SyntaxError";
    n(kt);
    function le(e, n, t, i, r) {
        throw new kt(e, n, t, i, r);
    }
    function pe(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var B = {};
    function de(r, o, a, s) {
        var f = {
            text: r,
            filename: o,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: []
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw B;
            if (F[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function h() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (F[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw B;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function _(e, n, t) {
            f.regex_allowed = e == "operator" && !ve[n] || e == "keyword" && M[n] || e == "punc" && N[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: o
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Q(i);
        }
        function m() {
            while (H[c()]) l();
        }
        function t(e) {
            var n = "", t, i = 0;
            while ((t = c()) && e(t, i++)) n += l();
            return n;
        }
        function g(e) {
            le(e, o, f.tokline, f.tokcol, f.tokpos);
        }
        function b(i) {
            var r = false, o = false, a = false, s = i == ".";
            var e = t(function(e, n) {
                var t = e.charCodeAt(0);
                switch (t) {
                  case 120:
                  case 88:
                    return a ? false : a = true;

                  case 101:
                  case 69:
                    return a ? true : r ? false : r = o = true;

                  case 45:
                    return o || n == 0 && !i;

                  case 43:
                    return o;

                  case o = false, 46:
                    return !s && !a && !r ? s = true : false;
                }
                return R(t) || /[_0-9a-fo]/i.test(e);
            });
            if (i) e = i + e;
            if (/^0[0-7_]+$/.test(e)) {
                if ($.has_directive("use strict")) g("Legacy octal literals are not allowed in strict mode");
            } else {
                e = e.replace(a ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var n = U(e);
            if (!isNaN(n)) return _("num", n);
            g("Invalid syntax: " + e);
        }
        function y(e) {
            var n = l(true, e);
            switch (n.charCodeAt(0)) {
              case 110:
                return "\n";

              case 114:
                return "\r";

              case 116:
                return "\t";

              case 98:
                return "\b";

              case 118:
                return "\v";

              case 102:
                return "\f";

              case 120:
                return String.fromCharCode(x(2));

              case 117:
                if (c() != "{") return String.fromCharCode(x(4));
                l();
                var t = 0;
                do {
                    var i = parseInt(l(true), 16);
                    if (isNaN(i)) g("Invalid hex-character pattern in string");
                    t = t * 16 + i;
                } while (c() != "}");
                l();
                if (t < 65536) return String.fromCharCode(t);
                if (t > 1114111) g("Invalid character code: " + t);
                return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

              case 13:
                if (c() == "\n") l(true, e);

              case 10:
                return "";
            }
            if (n >= "0" && n <= "7") return w(n);
            return n;
        }
        function w(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && $.has_directive("use strict")) g("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        function x(e) {
            var n = 0;
            for (;e > 0; --e) {
                var t = parseInt(l(true), 16);
                if (isNaN(t)) g("Invalid hex-character pattern in string");
                n = n << 4 | t;
            }
            return n;
        }
        var k = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = y(true); else if (F[i]) g("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = _("string", t);
            r.quote = e;
            return r;
        });
        function E(e) {
            var n = f.regex_allowed;
            var t = h(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(_(e, i, true));
            f.regex_allowed = n;
            return $;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(_("comment2", t, true));
            f.regex_allowed = e;
            return $;
        });
        function S() {
            var e = false, n = "", t, i = false, r;
            while (t = c()) {
                if (!e) {
                    if (t == "\\") i = e = true, l(); else if (ne(t)) n += l(); else break;
                } else {
                    if (t != "u") g("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = y();
                    if (!ne(t)) g("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (ue[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var T = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (F[t]) {
                g("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = S();
            try {
                var o = new RegExp(e, r);
                o.raw_source = e;
                return _("regexp", o);
            } catch (e) {
                g(e.message);
            }
        });
        function O(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (q[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return _("operator", t(e || l()));
        }
        function D() {
            l();
            switch (c()) {
              case "/":
                l();
                return E("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? T("") : O("/");
        }
        function A() {
            l();
            return R(c().charCodeAt(0)) ? b(".") : _("punc", ".");
        }
        function z() {
            var e = S();
            if (u) return _("name", e);
            return j[e] ? _("atom", e) : !ue[e] ? _("name", e) : q[e] ? _("operator", e) : _("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === B) g(n); else throw e;
                }
            };
        }
        function $(e) {
            if (e != null) return T(e);
            if (s && f.pos == 0 && d("#!")) {
                v();
                p(2);
                E("comment5");
            }
            for (;;) {
                m();
                v();
                if (a) {
                    if (d("\x3c!--")) {
                        p(4);
                        E("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return _("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return k(n);

                  case 46:
                    return A();

                  case 47:
                    var i = D();
                    if (i === $) continue;
                    return i;
                }
                if (R(t)) return b();
                if (P[n]) return _("punc", l());
                if (C[n]) return O();
                if (t == 92 || !I[n]) return z();
                break;
            }
            g("Unexpected character '" + n + "'");
        }
        $.context = function(e) {
            if (e) f = e;
            return f;
        };
        $.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        $.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        $.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        $.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return $;
    }
    var he = qe("typeof void delete -- ++ ! ~ - +");
    var ve = qe("-- ++");
    var _e = qe("= += -= /= *= %= >>= <<= >>>= |= ^= &=");
    var Et = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ] ], {});
    var me = qe("atom num string regexp name");
    function St(e, a) {
        a = ae(a, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var f = {
            input: typeof e == "string" ? de(e, a.filename, a.html5_comments, a.shebang) : e,
            token: null,
            prev: null,
            peeked: null,
            in_function: 0,
            in_directives: true,
            in_loop: 0,
            labels: []
        };
        f.token = c();
        function u(e, n) {
            return pe(f.token, e, n);
        }
        function o() {
            return f.peeked || (f.peeked = f.input());
        }
        function c() {
            f.prev = f.token;
            if (f.peeked) {
                f.token = f.peeked;
                f.peeked = null;
            } else {
                f.token = f.input();
            }
            f.in_directives = f.in_directives && (f.token.type == "string" || u("punc", ";"));
            return f.token;
        }
        function l() {
            return f.prev;
        }
        function s(e, n, t, i) {
            var r = f.input.context();
            le(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function t(e, n) {
            s(n, e.line, e.col);
        }
        function i(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function p(e) {
            if (e == null) e = f.token;
            t(e, "Unexpected token: " + i(e.type, e.value));
        }
        function d(e, n) {
            if (u(e, n)) return c();
            t(f.token, "Unexpected token: " + i(f.token.type, f.token.value) + ", expected: " + i(e, n));
        }
        function h(e) {
            return d("punc", e);
        }
        function v(e) {
            return e.nlb || !Fe(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function _() {
            return !a.strict && (u("eof") || u("punc", "}") || v(f.token));
        }
        function m(e) {
            if (u("punc", ";")) c(); else if (!e && !_()) d("punc", ";");
        }
        function g() {
            h("(");
            var e = re(true);
            h(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = f.token;
                var n = i.apply(null, arguments);
                var t = l();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function b() {
            if (u("operator", "/") || u("operator", "/=")) {
                f.peeked = null;
                f.token = f.input(f.token.value.substr(1));
            }
        }
        var y = n(function() {
            b();
            switch (f.token.type) {
              case "string":
                var e = f.in_directives;
                var n = re(true);
                if (e) {
                    if (n instanceof ct) {
                        var t = n.start.raw.slice(1, -1);
                        f.input.add_directive(t);
                        n.value = t;
                    } else {
                        f.in_directives = e = false;
                    }
                }
                m();
                return e ? new Ue(n) : new Ye({
                    body: n
                });

              case "num":
              case "regexp":
              case "operator":
              case "atom":
                return x();

              case "name":
                return pe(o(), "punc", ":") ? w() : x();

              case "punc":
                switch (f.token.value) {
                  case "{":
                    return new Je({
                        start: f.token,
                        body: D(),
                        end: l()
                    });

                  case "[":
                  case "(":
                    return x();

                  case ";":
                    f.in_directives = false;
                    c();
                    return new Be();

                  default:
                    p();
                }

              case "keyword":
                switch (f.token.value) {
                  case "break":
                    c();
                    return k(vn);

                  case "const":
                    c();
                    var i = j();
                    m();
                    return i;

                  case "continue":
                    c();
                    return k(_n);

                  case "debugger":
                    c();
                    m();
                    return new Re();

                  case "do":
                    c();
                    var n = oe(y);
                    d("keyword", "while");
                    var r = g();
                    m(true);
                    return new Qe({
                        body: n,
                        condition: r
                    });

                  case "while":
                    c();
                    return new Ze({
                        condition: g(),
                        body: oe(y)
                    });

                  case "for":
                    c();
                    return E();

                  case "function":
                    c();
                    return T(un);

                  case "if":
                    c();
                    return O();

                  case "let":
                    c();
                    var i = M();
                    m();
                    return i;

                  case "return":
                    if (f.in_function == 0 && !a.bare_returns) s("'return' outside of function");
                    c();
                    var t = null;
                    if (u("punc", ";")) {
                        c();
                    } else if (!_()) {
                        t = re(true);
                        m();
                    }
                    return new pn({
                        value: t
                    });

                  case "switch":
                    c();
                    return new gn({
                        expression: g(),
                        body: oe(A)
                    });

                  case "throw":
                    c();
                    if (v(f.token)) s("Illegal newline after 'throw'");
                    var t = re(true);
                    m();
                    return new dn({
                        value: t
                    });

                  case "try":
                    c();
                    return z();

                  case "var":
                    c();
                    var i = q();
                    m();
                    return i;

                  case "with":
                    if (f.input.has_directive("use strict")) {
                        s("Strict mode may not include a with statement");
                    }
                    c();
                    return new tn({
                        expression: g(),
                        body: y()
                    });
                }
            }
            p();
        });
        function w() {
            var n = V(se);
            if (!Fe(f.labels, function(e) {
                return e.name != n.name;
            })) {
                s("Label " + n.name + " defined twice");
            }
            h(":");
            f.labels.push(n);
            var e = y();
            f.labels.pop();
            if (!(e instanceof Xe)) {
                n.references.forEach(function(e) {
                    if (e instanceof _n) {
                        e = e.label.start;
                        s("Continue label `" + n.name + "` refers to non-IterationStatement.", e.line, e.col, e.pos);
                    }
                });
            }
            return new Ge({
                body: e,
                label: n
            });
        }
        function x() {
            var e = re(true);
            m();
            return new Ye({
                body: e
            });
        }
        function k(e) {
            var n = null, t;
            if (!_()) {
                n = V(fe, true);
            }
            if (n != null) {
                t = ce(function(e) {
                    return e.name == n.name;
                }, f.labels);
                if (!t) s("Undefined label " + n.name);
                n.thedef = t;
            } else if (f.in_loop == 0) s(e.TYPE + " not inside a loop or switch");
            m();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function E() {
            h("(");
            var e = null;
            if (!u("punc", ";")) {
                e = u("keyword", "const") ? (c(), j(true)) : u("keyword", "let") ? (c(), M(true)) : u("keyword", "var") ? (c(), 
                q(true)) : re(true, true);
                if (u("operator", "in")) {
                    if (e instanceof Sn) {
                        if (e.definitions.length > 1) s("Only one variable declaration allowed in for..in loop", e.start.line, e.start.col, e.start.pos);
                    } else if (!(ne(e) || (e = te(e)) instanceof Bn)) {
                        s("Invalid left-hand side in for..in loop", e.start.line, e.start.col, e.start.pos);
                    }
                    c();
                    return S(e);
                }
            }
            return r(e);
        }
        function r(e) {
            h(";");
            var n = u("punc", ";") ? null : re(true);
            h(";");
            var t = u("punc", ")") ? null : re(true);
            h(")");
            return new en({
                init: e,
                condition: n,
                step: t,
                body: oe(y)
            });
        }
        function S(e) {
            var n = re(true);
            h(")");
            return new nn({
                init: e,
                object: n,
                body: oe(y)
            });
        }
        var T = function(e) {
            var n = e === un;
            var t = u("name") ? V(n ? rt : ot) : null;
            if (n && !t) d("name");
            if (t && e !== sn && !(t instanceof Zn)) p(l());
            h("(");
            var i = [];
            for (var r = true; !u("punc", ")"); ) {
                if (r) r = false; else h(",");
                i.push(W(it));
            }
            c();
            var o = f.in_loop;
            var a = f.labels;
            ++f.in_function;
            f.in_directives = true;
            f.input.push_directives_stack();
            f.in_loop = 0;
            f.labels = [];
            var s = D();
            if (f.input.has_directive("use strict")) {
                if (t) L(t);
                i.forEach(L);
            }
            f.input.pop_directives_stack();
            --f.in_function;
            f.in_loop = o;
            f.labels = a;
            return new e({
                name: t,
                argnames: i,
                body: s
            });
        };
        function O() {
            var e = g(), n = y(), t = null;
            if (u("keyword", "else")) {
                c();
                t = y();
            }
            return new mn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function D() {
            h("{");
            var e = [];
            while (!u("punc", "}")) {
                if (u("eof")) d("punc", "}");
                e.push(y());
            }
            c();
            return e;
        }
        function A() {
            h("{");
            var e = [], n, t, i, r;
            while (!u("punc", "}")) {
                if (u("eof")) d("punc", "}");
                if (u("keyword", "case")) {
                    if (n) n.end = l();
                    t = [];
                    n = new wn({
                        start: (r = f.token, c(), r),
                        expression: re(true),
                        body: t
                    });
                    e.push(n);
                    h(":");
                } else if (u("keyword", "default")) {
                    if (n) n.end = l();
                    if (i) s("More than one default clause in switch statement");
                    t = [];
                    n = new yn({
                        start: (r = f.token, c(), h(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) p();
                    t.push(y());
                }
            }
            if (n) n.end = l();
            c();
            return e;
        }
        function z() {
            var e = D(), n = null, t = null;
            if (u("keyword", "catch")) {
                var i = f.token;
                c();
                var r = null;
                if (u("punc", "(")) {
                    c();
                    r = V(at);
                    h(")");
                }
                n = new kn({
                    start: i,
                    argname: r,
                    body: D(),
                    end: l()
                });
            }
            if (u("keyword", "finally")) {
                var i = f.token;
                c();
                t = new En({
                    start: i,
                    body: D(),
                    end: l()
                });
            }
            if (!n && !t) s("Missing catch/finally blocks");
            return new xn({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function $(e, n) {
            var t = [];
            for (;;) {
                var i = f.token;
                var r = W(e);
                var o = null;
                if (u("operator", "=")) {
                    c();
                    o = re(false, n);
                } else if (!n && (e === et || r instanceof Bn)) {
                    s("Missing initializer in declaration");
                }
                t.push(new An({
                    start: i,
                    name: r,
                    value: o,
                    end: l()
                }));
                if (!u("punc", ",")) break;
                c();
            }
            return t;
        }
        var j = function(e) {
            return new Tn({
                start: l(),
                definitions: $(et, e),
                end: l()
            });
        };
        var M = function(e) {
            return new On({
                start: l(),
                definitions: $(nt, e),
                end: l()
            });
        };
        var q = function(e) {
            return new Dn({
                start: l(),
                definitions: $(tt, e),
                end: l()
            });
        };
        var F = function(e) {
            var n = f.token;
            d("operator", "new");
            var t = N(false), i;
            if (u("punc", "(")) {
                c();
                i = P(")");
            } else {
                i = [];
            }
            var r = new $n({
                start: n,
                expression: t,
                args: i,
                end: l()
            });
            J(r);
            return G(r, e);
        };
        function C() {
            var e = f.token, n;
            switch (e.type) {
              case "name":
                n = Y(st, e);
                break;

              case "num":
                n = new lt({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new ct({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new pt({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new bt({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new yt({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new dt({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            c();
            return n;
        }
        var N = function(e) {
            if (u("operator", "new")) {
                return F(e);
            }
            var n = f.token;
            if (u("punc")) {
                switch (n.value) {
                  case "(":
                    c();
                    var t = re(true);
                    var i = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = i;
                    if (i == 0 && n.comments_before.length > 0) {
                        var r = n.comments_before[0];
                        if (!r.nlb) {
                            r.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    h(")");
                    var o = l();
                    o.comments_before = t.end.comments_before;
                    [].push.apply(t.end.comments_after, o.comments_after);
                    o.comments_after.length = 0;
                    o.comments_after = t.end.comments_after;
                    t.end = o;
                    if (t instanceof zn) J(t);
                    return G(t, e);

                  case "[":
                    return G(H(), e);

                  case "{":
                    return G(R(), e);
                }
                p();
            }
            if (u("keyword", "function")) {
                c();
                var a = T(fn);
                a.start = n;
                a.end = l();
                return G(a, e);
            }
            if (me[f.token.type]) {
                return G(C(), e);
            }
            p();
        };
        function P(e, n, t, i) {
            if (!i) i = re;
            var r = true, o = [];
            while (!u("punc", e)) {
                if (r) r = false; else h(",");
                if (n && u("punc", e)) break;
                if (u("punc", ",") && t) {
                    o.push(new _t({
                        start: f.token,
                        end: f.token
                    }));
                } else {
                    o.push(i());
                }
            }
            c();
            return o;
        }
        var H = n(function() {
            h("[");
            return new Un({
                elements: P("]", !a.strict, true)
            });
        });
        var I = n(function() {
            return T(sn);
        });
        var R = n(function() {
            h("{");
            var e = true, n = [];
            while (!u("punc", "}")) {
                if (e) e = false; else h(",");
                if (!a.strict && u("punc", "}")) break;
                var t = f.token;
                var i = U();
                if (u("punc", "(")) {
                    var r = f.token;
                    var o = T(fn);
                    o.start = r;
                    o.end = l();
                    n.push(new Gn({
                        start: t,
                        key: i,
                        value: o,
                        end: l()
                    }));
                    continue;
                }
                if (!u("punc", ":") && t.type == "name") switch (i) {
                  case "get":
                    n.push(new Kn({
                        start: t,
                        key: U(),
                        value: I(),
                        end: l()
                    }));
                    continue;

                  case "set":
                    n.push(new Xn({
                        start: t,
                        key: U(),
                        value: I(),
                        end: l()
                    }));
                    continue;

                  default:
                    n.push(new Gn({
                        start: t,
                        key: i,
                        value: Y(st, t),
                        end: l()
                    }));
                    continue;
                }
                h(":");
                n.push(new Gn({
                    start: t,
                    key: i,
                    value: re(false),
                    end: l()
                }));
            }
            c();
            return new Wn({
                properties: n
            });
        });
        function U() {
            var e = f.token;
            switch (e.type) {
              case "operator":
                if (!ue[e.value]) p();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                c();
                return "" + e.value;

              case "punc":
                if (e.value != "[") p();
                c();
                var n = re(false);
                h("]");
                return n;

              default:
                p();
            }
        }
        function B() {
            if (!u("name")) d("name");
            var e = f.token.value;
            c();
            return e;
        }
        function Y(e, n) {
            var t = n.value;
            return new (t === "this" ? ft : e)({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function L(e) {
            if (e.name == "arguments" || e.name == "eval") s("Unexpected " + e.name + " in strict mode", e.start.line, e.start.col, e.start.pos);
        }
        function V(e, n) {
            if (!u("name")) {
                if (!n) s("Name expected");
                return null;
            }
            var t = Y(e, f.token);
            if (f.input.has_directive("use strict") && t instanceof Zn) {
                L(t);
            }
            c();
            return t;
        }
        function W(e) {
            var n = f.token;
            if (u("punc", "[")) {
                c();
                return new Yn({
                    start: n,
                    elements: P("]", !a.strict, true, function() {
                        return W(e);
                    }),
                    end: l()
                });
            }
            if (u("punc", "{")) {
                c();
                var t = true, i = [];
                while (!u("punc", "}")) {
                    if (t) t = false; else h(",");
                    if (!a.strict && u("punc", "}")) break;
                    var r = f.token;
                    var o = U();
                    if (!u("punc", ":") && r.type == "name") {
                        i.push(new Ln({
                            start: r,
                            key: o,
                            value: Y(e, r),
                            end: l()
                        }));
                        continue;
                    }
                    h(":");
                    i.push(new Ln({
                        start: r,
                        key: o,
                        value: W(e),
                        end: l()
                    }));
                }
                c();
                return new Vn({
                    start: n,
                    properties: i,
                    end: l()
                });
            }
            return V(e);
        }
        function J(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = Ne(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        var G = function(e, n) {
            var t = e.start;
            if (u("punc", ".")) {
                c();
                return G(new qn({
                    start: t,
                    expression: e,
                    property: B(),
                    end: l()
                }), n);
            }
            if (u("punc", "[")) {
                c();
                var i = re(true);
                h("]");
                return G(new Fn({
                    start: t,
                    expression: e,
                    property: i,
                    end: l()
                }), n);
            }
            if (n && u("punc", "(")) {
                c();
                var r = new zn({
                    start: t,
                    expression: e,
                    args: P(")"),
                    end: l()
                });
                J(r);
                return G(r, true);
            }
            return e;
        };
        var X = function(e) {
            var n = f.token;
            if (u("operator") && he[n.value]) {
                c();
                b();
                var t = K(Nn, n, X(e));
                t.start = n;
                t.end = l();
                return t;
            }
            var i = N(e);
            while (u("operator") && ve[f.token.value] && !v(f.token)) {
                i = K(Pn, f.token, i);
                i.start = n;
                i.end = f.token;
                c();
            }
            return i;
        };
        function K(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!ne(t)) s("Invalid use of " + i + " operator", n.line, n.col, n.pos);
                break;

              case "delete":
                if (t instanceof st && f.input.has_directive("use strict")) s("Calling delete on expression not allowed in strict mode", t.start.line, t.start.col, t.start.pos);
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        var Q = function(e, n, t) {
            var i = u("operator") ? f.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Et[i] : null;
            if (r != null && r > n) {
                c();
                var o = Q(X(true), r, t);
                return Q(new Hn({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: o,
                    end: o.end
                }), n, t);
            }
            return e;
        };
        function Z(e) {
            return Q(X(true), 0, e);
        }
        var ee = function(e) {
            var n = f.token;
            var t = Z(e);
            if (u("operator", "?")) {
                c();
                var i = re(false);
                h(":");
                return new In({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: re(false, e),
                    end: l()
                });
            }
            return t;
        };
        function ne(e) {
            return e instanceof Mn || e instanceof st;
        }
        function te(e) {
            if (e instanceof Un) {
                var n = e.elements.map(te);
                return Fe(n, function(e) {
                    return e instanceof Bn || e instanceof _t || ne(e);
                }) ? new Yn({
                    start: e.start,
                    elements: n,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof Wn)) return e;
            var t = [];
            for (var i = 0; i < e.properties.length; i++) {
                var r = e.properties[i];
                if (!(r instanceof Gn)) return e;
                var o = te(r.value);
                if (!(o instanceof Bn || ne(o))) return e;
                t.push(new Ln({
                    start: r.start,
                    key: r.key,
                    value: o,
                    end: r.end
                }));
            }
            return new Vn({
                start: e.start,
                properties: t,
                end: e.end
            });
        }
        var ie = function(e) {
            var n = f.token;
            var t = ee(e), i = f.token.value;
            if (u("operator") && _e[i]) {
                if (ne(t) || i == "=" && (t = te(t)) instanceof Bn) {
                    c();
                    return new Rn({
                        start: n,
                        left: t,
                        operator: i,
                        right: ie(e),
                        end: l()
                    });
                }
                s("Invalid assignment");
            }
            return t;
        };
        var re = function(e, n) {
            var t = f.token;
            var i = [];
            while (true) {
                i.push(ie(n));
                if (!e || !u("punc", ",")) break;
                c();
                e = true;
            }
            return i.length == 1 ? i[0] : new jn({
                start: t,
                expressions: i,
                end: o()
            });
        };
        function oe(e) {
            ++f.in_loop;
            var n = e();
            --f.in_loop;
            return n;
        }
        if (a.expression) {
            b();
            return re(true);
        }
        return function() {
            var e = f.token;
            var n = [];
            f.input.push_directives_stack();
            while (!u("eof")) n.push(y());
            f.input.pop_directives_stack();
            var t = l();
            var i = a.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new on({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Tt(e, n) {
        wt.call(this);
        this.before = e;
        this.after = n;
    }
    Tt.prototype = new wt();
    (function(e) {
        function t(e, n) {
            return ze(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(He, Se);
        e(Ge, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(Ye, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(We, function(e, n) {
            e.body = t(e.body, n);
        });
        e(Qe, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(Ze, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(en, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(nn, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(tn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(ln, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(hn, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(mn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(gn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(wn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(xn, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(kn, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(Sn, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(An, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(an, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            e.body = t(e.body, n);
        });
        e(zn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(jn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(qn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Fn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Cn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Hn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(In, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Un, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(Yn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(Ln, function(e, n) {
            if (e.key instanceof He) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(Vn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Wn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(Jn, function(e, n) {
            if (e.key instanceof He) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function d(e, n, t, i) {
        this.eliminated = 0;
        this.global = false;
        this.id = e;
        this.init = i;
        this.lambda = t instanceof ot;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    d.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = g(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this.defun;
            if (!e) return;
            var n = this.name;
            var t = e.variables.get(n) || e instanceof on && e.globals.get(n) || this.orig[0] instanceof et && ce(function(e) {
                return e.name == n;
            }, e.enclosed);
            if (t && t !== this) return t.redefined() || t;
        },
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof ot || this.orig[0] instanceof rt);
        }
    };
    on.DEFMETHOD("figure_out_scope", function(u) {
        u = ae(u, {
            cache: null,
            ie8: false
        });
        var c = this;
        var a = null;
        var t = 0;
        var s = c.parent_scope = null;
        var l = new wt(function(i, e) {
            if (i instanceof un) {
                i.name.walk(l);
                r(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(l);
                    });
                    Ve(i, l);
                });
                return true;
            }
            if (i instanceof bn) {
                i.init_vars(s);
                e();
                return true;
            }
            if (i instanceof xn) {
                r(function() {
                    Ve(i, l);
                });
                if (i.bcatch) i.bcatch.walk(l);
                if (i.bfinally) i.bfinally.walk(l);
                return true;
            }
            if (i instanceof tn) {
                var n = s;
                do {
                    n = n.resolve();
                    if (n.uses_with) break;
                    n.uses_with = true;
                } while (n = n.parent_scope);
                r(e);
                return true;
            }
            if (i instanceof Le) {
                r(e);
                return true;
            }
            if (i instanceof Qn) {
                i.scope = s;
            }
            if (i instanceof se) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof at) {
                s.def_variable(i).defun = a;
            } else if (i instanceof et) {
                s.def_variable(i).defun = a;
            } else if (i instanceof rt) {
                a.def_function(i, l.parent());
                o(a, s);
            } else if (i instanceof it) {
                a.def_variable(i);
                o(a, s);
            } else if (i instanceof ot) {
                var t = a.def_function(i, i.name == "arguments" ? undefined : a);
                if (u.ie8) t.defun = a.parent_scope.resolve();
            } else if (i instanceof nt) {
                s.def_variable(i);
            } else if (i instanceof tt) {
                a.def_variable(i, null);
                o(a, s);
            }
            function r(e) {
                i.init_vars(s);
                var n = a;
                var t = s;
                if (i instanceof rn) a = i;
                s = i;
                e();
                s = t;
                a = n;
            }
            function o(e, n) {
                if (e === n) return;
                i.mark_enclosed(u);
                var t = n.find_variable(i);
                if (i.thedef === t) return;
                i.thedef = t;
                t.orig.push(i);
                i.mark_enclosed(u);
            }
        });
        c.make_def = function(e, n) {
            return new d(++t, this, e, n);
        };
        c.walk(l);
        c.globals = new Ce();
        var p = [];
        var l = new wt(function(e) {
            if (e instanceof an) {
                p.push(e);
                e.argnames.forEach(function(e) {
                    e.walk(l);
                });
                p.pop();
                Ve(e, l);
                return true;
            }
            if (e instanceof hn) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof st) {
                var n = e.name;
                var t = e.scope.find_variable(n);
                for (var i = p.length; i > 0 && t; ) {
                    i = p.lastIndexOf(t.scope, i - 1);
                    if (i < 0) break;
                    var r = t.orig[0];
                    if (r instanceof it || r instanceof ot) {
                        e.in_arg = true;
                        break;
                    }
                    t = t.scope.parent_scope.find_variable(n);
                }
                if (!t) {
                    t = c.def_global(e);
                } else if (n == "arguments" && t.scope instanceof an) {
                    if (!(l.parent() instanceof Mn)) {
                        t.scope.uses_arguments = "d";
                    } else if (!t.scope.uses_arguments) {
                        t.scope.uses_arguments = true;
                    }
                }
                if (n == "eval") {
                    var o = l.parent();
                    if (o.TYPE == "Call" && o.expression === e) {
                        var a = e.scope;
                        do {
                            a = a.resolve();
                            if (a.uses_eval) break;
                            a.uses_eval = true;
                        } while (a = a.parent_scope);
                    } else if (t.undeclared) {
                        c.uses_eval = true;
                    }
                }
                e.thedef = t;
                e.reference(u);
                return true;
            }
            if (e instanceof at) {
                var s = e.definition().redefined();
                if (s) for (var a = e.scope; a; a = a.parent_scope) {
                    $e(a.enclosed, s);
                    if (a === s.scope) break;
                }
                return true;
            }
            if (e instanceof et) {
                var f = e.definition().redefined();
                if (f) f.const_redefs = true;
                return true;
            }
        });
        c.walk(l);
        if (u.ie8) c.walk(new wt(function(e) {
            if (e instanceof at) {
                var n = e.thedef.defun;
                if (n.name instanceof ot && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof ot) {
                var t = e.thedef;
                i(e, e.scope.parent_scope.resolve());
                if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!Fe(i.orig, function(e) {
                return !(e instanceof et || e instanceof nt);
            })) return;
            var r = n.find_variable(t);
            if (r) {
                var o = r.redefined();
                if (o) r = o;
            } else {
                r = c.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = true;
                e.thedef = r;
                e.reference(u);
            });
            if (i.lambda) r.lambda = true;
            if (r.undeclared) c.variables.set(t, r);
        }
    });
    on.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function p(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new Ce();
        e.variables = new Ce();
        if (n) e.make_def = n.make_def;
    }
    function _(e, n) {
        p(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    Le.DEFMETHOD("init_vars", function(e) {
        p(this, e);
    });
    rn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    an.DEFMETHOD("init_vars", function(e) {
        _(this, e);
        this.uses_arguments = false;
        this.def_variable(new it({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    Qn.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            $e(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    $e(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Qn.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Le.DEFMETHOD("find_variable", function(e) {
        if (e instanceof Qn) e = e.name;
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Le.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof un) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Le.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof fn) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function m(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = Object.create(null);
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function g(e, i) {
        var n = e.scope;
        var t = m(n, i);
        var r = n.cname_holes;
        var o = Object.create(null);
        var a = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (a.indexOf(n) < 0) {
                    for (var t in m(n, i)) {
                        o[t] = true;
                    }
                    a.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = y(r[f]);
            if (o[s]) continue;
            r.splice(f, 1);
            t[s] = true;
            return s;
        }
        while (true) {
            s = y(++n.cname);
            if (t[s] || E[s] || i.reserved.has[s]) continue;
            if (!o[s]) break;
            r.push(n.cname);
        }
        t[s] = true;
        return s;
    }
    Qn.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    se.DEFMETHOD("unmangleable", Te);
    Qn.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function b(e) {
        e = ae(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        $e(e.reserved, "arguments");
        e.reserved.has = qe(e.reserved);
        return e;
    }
    on.DEFMETHOD("mangle_names", function(o) {
        o = b(o);
        var a = -1;
        if (o.cache && o.cache.props) {
            var n = m(this, o);
            o.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var s = [];
        var f = new wt(function(n, e) {
            if (n instanceof Ge) {
                var t = a;
                e();
                a = t;
                return true;
            }
            if (n instanceof Le) {
                if (o.webkit && n instanceof Xe && n.init instanceof On) {
                    n.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof nt)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var i = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(i);
                            n.redefined = function() {
                                return i;
                            };
                        });
                    }, true);
                }
                n.to_mangle = [];
                n.variables.each(function(e) {
                    if (!c(e)) n.to_mangle.push(e);
                });
                e();
                if (o.cache && n instanceof on) {
                    n.globals.each(u);
                }
                if (n instanceof un && f.has_directive("use asm")) {
                    var i = new st(n.name);
                    i.scope = n;
                    i.reference(o);
                }
                n.to_mangle.forEach(u);
                return true;
            }
            if (n instanceof se) {
                var r;
                do {
                    r = y(++a);
                } while (E[r]);
                n.mangled_name = r;
                return true;
            }
        });
        this.walk(f);
        s.forEach(u);
        function u(e) {
            if (o.reserved.has[e.name]) return;
            e.mangle(o);
        }
        function c(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof et)) return false;
                var i = n.scope.resolve();
                if (n.scope === i) return false;
                t = i.def_variable(e);
                i.to_mangle.push(t);
            }
            s.push(n);
            n.references.forEach(r);
            if (e instanceof at || e instanceof et) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(o);
                e.thedef = n;
            }
        }
    });
    on.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(E);
        t.reserved.forEach(r);
        this.globals.each(o);
        this.walk(new wt(function(e) {
            if (e instanceof Le) e.variables.each(o);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function o(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    on.DEFMETHOD("expand_names", function(i) {
        y.reset();
        y.sort();
        i = b(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(o);
        this.walk(new wt(function(e) {
            if (e instanceof Le) e.variables.each(o);
        }));
        function r() {
            var e;
            do {
                e = y(t++);
            } while (n[e]);
            return e;
        }
        function o(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    He.DEFMETHOD("tail_node", De);
    jn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    on.DEFMETHOD("compute_char_frequency", function(e) {
        e = b(e);
        y.reset();
        var n = Qn.prototype.add_source_map;
        try {
            Qn.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) y.consider(this.name, -1);
            };
            if (e.properties) {
                qn.prototype.add_source_map = function() {
                    y.consider(this.property, -1);
                };
                Fn.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            y.consider(this.print_to_string(), 1);
        } finally {
            Qn.prototype.add_source_map = n;
            delete qn.prototype.add_source_map;
            delete Fn.prototype.add_source_map;
        }
        y.sort();
        function t(e) {
            if (e instanceof ct) {
                y.consider(e.value, -1);
            } else if (e instanceof In) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof jn) {
                t(e.tail_node());
            }
        }
    });
    var y = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, o;
        function a() {
            o = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                o[e[t]] += n;
            }
        };
        function s(e, n) {
            return o[n] - o[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        f.reset = a;
        a();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function te(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function Ot(f) {
        var e = !f;
        f = ae(f, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = Te;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var t = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, t - 1), f.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = te;
            } else {
                u = Oe;
            }
        }
        var r = f.indent_start;
        var o = 0;
        var a = 1;
        var c = 0;
        var s = "";
        var l = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (Z(r)) {
                    if (ee(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ee(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function o() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (f.quote_style) {
              case 1:
                return n();

              case 2:
                return o();

              case 3:
                return e == "'" ? n() : o();

              default:
                return i > r ? n() : o();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (f.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function d(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        var h = false;
        var v = 0;
        var _ = true;
        var m = false;
        var g = false;
        var b = false;
        var y = false;
        var w = -1;
        var x = "";
        var k, E, S = f.source_map && [];
        var T = S ? function(n, t) {
            S.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Se;
        var O = S ? function() {
            S.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            S = [];
        } : Se;
        function D(e) {
            var n = s.lastIndexOf("\n");
            if (v < n) v = n;
            var t = s.slice(0, v);
            var i = s.slice(v);
            T(e, i.length - o);
            a += e;
            c += e;
            o = i.length;
            s = t;
            while (e--) s += "\n";
            s += i;
        }
        var A = f.max_line_len ? function() {
            if (_) {
                if (o > f.max_line_len) {
                    He.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (o > f.max_line_len) D(1);
            _ = true;
            O();
        } : Se;
        var z = qe("( [ + * / - , .");
        function $(e) {
            e = String(e);
            var n = e.charAt(0);
            if (b && n) {
                b = false;
                if (n != "\n") {
                    $("\n");
                    M();
                }
            }
            if (y && n) {
                y = false;
                if (!/[\s;})]/.test(n)) {
                    j();
                }
            }
            w = -1;
            var t = x.slice(-1);
            if (g) {
                g = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || z[n]) {
                        s += ";";
                        o++;
                        c++;
                    } else {
                        A();
                        s += "\n";
                        c++;
                        a++;
                        o = 0;
                        if (/^\s+$/.test(e)) {
                            g = true;
                        }
                    }
                    if (!f.beautify) m = false;
                }
            }
            if (m) {
                if (ne(t) && (ne(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == x || e == "--" && x == "!" || e == "in" && t == "/" || x == "--" && n == ">") {
                    s += " ";
                    o++;
                    c++;
                }
                if (t != "<" || e != "!") m = false;
            }
            if (k) {
                S.push({
                    token: k,
                    name: E,
                    line: a,
                    col: o
                });
                k = false;
                if (_) O();
            }
            s += e;
            h = e.slice(-1) == "(";
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            a += r;
            o += i[0].length;
            if (r > 0) {
                A();
                o = i[r].length;
            }
            x = e;
        }
        var j = f.beautify ? function() {
            $(" ");
        } : function() {
            m = true;
        };
        var M = f.beautify ? function(e) {
            $(K(" ", e ? r - (f.indent_level >> 1) : r));
        } : Se;
        var q = f.beautify ? function(e, n) {
            if (e === true) e = H();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var F = f.max_line_len || f.preserve_line ? function() {
            A();
            v = s.length;
            _ = false;
        } : Se;
        var C = f.beautify ? function() {
            if (w < 0) return $("\n");
            if (s[w] != "\n") {
                s = s.slice(0, w) + "\n" + s.slice(w);
                c++;
                a++;
            }
            w++;
        } : F;
        var N = f.beautify ? function() {
            $(";");
        } : function() {
            g = true;
        };
        function P() {
            if (g) $(";");
            $(";");
        }
        function H() {
            return r + f.indent_level;
        }
        function I(e) {
            var n;
            $("{");
            C();
            q(H(), function() {
                n = e();
            });
            M();
            $("}");
            return n;
        }
        function R(e) {
            $("(");
            F();
            var n = e();
            F();
            $(")");
            return n;
        }
        function U(e) {
            $("[");
            F();
            var n = e();
            F();
            $("]");
            return n;
        }
        function B() {
            F();
            $(",");
            F();
            j();
        }
        function Y() {
            $(":");
            j();
        }
        var L = S ? function(e, n) {
            k = e;
            E = n;
        } : Se;
        function V() {
            if (!_) A();
            return s;
        }
        function W() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function J(e) {
            var i = this;
            var r = e instanceof ln && e.value;
            var o = s(e);
            if (!o) o = [];
            if (r) {
                var a = new wt(function(e) {
                    var n = a.parent();
                    if (n instanceof ln || n instanceof Hn && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof In && n.condition === e || n instanceof qn && n.expression === e || n instanceof jn && n.expressions[0] === e || n instanceof Fn && n.expression === e || n instanceof Pn) {
                        var t = s(e);
                        if (t) o = o.concat(t);
                    } else {
                        return true;
                    }
                });
                a.push(e);
                e.value.walk(a);
            }
            if (c == 0) {
                if (o.length > 0 && f.shebang && o[0].type == "comment5") {
                    $("#!" + o.shift().value + "\n");
                    M();
                }
                var n = f.preamble;
                if (n) {
                    $(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            o = o.filter(u, e);
            if (o.length == 0) return;
            var t = W();
            o.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        $("\n");
                        M();
                        t = true;
                    } else if (n > 0) {
                        j();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    M();
                    t = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    $("\n");
                    M();
                } else {
                    j();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new Q();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function G(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof Ie || Fe(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var o = s.length;
            r.filter(u, e).forEach(function(e, n) {
                y = false;
                if (b) {
                    $("\n");
                    M();
                    b = false;
                } else if (e.nlb && (n > 0 || !W())) {
                    $("\n");
                    M();
                } else if (n > 0 || !t) {
                    j();
                }
                if (/comment[134]/.test(e.type)) {
                    $("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    b = true;
                } else if (e.type == "comment2") {
                    $("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    y = true;
                }
            });
            if (s.length > o) w = o;
        }
        var X = [];
        return {
            get: V,
            toString: V,
            indent: M,
            should_break: e ? Se : function() {
                return f.width && o - r >= f.width;
            },
            has_parens: function() {
                return h;
            },
            newline: C,
            print: $,
            space: j,
            comma: B,
            colon: Y,
            last: function() {
                return x;
            },
            semicolon: N,
            force_semicolon: P,
            to_utf8: l,
            print_name: function(e) {
                $(d(e));
            },
            print_string: function(e, n) {
                $(p(e, n));
            },
            next_indent: H,
            with_indent: q,
            with_block: I,
            with_parens: R,
            with_square: U,
            add_mapping: L,
            option: function(e) {
                return f[e];
            },
            prepend_comments: e ? Se : J,
            append_comments: e || u === Te ? Se : G,
            line: function() {
                return a;
            },
            col: function() {
                return o;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                X.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = X.pop();
                if (e.start && e.start.line > a) {
                    D(e.start.line - a);
                }
            } : function() {
                X.pop();
            },
            parent: function(e) {
                return X[X.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        He.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        He.DEFMETHOD("print_to_string", function(e) {
            var n = Ot(e);
            this.print(n);
            return n.get();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(He, Te);
        n(fn, function(e) {
            if (!e.has_parens() && Pe(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof Mn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof zn && n.expression === this) return true;
            }
        });
        function t(e) {
            return !e.has_parens() && Pe(e);
        }
        n(Wn, t);
        n(Cn, function(e) {
            var n = e.parent();
            return (n instanceof zn || n instanceof Mn) && n.expression === this;
        });
        n(jn, function(e) {
            var n = e.parent();
            return n instanceof Un || n instanceof Hn || n instanceof zn || n instanceof In || n instanceof Ln || n instanceof Jn || n instanceof Mn && n.expression === this || n instanceof Cn || n instanceof An;
        });
        n(Hn, function(e) {
            var n = e.parent();
            if (n instanceof Hn) {
                var t = n.operator, i = Et[t];
                var r = this.operator, o = Et[r];
                return i > o || i == o && this === n.right;
            }
            if (n instanceof zn) return n.expression === this;
            if (n instanceof Mn) return n.expression === this;
            if (n instanceof Cn) return true;
        });
        n(Mn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof $n && t.expression === n) {
                do {
                    n = n.expression;
                } while (n instanceof Mn);
                return n.TYPE == "Call";
            }
        });
        n(zn, function(e) {
            var n = e.parent();
            if (n instanceof $n) return n.expression === this;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof fn && n instanceof Mn && n.expression === this && t instanceof Rn && t.left === n;
            }
        });
        n($n, function(e) {
            if (g(this, e)) return false;
            var n = e.parent();
            if (n instanceof zn) return n.expression === this;
            return n instanceof Mn;
        });
        n(lt, function(e) {
            var n = e.parent();
            if (n instanceof Mn && n.expression === this) {
                var t = this.value;
                return t < 0 || e.option("galio") && /^0/.test(y(t));
            }
        });
        function i(e, n) {
            var t = n.parent();
            if (t instanceof Hn) return !(t instanceof Rn);
            if (t instanceof zn) return t.expression === e;
            if (t instanceof In) return t.condition === e;
            if (t instanceof Mn) return t.expression === e;
            if (t instanceof Cn) return true;
        }
        n(Rn, function(e) {
            if (i(this, e)) return true;
            if (e.option("v8")) return this.left instanceof Bn;
            if (this.left instanceof Vn) return t(e);
        });
        n(In, function(e) {
            return i(this, e);
        });
        e(Ue, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Re, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function r(e, t, i, n) {
            var r = e.length - 1;
            var o = n;
            var a = s;
            e.forEach(function(e, n) {
                if (o) {
                    if (e instanceof Ue) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof Be)) {
                        if (e instanceof Ye && e.body instanceof ct) {
                            i.force_semicolon();
                        }
                        o = false;
                    }
                }
                if (e instanceof Be) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = a;
        }
        e(Ie, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        e(on, function(e) {
            r(this.body, true, e, true);
            e.print("");
        });
        e(Ge, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(Ye, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function o(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function a(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    r(e.body, false, n, t);
                });
            } else o(e, n);
        }
        e(Je, function(e) {
            a(this, e);
        });
        e(Be, function(e) {
            e.semicolon();
        });
        e(Qe, function(e) {
            var n = this;
            e.print("do");
            e.space();
            w(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(Ze, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            m(n.body, e);
        });
        e(en, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof Sn) {
                        n.init.print(e);
                    } else {
                        p(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            e.space();
            m(n.body, e);
        });
        e(nn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                n.init.print(e);
                e.space();
                e.print("in");
                e.space();
                n.object.print(e);
            });
            e.space();
            m(n.body, e);
        });
        e(tn, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            e.space();
            m(n.body, e);
        });
        e(an, function(t, e) {
            var n = this;
            if (!e) {
                t.print("function");
            }
            if (n.name) {
                t.space();
                n.name.print(t);
            }
            t.with_parens(function() {
                n.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
            t.space();
            a(n, t, true);
        });
        function f(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(pn, f("return", "value"));
        e(dn, f("throw", "value"));
        e(vn, f("break", "label"));
        e(_n, f("continue", "label"));
        function u(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof Tn || t instanceof On) || n.option("ie8") && t instanceof Qe) return w(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof mn) {
                    if (!t.alternative) {
                        w(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof k) {
                    t = t.body;
                } else break;
            }
            m(e.body, n);
        }
        e(mn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            if (n.alternative) {
                u(n, e);
                e.space();
                e.print("else");
                e.space();
                if (n.alternative instanceof mn) n.alternative.print(e); else m(n.alternative, e);
            } else {
                m(n.body, e);
            }
        });
        e(gn, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) o(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function c(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(yn, function(e) {
            e.print("default:");
            c(this, e);
        });
        e(wn, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            c(n, e);
        });
        e(xn, function(e) {
            var n = this;
            e.print("try");
            e.space();
            a(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(kn, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            a(n, e);
        });
        e(En, function(e) {
            e.print("finally");
            e.space();
            a(this, e);
        });
        function l(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (n && n.init !== e || !(n instanceof en || n instanceof nn)) t.semicolon();
            };
        }
        e(Tn, l("const"));
        e(On, l("let"));
        e(Dn, l("var"));
        function p(e, n, t) {
            var i = false;
            if (t) e.walk(new wt(function(e) {
                if (i || e instanceof rn) return true;
                if (e instanceof Hn && e.operator == "in") {
                    i = true;
                    return true;
                }
            }));
            e.print(n, i);
        }
        e(An, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof en || t instanceof nn;
                p(n.value, e, i);
            }
        });
        function d(e, t) {
            if (e.expression instanceof zn || e.expression instanceof an) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(zn, function(e) {
            this.expression.print(e);
            d(this, e);
        });
        e($n, function(e) {
            var n = this;
            e.print("new");
            e.space();
            n.expression.print(e);
            if (g(n, e)) d(n, e);
        });
        e(jn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(qn, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie8") && E[i]) {
                e.print("[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof lt && t.value >= 0) {
                    if (!/[xa-f.)]/i.test(e.last())) {
                        e.print(".");
                    }
                }
                e.print(".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(Fn, function(e) {
            this.expression.print(e);
            e.print("[");
            this.property.print(e);
            e.print("]");
        });
        e(Nn, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof Nn && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(Pn, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(Hn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(In, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(Un, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof _t) t.comma();
                });
                t.space();
            } : Se);
        });
        e(Yn, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof _t) t.comma();
                });
                t.space();
            } : Se);
        });
        e(Ln, v);
        e(Vn, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else o(this, t);
        });
        e(Wn, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else o(this, t);
        });
        function h(e, n) {
            var t = e.key;
            if (t instanceof He) {
                n.with_square(function() {
                    t.print(n);
                });
            } else if (n.option("quote_keys")) {
                n.print_string(t);
            } else if ("" + +t == t && t >= 0) {
                n.print(y(t));
            } else {
                var i = e.start && e.start.quote;
                if (E[t] ? !n.option("ie8") : xt(t)) {
                    if (i && n.option("keep_quoted_props")) {
                        n.print_string(t, i);
                    } else {
                        n.print_name(t);
                    }
                } else {
                    n.print_string(t, i);
                }
            }
        }
        function v(e) {
            var n = this;
            h(n, e);
            e.colon();
            n.value.print(e);
        }
        e(Gn, v);
        function _(t) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                h(n, e);
                n.value._codegen(e, true);
            };
        }
        e(Kn, _("get"));
        e(Xn, _("set"));
        e(Qn, function(e) {
            var n = this.definition();
            e.print_name(n && n.mangled_name || this.name);
        });
        e(_t, Se);
        e(ft, function(e) {
            e.print("this");
        });
        e(ut, function(e) {
            e.print(this.value);
        });
        e(ct, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(lt, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(y(this.value));
            }
        });
        e(pt, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof Hn && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function m(e, n) {
            if (n.option("braces") && !(e instanceof Tn || e instanceof On)) {
                w(e, n);
            } else if (!e || e instanceof Be) {
                n.force_semicolon();
            } else {
                e.print(n);
            }
        }
        function g(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function b(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function y(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, o;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                o = n.slice(r);
                t.push(o + "e-" + (o.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return b(t);
        }
        function w(e, n) {
            if (!e || e instanceof Be) n.print("{}"); else if (e instanceof Je) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function x(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        x([ He, Ge ], Se);
        x([ Un, Je, kn, ut, Re, Sn, Bn, En, cn, an, $n, Wn, k, Qn, gn, bn, xn ], function(e) {
            e.add_mapping(this.start);
        });
        x([ Ln, Jn ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Dt(e, n) {
        if (!(this instanceof Dt)) return new Dt(e, n);
        Tt.call(this, this.before, this.after);
        this.options = ae(e, {
            arguments: !n,
            assignments: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n || "strict",
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_getters: !n && "strict",
            pure_funcs: null,
            reduce_funcs: !n,
            reduce_vars: !n,
            sequences: !n,
            side_effects: !n,
            strings: !n,
            switches: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && Ne(i, r)) {
                i[r.slice(1)] = St(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        var o = this.options["keep_fargs"];
        this.drop_fargs = o == "strict" ? function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        } : o ? Te : Oe;
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                return a !== e.expression.print_to_string();
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                return !Ee(e.expression.print_to_string(), a);
            };
        } else {
            this.pure_funcs = Oe;
        }
        var s = this.options["sequences"];
        this.sequences_limit = s == 1 ? 800 : s | 0;
        var f = this.options["top_retain"];
        if (f instanceof RegExp) {
            this.top_retain = function(e) {
                return f.test(e.name);
            };
        } else if (typeof f == "function") {
            this.top_retain = f;
        } else if (f) {
            if (typeof f == "string") {
                f = f.split(/,/);
            }
            this.top_retain = function(e) {
                return Ee(e.name, f);
            };
        }
        var u = this.options["toplevel"];
        this.toplevel = typeof u == "string" ? {
            funcs: /funcs/.test(u),
            vars: /vars/.test(u)
        } : {
            funcs: u,
            vars: u
        };
    }
    Dt.prototype = new Tt();
    t(Dt.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.undeclared) return true;
            if (!(e.global || e.scope.resolve() instanceof on)) return false;
            var n = this.toplevel;
            return !Fe(e.orig, function(e) {
                return n[e instanceof rt ? "funcs" : "vars"];
            });
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var o = 0; o < n; o++) {
                e.figure_out_scope(r);
                if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var a = 0;
                    e.walk(new wt(function() {
                        a++;
                    }));
                    He.info("pass {pass}: last_count: {min_count}, count: {count}", {
                        pass: o,
                        min_count: t,
                        count: a
                    });
                    if (a < t) {
                        t = a;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof rn;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
                r.merge_variables(this);
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(He, function(e, n) {
            return e;
        });
        He.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        rn.DEFMETHOD("process_expression", function(t, i) {
            var r = this;
            var o = new Tt(function(e) {
                if (t && e instanceof Ye) {
                    return ve(pn, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof pn) {
                    return i ? i(e) : ve(Ye, e, {
                        body: e.value || ve(Nn, e, {
                            operator: "void",
                            expression: ve(lt, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof an && e !== r) {
                    return e;
                }
                if (e instanceof We) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(o);
                    }
                } else if (e instanceof mn) {
                    e.body = e.body.transform(o);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(o);
                    }
                } else if (e instanceof tn) {
                    e.body = e.body.transform(o);
                }
                return e;
            });
            r.transform(o);
        });
        function T(e, n) {
            var t = n.getProperty();
            if (t instanceof He) return;
            var i;
            if (e instanceof Un) {
                var r = e.elements;
                if (t == "length") return O(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof an) {
                if (t == "length") {
                    e.length_read = true;
                    return O(e.argnames.length, e);
                }
            } else if (e instanceof Wn) {
                t = "" + t;
                var o = e.properties;
                for (var a = o.length; --a >= 0; ) {
                    var s = o[a];
                    if (!(s instanceof Gn)) return;
                    if (!i && o[a].key === t) i = o[a].value;
                }
            }
            return i instanceof st && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof gt) return g.Boolean[n];
            if (e instanceof lt) return g.Number[n];
            if (e instanceof ct) return g.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Un) return g.Array[n];
            if (e instanceof fn) return g.Function[n];
            if (e instanceof Wn) return g.Object[n];
            if (e instanceof pt) return g.RegExp[n] && !e.value.global;
        }
        function le(e, n, t, i, r, o, a) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof qn && l(i, s.property)) {
                return;
            }
            var f = we(t, s);
            if (f) return f;
            if (s instanceof Un) return le(e, n, s, s, r + 1);
            if (s instanceof zn) {
                return !o && s.expression === t && !s.is_expr_pure(e) && (!(i instanceof fn) || !(s instanceof $n) && i.contains_this());
            }
            if (s instanceof nn) return s.init === t;
            if (s instanceof Gn) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return le(e, n, u, u, r + 2);
            }
            if (s instanceof Mn) {
                if (s.expression !== t) return;
                var c = T(i, s);
                return (!o || a) && le(e, n, s, c, r + 1);
            }
        }
        function pe(e) {
            if (e.name != "arguments") return false;
            var n = e.orig;
            return n.length == 1 && n[0] instanceof it;
        }
        function R(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof rn) return true;
            } while (n = n.parent_scope);
        }
        function de(e, n) {
            var t = e.definition().orig;
            if (e.in_arg && (t[0] instanceof it || t[1] instanceof it)) return false;
            return Fe(t, function(e) {
                return !(e instanceof et || e instanceof nt || n && e instanceof ot);
            });
        }
        (function(e) {
            e(He, Se);
            function o(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof fn && t.init !== t.scope) && t.init;
                if (t.fixed instanceof un && !Fe(t.references, function(e) {
                    var n = e.scope.resolve();
                    do {
                        if (t.scope === n) return true;
                    } while (n instanceof fn && (n = n.parent_scope.resolve()));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function u(n, t, e) {
                e.variables.each(function(e) {
                    o(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        h(n, e);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        h(n, e);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = Se;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (e.init instanceof un && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
                if (t.option("ie8")) e.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function c(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!_(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function l(n, e) {
                e.functions.each(function(e) {
                    if (e.init instanceof un && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function p(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function d(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function h(e, n) {
                e.safe_ids[n.id] = {};
            }
            function v(e, n) {
                e.references.push(n);
                e.last_ref = n;
            }
            function _(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    if (!Ne(e.safe_ids, n.id)) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (pe(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = ve(vt, n.orig[0]);
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof un;
            }
            function m(e, n, t) {
                if (!(t || Fe(n.orig, function(e) {
                    return !(e instanceof et);
                }))) return false;
                if (n.fixed === undefined) return t || Fe(n.orig, function(e) {
                    return !(e instanceof nt);
                });
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (n.fixed === false) return false;
                var i = e.safe_ids[n.id];
                if (!Ne(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read && n.scope !== e.find_parent(rn)) return false;
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return _(e, n) && Fe(n.orig, function(e) {
                    return !(e instanceof ot);
                });
            }
            function g(e, n) {
                var t = ve(st, e, e);
                t.fixed = n || ve(vt, e);
                return t;
            }
            function b(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1;
            }
            function y(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof an || e instanceof ft;
            }
            function w(e, n, t) {
                if (t instanceof Rn) return t.operator == "=" && t.right === n;
                if (t instanceof zn) return t.expression !== n || t instanceof $n;
                if (t instanceof ln) return t.value === n && n.scope !== e.scope;
                if (t instanceof An) return t.value === n;
            }
            function x(e, n) {
                if (n instanceof Un) return true;
                if (n instanceof Hn) return be[n.operator];
                if (n instanceof In) return n.condition !== e;
                if (n instanceof jn) return n.tail_node() === e;
            }
            function k(e, n, t, i, r, o, a) {
                var s = e.parent(o);
                if (r && r.is_constant()) return;
                if (w(n, i, s)) {
                    n.escaped.push(s);
                    if (a > 1 && !(r && r.is_constant_expression(t))) a = 1;
                    if (!n.escaped.depth || n.escaped.depth > a) n.escaped.depth = a;
                    return;
                } else if (x(i, s)) {
                    k(e, n, t, s, s, o + 1, a);
                } else if (s instanceof Gn && s.value === i) {
                    var f = e.parent(o + 1);
                    k(e, n, t, f, f, o + 2, a);
                } else if (s instanceof Mn && s.expression === i) {
                    r = T(r, s);
                    k(e, n, t, s, r, o + 1, a + 1);
                    if (r) return;
                }
                if (o > 0) return;
                if (s instanceof zn && s.expression === i) return;
                if (s instanceof jn && s.tail_node() !== i) return;
                if (s instanceof Ye) return;
                if (s instanceof Cn && !j[s.operator]) return;
                n.direct_access = true;
            }
            function E(e) {
                if (!(e instanceof Fn)) return;
                var n = e.expression;
                if (!(n instanceof st)) return;
                var t = n.definition();
                if (pe(t) && e.property instanceof lt) t.reassigned = true;
            }
            function S(n, e, r, t) {
                var o = new wt(function(e) {
                    if (e instanceof Yn) {
                        var i = r;
                        e.elements.forEach(function(e, n) {
                            if (e instanceof _t) return;
                            r = function() {
                                return ve(Fn, e, {
                                    expression: i(),
                                    property: ve(lt, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(o);
                        });
                        r = i;
                        return true;
                    }
                    if (e instanceof Vn) {
                        var i = r;
                        e.properties.forEach(function(t) {
                            if (t.key instanceof He) {
                                p(n);
                                t.key.walk(n);
                                d(n);
                            }
                            r = function() {
                                var e = t.key;
                                var n = Fn;
                                if (typeof e == "string") {
                                    if (xt(e)) {
                                        n = qn;
                                    } else {
                                        e = O(e, t);
                                    }
                                }
                                return ve(n, t, {
                                    expression: i(),
                                    property: e
                                });
                            };
                            t.value.walk(o);
                        });
                        r = i;
                        return true;
                    }
                    t(e, r);
                    return true;
                });
                e.walk(o);
            }
            e(sn, function(e, n, t) {
                p(e);
                u(e, t, this);
                n();
                d(e);
                l(e, this);
                return true;
            });
            e(Rn, function(i, e, r) {
                var o = this;
                var a = o.left;
                if (o.operator == "=" && a.equivalent_to(o.right) && !a.has_side_effects(r)) {
                    o.right.walk(i);
                    f(a);
                    o.__drop = true;
                } else if (!(a instanceof Bn || a instanceof st)) {
                    E(a);
                    return;
                } else if (o.operator == "=") {
                    o.right.walk(i);
                    S(i, a, function() {
                        return o.right;
                    }, function(e, n) {
                        if (!(e instanceof st)) {
                            E(e);
                            e.walk(i);
                            return;
                        }
                        var t = e.definition();
                        t.assignments++;
                        if (!le(r, i, o, o.right, 0) && de(e) && m(i, t)) {
                            v(t, e);
                            h(i, t);
                            if (t.single_use && a instanceof Bn) t.single_use = false;
                            i.loop_ids[t.id] = i.in_loop;
                            k(i, t, e.scope, o, o.right, 0, 1);
                            e.fixed = t.fixed = n;
                            e.fixed.assigns = [ o ];
                        } else {
                            e.walk(i);
                            t.fixed = false;
                        }
                    });
                } else {
                    var n = a.definition();
                    n.assignments++;
                    var t = n.fixed;
                    if (le(r, i, o, o, 0)) {
                        n.fixed = false;
                        return;
                    }
                    var s = _(i, n);
                    o.right.walk(i);
                    if (s && m(i, n)) {
                        v(n, a);
                        h(i, n);
                        if (n.single_use) n.single_use = false;
                        a.fixed = n.fixed = function() {
                            return ve(Hn, o, {
                                operator: o.operator.slice(0, -1),
                                left: g(a, t),
                                right: o.right
                            });
                        };
                        a.fixed.assigns = !t || !t.assigns ? [] : t.assigns.slice();
                        a.fixed.assigns.push(o);
                    } else {
                        a.walk(i);
                        n.fixed = false;
                    }
                }
                return true;
                function f(e) {
                    if (e instanceof qn) {
                        f(e.expression);
                    } else if (e instanceof Fn) {
                        f(e.expression);
                        e.property.walk(i);
                    } else if (e instanceof st) {
                        var n = e.definition();
                        v(n, e);
                        e.fixed = n.fixed;
                    } else {
                        e.walk(i);
                    }
                }
            });
            e(Hn, function(e) {
                if (!be[this.operator]) return;
                this.left.walk(e);
                p(e);
                this.right.walk(e);
                d(e);
                return true;
            });
            e(Le, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
            });
            e(zn, function(n, e) {
                n.find_parent(rn).may_call_this();
                var t = this.expression;
                var i = t.tail_node();
                if (i instanceof fn) {
                    if (t !== i) t.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(n);
                    });
                    this.args.forEach(function(e) {
                        e.walk(n);
                    });
                    i.walk(n);
                    return true;
                } else if (i instanceof st) {
                    var r = i.definition();
                    if (this.TYPE == "Call" && n.in_boolean_context()) r.bool_fn++;
                    if (!(r.fixed instanceof un)) return;
                    var o = c(n, r);
                    if (!o) return;
                    e();
                    o.walk(n);
                    return true;
                } else if (this.TYPE == "Call" && i instanceof Rn && i.operator == "=" && i.left instanceof st && n.in_boolean_context()) {
                    i.left.definition().bool_fn++;
                }
            });
            e(In, function(e) {
                this.condition.walk(e);
                p(e);
                this.consequent.walk(e);
                d(e);
                p(e);
                this.alternative.walk(e);
                d(e);
                return true;
            });
            e(un, function(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                p(e);
                u(e, t, this);
                n();
                d(e);
                l(e, this);
                return true;
            });
            e(Qe, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                p(e);
                this.body.walk(e);
                if (q(this, e.parent())) {
                    d(e);
                    p(e);
                }
                this.condition.walk(e);
                d(e);
                e.in_loop = n;
                return true;
            });
            e(en, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                if (this.init) this.init.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                if (this.condition) this.condition.walk(n);
                this.body.walk(n);
                if (this.step) {
                    if (q(this, n.parent())) {
                        d(n);
                        p(n);
                    }
                    this.step.walk(n);
                }
                d(n);
                n.in_loop = i;
                return true;
            });
            e(nn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.object.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                var r = this.init;
                r.walk(n);
                if (r instanceof Sn) {
                    r.definitions[0].name.match_symbol(function(e) {
                        if (e instanceof Zn) e.definition().fixed = false;
                    }, true);
                } else if (r instanceof st) {
                    r.definition().fixed = false;
                }
                this.body.walk(n);
                d(n);
                n.in_loop = i;
                return true;
            });
            e(fn, function(a, e, n) {
                var t = this;
                t.inlined = false;
                var s;
                if (!t.name && (s = a.parent()) instanceof zn && s.expression === t) {
                    var i = false;
                    var r = false;
                    t.walk(new wt(function(e) {
                        if (i) return r = true;
                        if (e instanceof pn) return i = true;
                        if (e instanceof rn && e !== t) return true;
                    }));
                    if (r) p(a);
                    u(a, n, t);
                    var f = !t.uses_arguments || a.has_directive("use strict");
                    t.argnames.forEach(function(r, o) {
                        var n = s.args[o];
                        S(a, r, function() {
                            var e = t.argnames.indexOf(r);
                            return (e < 0 ? n : s.args[e]) || ve(vt, s);
                        }, function(e, n) {
                            var t = e.definition();
                            if (f && t.fixed === undefined) {
                                h(a, t);
                                a.loop_ids[t.id] = a.in_loop;
                                var i = s.args[o];
                                t.fixed = n;
                                t.fixed.assigns = [ r ];
                            } else {
                                t.fixed = false;
                            }
                        });
                    });
                    Ve(t, a);
                    var o = a.safe_ids;
                    d(a);
                    l(a, t);
                    if (!r) a.safe_ids = o;
                } else {
                    p(a);
                    u(a, n, t);
                    e();
                    d(a);
                    l(a, t);
                }
                return true;
            });
            e(mn, function(e) {
                this.condition.walk(e);
                p(e);
                this.body.walk(e);
                d(e);
                if (this.alternative) {
                    p(e);
                    this.alternative.walk(e);
                    d(e);
                }
                return true;
            });
            e(Ge, function(e) {
                p(e);
                this.body.walk(e);
                d(e);
                return true;
            });
            e(gn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                this.expression.walk(n);
                var i = true;
                this.body.forEach(function(e) {
                    if (e instanceof yn) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        p(n);
                    }
                });
                if (!i) d(n);
                Ve(this, n);
                return true;
            });
            e(bn, function(e) {
                p(e);
                Ve(this, e);
                d(e);
                return true;
            });
            e(at, function() {
                this.definition().fixed = false;
            });
            e(st, function(e, n, t) {
                var i = this.definition();
                v(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof rt) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                if (i.fixed === false) {
                    var r = i.redefined();
                    if (r && R(i.scope, this.scope)) r.single_use = false;
                } else if (i.fixed === undefined || !_(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof ot) this.fixed = i.scope;
                    var o = this.fixed_value();
                    var a = ke(e, i);
                    if (a) {
                        i.recursive_refs++;
                    } else if (o && b(t, i)) {
                        i.in_loop = e.loop_ids[i.id] !== e.in_loop;
                        i.single_use = o instanceof an && !o.pinned() && (!i.in_loop || e.parent() instanceof zn) || !i.in_loop && i.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (le(t, e, this, o, 0, y(o), a)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    if (i.fixed && e.loop_ids[i.id] !== e.in_loop) {
                        i.cross_loop = true;
                    }
                    k(e, i, this.scope, this, o, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (i.fixed instanceof un && !((s = e.parent()) instanceof zn && s.expression === this)) {
                    var f = c(e, i);
                    if (f) f.walk(e);
                }
            });
            e(on, function(n, e, t) {
                this.globals.each(function(e) {
                    o(n, t, e);
                });
                p(n);
                u(n, t, this);
                e();
                d(n);
                l(n, this);
                return true;
            });
            e(xn, function(n, e, t) {
                this.variables.each(function(e) {
                    o(n, t, e);
                });
                p(n);
                Ve(this, n);
                d(n);
                if (this.bcatch) {
                    p(n);
                    this.bcatch.walk(n);
                    d(n);
                }
                if (this.bfinally) this.bfinally.walk(n);
                return true;
            });
            e(Cn, function(e, n) {
                var t = this;
                if (!ye[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof st)) {
                    E(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var o = r.fixed;
                if (_(e, r) && m(e, r)) {
                    v(r, i);
                    h(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return ve(Hn, t, {
                            operator: t.operator.slice(0, -1),
                            left: ve(Nn, t, {
                                operator: "+",
                                expression: g(i, o)
                            }),
                            right: ve(lt, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = o && o.assigns ? o.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof Nn) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return ve(Nn, t, {
                                operator: "+",
                                expression: g(i, o)
                            });
                        };
                        i.fixed.assigns = o && o.assigns;
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(An, function(i) {
                var r = this;
                if (!r.value) return;
                r.value.walk(i);
                S(i, r.name, function() {
                    return r.value;
                }, function(e, n) {
                    var t = e.definition();
                    if (m(i, t, true)) {
                        h(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ r ];
                        if (e instanceof et && t.redefined() || !(de(e) || U(t))) {
                            t.single_use = false;
                        }
                    } else {
                        t.fixed = false;
                    }
                });
                return true;
            });
            e(Ze, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                p(e);
                n();
                d(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        on.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new wt(t.option("reduce_vars") ? function(e, n) {
                r(e);
                return e.reduce_vars(i, n, t);
            } : r);
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
            function r(e) {
                e._squeezed = false;
                e._optimized = false;
                delete e.fixed;
                if (e instanceof rn) delete e._var_names;
            }
        });
        Qn.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof He ? e : e();
        });
        st.DEFMETHOD("is_immutable", function() {
            var e = this.definition();
            if (e.orig.length != 1) return false;
            var n = e.orig[0];
            return n instanceof ot && e.scope.name === n;
        });
        He.DEFMETHOD("convert_symbol", Se);
        Bn.DEFMETHOD("convert_symbol", function(t, i) {
            return this.transform(new Tt(function(e, n) {
                if (e instanceof Bn) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof Ln) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, i);
            }));
        });
        function n(e, n) {
            var t = ve(e, this, this);
            n(t, this);
            return t;
        }
        Zn.DEFMETHOD("convert_symbol", n);
        st.DEFMETHOD("convert_symbol", n);
        Bn.DEFMETHOD("mark_symbol", function(n, t) {
            var i = new wt(function(e) {
                if (e instanceof Ln) {
                    if (e.key instanceof He) e.key.walk(t);
                    e.value.walk(i);
                    return true;
                }
                return n(e);
            });
            this.walk(i);
        });
        function t(e) {
            return e(this);
        }
        Zn.DEFMETHOD("mark_symbol", t);
        st.DEFMETHOD("mark_symbol", t);
        He.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        Bn.DEFMETHOD("match_symbol", function(n, t) {
            var i = false;
            var r = new wt(function(e) {
                if (i) return true;
                if (e instanceof Ln) {
                    if (!t && e.key instanceof He) return i = true;
                    e.value.walk(r);
                    return true;
                }
                if (n(e)) return i = true;
            });
            this.walk(r);
            return i;
        });
        function L(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        function he(e, n) {
            if (e instanceof ft) return true;
            if (e instanceof st) {
                var t = e.definition();
                return t.lambda || n.exposed(t) && K[t.name];
            }
            if (e instanceof Mn) {
                e = e.expression;
                if (e instanceof st) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return he(e, n);
            }
            return false;
        }
        function ve(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function V(e, n) {
            if (n.length == 1) return n[0];
            return ve(jn, e, {
                expressions: n.reduce(_, [])
            });
        }
        function O(e, n) {
            switch (typeof e) {
              case "string":
                return ve(ct, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return ve(ht, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? ve(Nn, n, {
                        operator: "-",
                        expression: ve(lt, n, {
                            value: -e
                        })
                    }) : ve(lt, n, {
                        value: e
                    });
                }
                return e < 0 ? ve(Nn, n, {
                    operator: "-",
                    expression: ve(mt, n)
                }) : ve(mt, n);

              case "boolean":
                return ve(e ? yt : bt, n);

              case "undefined":
                return ve(vt, n);

              default:
                if (e === null) {
                    return ve(dt, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return ve(pt, n, {
                        value: e
                    });
                }
                throw new Error(je("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function W(e, n) {
            return n instanceof Mn || X(n) && n.name == "eval";
        }
        function _e(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && W(e, i);
            } else if (n instanceof Nn) {
                r = n.operator == "delete" || n.operator == "typeof" && X(i);
            }
            return r ? V(t, [ ve(lt, t, {
                value: 0
            }), i ]) : i;
        }
        function _(e, n) {
            if (n instanceof jn) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function D(e) {
            if (e === null) return [];
            if (e instanceof Je) return Fe(e.body, function(e) {
                return !(e instanceof Tn || e instanceof On);
            }) ? e.body : [ e ];
            if (e instanceof Be) return [];
            if (e instanceof Ie) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function J(e) {
            if (e === null) return true;
            if (e instanceof Be) return true;
            if (e instanceof Je) return e.body.length == 0;
            return false;
        }
        function x(e) {
            return Fe(e.body, function(e) {
                return J(e) || e instanceof un || e instanceof Dn && Fe(e.definitions, function(e) {
                    return !e.value;
                });
            });
        }
        function A(e) {
            if (e instanceof Xe) {
                return e.body instanceof Je ? e.body : e;
            }
            return e;
        }
        function me(e) {
            while (e instanceof Mn) e = e.expression;
            return e;
        }
        function G(e) {
            if (e.TYPE != "Call") return false;
            return e.expression instanceof fn || G(e.expression);
        }
        function X(e) {
            return e instanceof st && e.definition().undeclared;
        }
        function ge(e) {
            return e[e instanceof Rn ? "right" : "value"];
        }
        var i = qe("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        st.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && i[this.name];
        });
        var K = qe("Infinity NaN undefined");
        function a(e) {
            return e instanceof mt || e instanceof ht || e instanceof vt;
        }
        function m(e) {
            return Fe(e.definitions, function(e) {
                return !e.value;
            });
        }
        function z(e) {
            return e instanceof un || e instanceof Dn && m(e);
        }
        function u(e, f) {
            var se, fe, ue;
            t();
            var ce, n = 10;
            do {
                ce = false;
                r(e);
                if (f.option("dead_code")) {
                    a(e, f);
                }
                if (f.option("if_return")) {
                    o(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    v(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (ce && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof kn) {
                        if (!f.parent(n).bfinally) n++;
                    } else if (e instanceof En) {
                        n++;
                    } else if (e instanceof Xe) {
                        se = true;
                    } else if (e instanceof rn) {
                        ue = e;
                        break;
                    } else if (e instanceof xn) {
                        if (!fe) fe = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(o, c) {
                if (ue.pinned()) return o;
                var f;
                var a = Object.create(null);
                var u = [];
                var s = Object.create(null);
                var t;
                var l = o.length;
                var p = new Tt(function(e, n) {
                    if ($) return e;
                    if (!z) {
                        if (e !== d[h]) return e;
                        h++;
                        if (h < d.length) return N(e, p);
                        z = true;
                        m = (_ ? Y : B)(e, 0);
                        if (m === e) $ = true;
                        return e;
                    }
                    var t = p.parent();
                    if (P(e, t)) {
                        $ = true;
                        return e;
                    }
                    if (!g && H(e, t)) {
                        g = t;
                    }
                    if (e.single_use && t instanceof An && t.value === e) return e;
                    var i;
                    if (!(e instanceof Zn) && (w && b.equivalent_to(e) || x && (i = x(e, this)))) {
                        if (!q || g && (i || !T || !O)) {
                            if (!i || !_) $ = true;
                            return e;
                        }
                        if (we(e, t)) {
                            if (_ && !i) {
                                M = true;
                                j++;
                            }
                            return e;
                        } else if (_) {
                            if (!i) j++;
                            return e;
                        } else {
                            j++;
                        }
                        ce = $ = true;
                        He.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (v instanceof Pn) {
                            if (b instanceof st) b.definition().fixed = false;
                            return ve(Nn, v, v);
                        }
                        if (v instanceof An) {
                            var r = v.name.definition();
                            if (r.references.length - r.replaced == 1 && !c.exposed(r)) {
                                r.replaced++;
                                return _e(c, t, e, v.value);
                            }
                            return ve(Rn, v, {
                                operator: "=",
                                left: ve(st, v.name, v.name),
                                right: v.value
                            });
                        }
                        v.write_only = false;
                        return v;
                    }
                    if (I(e, t) || D(e)) {
                        m = e;
                        if (e instanceof rn) $ = true;
                    }
                    if (e instanceof sn) {
                        var o = q;
                        q = false;
                        n(e, p);
                        q = o;
                        return e;
                    }
                    return N(e, p);
                }, function(e) {
                    if ($) return;
                    if (m === e) $ = true;
                    if (g === e) g = null;
                });
                var i = new Tt(function(e) {
                    if ($) return e;
                    if (!z) {
                        if (e !== d[h]) return e;
                        h++;
                        switch (d.length - h) {
                          case 0:
                            z = true;
                            if (M) return e;
                            if (e instanceof An) return e;
                            F.replaced++;
                            var n = i.parent();
                            if (n instanceof jn && n.tail_node() !== e) {
                                _.replaced++;
                                return ze.skip;
                            }
                            return r;

                          case 1:
                            if (!M && e.body === v) {
                                z = true;
                                F.replaced++;
                                _.replaced++;
                                return null;
                            }

                          default:
                            return;
                        }
                    }
                    if (e instanceof st && e.name == F.name) {
                        if (!--j) $ = true;
                        if (we(e, i.parent())) return e;
                        F.replaced++;
                        var t = r.clone();
                        _.references.push(t);
                        return t;
                    }
                    if (e instanceof yn || e instanceof rn) return e;
                }, ee);
                while (--l >= 0) {
                    if (l == 0 && c.option("unused")) R();
                    var d = [];
                    U(o[l]);
                    while (u.length > 0) {
                        d = u.pop();
                        var h = 0;
                        var v = d[d.length - 1];
                        var _ = null;
                        var m = null;
                        var g = null;
                        var b = W(v);
                        var y = b && b.has_side_effects(c);
                        var w = b && !y && !he(b, c);
                        var x = G(v);
                        if (!w && !x) continue;
                        var k = false;
                        var E = false;
                        var S = Q(v);
                        var T = ne(b);
                        var r = ge(v);
                        if (!y) y = te();
                        var O = ie(v);
                        var D = v.may_throw(c) ? fe ? function(e) {
                            return e.has_side_effects(c);
                        } : ae : Te;
                        var A = v.name instanceof it;
                        var z = A;
                        var $ = false;
                        var j = 0;
                        var M = false;
                        var q = !f || !z;
                        if (!q) {
                            for (var e = c.self().argnames.lastIndexOf(v.name) + 1; !$ && e < f.length; e++) {
                                f[e].transform(p);
                            }
                            q = true;
                        }
                        for (var n = l; !$ && n < o.length; n++) {
                            o[n].transform(p);
                        }
                        if (_) {
                            var F = b.definition();
                            var C = F.references.length - F.replaced;
                            if (v instanceof Rn) C--;
                            if (j && C == j) {
                                $ = false;
                            } else {
                                u.push(d);
                                t = true;
                                continue;
                            }
                            if (j) {
                                h = 0;
                                z = A;
                                for (var n = l; !$ && n < o.length; n++) {
                                    if (!o[n].transform(i)) o.splice(n--, 1);
                                }
                                if (v instanceof An) {
                                    j = !c.exposed(F) && F.references.length == F.replaced;
                                }
                                _.single_use = false;
                            }
                        }
                        if (j && !Z(v)) o.splice(l, 1);
                    }
                }
                function N(e, n) {
                    if (!(e instanceof Le)) return;
                    if (e instanceof rn) return e;
                    if (!(e.variables && e.variables.all(function(e) {
                        return !S.has(e.name);
                    }))) {
                        $ = true;
                        return e;
                    }
                    if (e instanceof nn) {
                        e.object = e.object.transform(n);
                        $ = true;
                        return e;
                    }
                    if (e instanceof gn) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !$ && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof wn) {
                                if (!z) {
                                    if (i !== d[h]) continue;
                                    h++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!O) break;
                                x = false;
                            }
                        }
                        $ = true;
                        return e;
                    }
                }
                function P(e, n) {
                    if (e === r) return true;
                    if (n instanceof en) return e !== n.init;
                    if (e instanceof Rn) {
                        return e.operator != "=" && b.equivalent_to(e.left);
                    }
                    if (e instanceof zn) {
                        if (!(b instanceof Mn)) return false;
                        if (!b.equivalent_to(e.expression)) return false;
                        return !(r instanceof fn && !r.contains_this());
                    }
                    if (e instanceof Re) return true;
                    if (e instanceof un) return A && b.name === e.name.name;
                    if (e instanceof Bn) return n instanceof Rn;
                    if (e instanceof Ln) return e.key instanceof He;
                    if (e instanceof Ke) return true;
                    if (e instanceof hn) return true;
                    if (e instanceof st) {
                        if (e.is_declared(c)) {
                            if (e.fixed_value() || de(e)) return false;
                        } else if (n instanceof Rn && n.operator == "=" && n.left === e) {
                            return false;
                        }
                        if (!O) return true;
                        x = false;
                        return false;
                    }
                    if (e instanceof xn) return true;
                    if (e instanceof tn) return true;
                    return false;
                }
                function H(e, n) {
                    if (n instanceof Hn) return be[n.operator] && n.left !== e;
                    if (n instanceof wn) return n.expression !== e;
                    if (n instanceof In) return n.condition !== e;
                    return n instanceof mn && n.condition !== e;
                }
                function I(e, n) {
                    if (e.TYPE == "Binary") return e.operator == "in" && !xe(e.right);
                    if (e instanceof zn) {
                        var t, i = e.expression;
                        if (i instanceof st) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof an)) return true;
                        if (t && ke(c, t)) return true;
                        if (!Fe(i.argnames, function(e) {
                            return !(e instanceof Bn);
                        })) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = q;
                        q = false;
                        var o = m;
                        var a = g;
                        for (var s = 0; !$ && s < i.body.length; s++) {
                            var f = i.body[s];
                            if (f instanceof pn) {
                                if (f.value) f.value.transform(p);
                                break;
                            }
                            f.transform(p);
                        }
                        g = a;
                        m = o;
                        q = r;
                        delete i.collapse_scanning;
                        if (!$) return false;
                        $ = false;
                        return true;
                    }
                    if (e instanceof ln) {
                        if (fe) {
                            if (fe.bfinally) return true;
                            if (fe.bcatch && e instanceof dn) return true;
                        }
                        return y || b instanceof Mn || oe(b);
                    }
                    if (e instanceof fn) {
                        return c.option("ie8") && e.name && S.has(e.name.name);
                    }
                    if (e instanceof Mn) {
                        return y || !_ && e.expression.may_throw_on_access(c);
                    }
                    if (e instanceof st) {
                        if (re(e, n)) {
                            return !(n instanceof Rn && n.operator == "=" && n.left === e);
                        }
                        if (y && oe(e)) return true;
                        var t = e.definition();
                        return (fe || t.scope.resolve() !== ue) && !de(e);
                    }
                    if (e instanceof ft) return re(e, n);
                    if (e instanceof An) {
                        if ((fe || !T) && e.name instanceof Bn) return true;
                        return (e.value || n instanceof On) && e.name.match_symbol(function(e) {
                            return e instanceof Zn && (S.has(e.name) || y && oe(e));
                        });
                    }
                    var u = we(e.left, e);
                    if (!u) return false;
                    if (u instanceof Mn) return true;
                    if ((fe || !T) && u instanceof Bn) return true;
                    return u.match_symbol(function(e) {
                        return e instanceof st && (S.has(e.name) || k && c.exposed(e.definition()));
                    });
                }
                function R() {
                    var e, t = c.self();
                    if (t instanceof fn && !t.name && !t.uses_arguments && !t.pinned() && (e = c.parent()) instanceof zn && e.expression === t) {
                        var i = c.has_directive("use strict");
                        if (i && !Ee(i, t.body)) i = false;
                        var n = t.argnames.length;
                        f = e.args.slice(n);
                        var r = Object.create(null);
                        for (var o = n; --o >= 0; ) {
                            var a = t.argnames[o];
                            var s = e.args[o];
                            f.unshift(ve(An, a, {
                                name: a,
                                value: s
                            }));
                            if (a instanceof Bn) {
                                if (!a.match_symbol(Te)) continue;
                                u.length = 0;
                                break;
                            }
                            if (a.name in r) continue;
                            r[a.name] = true;
                            if (!s) {
                                s = ve(vt, a).transform(c);
                            } else if (s instanceof an && s.pinned()) {
                                s = null;
                            } else {
                                s.walk(new wt(function(e) {
                                    if (!s) return true;
                                    if (e instanceof st && t.variables.has(e.name)) {
                                        var n = e.definition().scope;
                                        if (n !== ue) while (n = n.parent_scope) {
                                            if (n === ue) return true;
                                        }
                                        s = null;
                                    }
                                    if (e instanceof ft && (i || !this.find_parent(rn))) {
                                        s = null;
                                        return true;
                                    }
                                }));
                            }
                            if (s) u.unshift([ ve(An, a, {
                                name: a,
                                value: s
                            }) ]);
                        }
                    }
                }
                function U(e) {
                    d.push(e);
                    if (e instanceof Un) {
                        e.elements.forEach(U);
                    } else if (e instanceof Rn) {
                        if (!(e.left instanceof Bn)) u.push(d.slice());
                        U(e.left);
                        U(e.right);
                        if (e.left instanceof st) {
                            a[e.left.name] = (a[e.left.name] || 0) + 1;
                        }
                    } else if (e instanceof Hn) {
                        U(e.left);
                        U(e.right);
                    } else if (e instanceof zn) {
                        U(e.expression);
                        e.args.forEach(U);
                    } else if (e instanceof wn) {
                        U(e.expression);
                    } else if (e instanceof In) {
                        U(e.condition);
                        U(e.consequent);
                        U(e.alternative);
                    } else if (e instanceof Sn) {
                        e.definitions.forEach(U);
                    } else if (e instanceof qn) {
                        U(e.expression);
                    } else if (e instanceof Ke) {
                        U(e.condition);
                        if (!(e.body instanceof We)) {
                            U(e.body);
                        }
                    } else if (e instanceof ln) {
                        if (e.value) U(e.value);
                    } else if (e instanceof en) {
                        if (e.init) U(e.init);
                        if (e.condition) U(e.condition);
                        if (e.step) U(e.step);
                        if (!(e.body instanceof We)) {
                            U(e.body);
                        }
                    } else if (e instanceof nn) {
                        U(e.object);
                        if (!(e.body instanceof We)) {
                            U(e.body);
                        }
                    } else if (e instanceof mn) {
                        U(e.condition);
                        if (!(e.body instanceof We)) {
                            U(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof We)) {
                            U(e.alternative);
                        }
                    } else if (e instanceof Wn) {
                        e.properties.forEach(function(e) {
                            d.push(e);
                            if (e.key instanceof He) U(e.key);
                            if (e instanceof Gn) U(e.value);
                            d.pop();
                        });
                    } else if (e instanceof jn) {
                        e.expressions.forEach(U);
                    } else if (e instanceof Ye) {
                        U(e.body);
                    } else if (e instanceof Fn) {
                        U(e.expression);
                        U(e.property);
                    } else if (e instanceof gn) {
                        U(e.expression);
                        e.body.forEach(U);
                    } else if (e instanceof Cn) {
                        if (ye[e.operator]) {
                            u.push(d.slice());
                        } else {
                            U(e.expression);
                        }
                    } else if (e instanceof An) {
                        if (e.name instanceof tt) {
                            if (e.value) {
                                var n = e.name.definition();
                                if (n.references.length > n.replaced) {
                                    u.push(d.slice());
                                }
                            } else {
                                s[e.name.name] = (s[e.name.name] || 0) + 1;
                            }
                        }
                        if (e.value) U(e.value);
                    }
                    d.pop();
                }
                function B(e, n) {
                    var t = p.parent(n);
                    if (t instanceof Un) return e;
                    if (t instanceof Rn) return e;
                    if (t instanceof Hn) return e;
                    if (t instanceof zn) return e;
                    if (t instanceof wn) return e;
                    if (t instanceof In) return e;
                    if (t instanceof Sn) return L(t, n + 1);
                    if (t instanceof ln) return e;
                    if (t instanceof mn) return e;
                    if (t instanceof Xe) return e;
                    if (t instanceof Jn) return e;
                    if (t instanceof Mn) return e;
                    if (t instanceof jn) {
                        return (t.tail_node() === e ? B : L)(t, n + 1);
                    }
                    if (t instanceof Ye) return L(t, n + 1);
                    if (t instanceof gn) return e;
                    if (t instanceof Cn) return e;
                    if (t instanceof An) return e;
                    return null;
                }
                function Y(e, n) {
                    var t = p.parent(n);
                    if (t instanceof Un) return Y(t, n + 1);
                    if (t instanceof Rn) return D(t) || t.left.match_symbol(function(e) {
                        return e instanceof st && (b.name == e.name || _.name == e.name);
                    }) ? e : Y(t, n + 1);
                    if (t instanceof Hn) {
                        if (be[t.operator] && t.left !== e) {
                            do {
                                e = t;
                                t = p.parent(++n);
                            } while (t instanceof Hn && t.operator == e.operator);
                            return e;
                        }
                        return Y(t, n + 1);
                    }
                    if (t instanceof zn) return t;
                    if (t instanceof wn) {
                        if (t.expression !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof In) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Sn) return L(t, n + 1);
                    if (t instanceof Qe) return e;
                    if (t instanceof ln) return L(t, n + 1);
                    if (t instanceof en) {
                        if (t.init !== e && t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof nn) {
                        if (t.init !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof mn) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Jn) {
                        var i = p.parent(n + 1);
                        return Fe(i.properties, function(e) {
                            return e instanceof Gn;
                        }) ? Y(i, n + 2) : i;
                    }
                    if (t instanceof Mn) return Y(t, n + 1);
                    if (t instanceof jn) {
                        return (t.tail_node() === e ? Y : L)(t, n + 1);
                    }
                    if (t instanceof Ye) return L(t, n + 1);
                    if (t instanceof gn) {
                        if (t.expression !== e) return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof Cn) {
                        if (t.operator == "delete") return e;
                        return Y(t, n + 1);
                    }
                    if (t instanceof An) return t.name.match_symbol(function(e) {
                        return e instanceof Zn && (b.name == e.name || _.name == e.name);
                    }) ? e : Y(t, n + 1);
                    if (t instanceof Ze) {
                        if (t.condition !== e) return e;
                        return Y(t, n + 1);
                    }
                    return null;
                }
                function L(e, n) {
                    var t = p.parent(n);
                    if (I(e, t)) return e;
                    if (H(e, t)) return e;
                    if (t instanceof Un) return L(t, n + 1);
                    if (t instanceof Rn) {
                        return D(t) ? e : L(t, n + 1);
                    }
                    if (t instanceof Hn) return L(t, n + 1);
                    if (t instanceof zn) return L(t, n + 1);
                    if (t instanceof wn) return L(t, n + 1);
                    if (t instanceof In) return L(t, n + 1);
                    if (t instanceof Sn) return L(t, n + 1);
                    if (t instanceof ln) return L(t, n + 1);
                    if (t instanceof mn) return L(t, n + 1);
                    if (t instanceof Xe) return e;
                    if (t instanceof Jn) {
                        var i = p.parent(n + 1);
                        return Fe(i.properties, function(e) {
                            return e instanceof Gn;
                        }) ? L(i, n + 2) : i;
                    }
                    if (t instanceof Mn) {
                        var r = t.expression;
                        if (r === e) return L(t, n + 1);
                        var o = me(r);
                        if (!(o instanceof st)) return L(t, n + 1);
                        var a = S.get(o.name);
                        return !a || Fe(a, function(e) {
                            return !(e instanceof Mn);
                        }) ? L(t, n + 1) : e;
                    }
                    if (t instanceof jn) return L(t, n + 1);
                    if (t instanceof Ye) return L(t, n + 1);
                    if (t instanceof gn) return L(t, n + 1);
                    if (t instanceof Cn) return L(t, n + 1);
                    if (t instanceof An) {
                        return D(t) ? e : L(t, n + 1);
                    }
                    return null;
                }
                function V(e) {
                    if (t) {
                        t = false;
                        return;
                    }
                    if (!(e instanceof st)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (pe(n)) return;
                    return _ = n;
                }
                function W(e) {
                    if (e instanceof An) {
                        var n = e.name.definition();
                        if (n.const_redefs) return;
                        if (!Ee(e.name, n.orig)) return;
                        var t = n.orig.length - n.eliminated - (s[n.name] || 0);
                        var i = n.references.length - n.replaced - (a[n.name] || 0);
                        if (t > 1 && !(e.name instanceof it)) {
                            V(e.value);
                            return ve(st, e.name, e.name);
                        }
                        if (V(e.value) || i == 1 && !c.exposed(n)) {
                            return ve(st, e.name, e.name);
                        }
                    } else if (e instanceof Rn) {
                        var n, r = e.left;
                        if (e.operator == "=" && r instanceof st && (n = r.definition()).references[0] === r && !c.exposed(n)) {
                            var i = n.references.length - n.replaced;
                            if (i > 1) V(e.right);
                        }
                        return r;
                    } else {
                        return e.expression;
                    }
                }
                function J(e) {
                    if (e instanceof Un) return false;
                    if (e instanceof Hn && be[e.operator]) {
                        return J(e.left) && J(e.right);
                    }
                    if (e instanceof zn) return false;
                    if (e instanceof In) {
                        return J(e.consequent) && J(e.alternative);
                    }
                    if (e instanceof Wn) return false;
                    return !e.has_side_effects(c);
                }
                function G(n) {
                    if (n instanceof Rn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new wt(function(e) {
                        if (e instanceof st) t[e.definition().id] = true;
                    });
                    while (n instanceof Rn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof st) {
                        var i = n.evaluate(c);
                        if (i === n) return o;
                        return X(i, o);
                    }
                    if (n instanceof ft) return o;
                    if (n.is_truthy()) return X(true, Te);
                    if (n.is_constant()) {
                        return X(n.evaluate(c), o);
                    }
                    if (!(b instanceof st)) return false;
                    if (!J(n)) return false;
                    var r;
                    n.walk(new wt(function(e) {
                        if (r) return true;
                        if (e instanceof st && t[e.definition().id]) r = true;
                    }));
                    return !r && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function X(t, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (t && e.is_truthy() && !e.has_side_effects(c)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                return !e.evaluate(c) == !t;
                            }
                        }
                        return i(e);
                    };
                }
                function K(e) {
                    if (e instanceof st) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Rn) return e.operator == "=" && K(e.right);
                    return e instanceof Mn || e instanceof ft;
                }
                function Q(i) {
                    var r = new Ce();
                    if (i instanceof An) r.add(i.name.name, b);
                    var o = ue.uses_arguments && !c.has_directive("use strict");
                    var a = ue instanceof on;
                    var s = new wt(function(e) {
                        var n;
                        if (e instanceof st) {
                            n = e.fixed_value() || e;
                        } else if (e instanceof ft) {
                            n = e;
                        }
                        if (n) r.add(e.name, le(c, s, e, n, 0));
                        if (o && e instanceof Fn) {
                            ue.each_argname(function(e) {
                                if (!c.option("reduce_vars") || e.definition().assignments) {
                                    r.add(e.name, true);
                                }
                            });
                            o = false;
                        }
                        if (!a) return;
                        if (e.TYPE == "Call") {
                            if (E) return;
                            var t = e.expression;
                            if (t instanceof Mn) return;
                            if (t instanceof fn && !t.contains_this()) return;
                            E = true;
                        } else if (e instanceof Mn && K(e.expression)) {
                            if (e === b && !(i instanceof Cn)) {
                                E = true;
                            } else {
                                k = true;
                            }
                        }
                    });
                    i.walk(s);
                    return r;
                }
                function Z(e) {
                    if (e.name instanceof it) {
                        var n = c.self().argnames.indexOf(e.name);
                        var t = c.parent().args;
                        if (t[n]) {
                            t[n] = ve(lt, t[n], {
                                value: 0
                            });
                            e.name.definition().fixed = false;
                        }
                        return true;
                    }
                    var i = d.length - 1;
                    if (d[i - 1].body === d[i]) i--;
                    var r = new Tt(function(e, n, t) {
                        if (z) return e;
                        if (e !== d[h]) return e;
                        h++;
                        if (h <= i) return N(e, r);
                        z = true;
                        if (e instanceof An) {
                            e.value = null;
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                            if (_) _.replaced++;
                            return e;
                        }
                        return t ? ze.skip : null;
                    }, ee);
                    $ = false;
                    z = false;
                    h = 0;
                    return o[l].transform(r);
                }
                function ee(e) {
                    if (e instanceof jn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return e.expressions[0];
                    }
                }
                function ne(e) {
                    var n = me(e);
                    return n instanceof st && n.definition().scope === ue && !(se && (S.has(n.name) && S.get(n.name)[0] !== e || v instanceof Cn || v instanceof Rn && v.operator != "="));
                }
                function te() {
                    if (v instanceof Cn) return false;
                    return r.has_side_effects(c);
                }
                function ie(e) {
                    if (e instanceof Cn) return false;
                    if (y) return false;
                    if (_) return true;
                    if (!(b instanceof st)) return false;
                    var n;
                    if (e instanceof An) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = b.definition();
                    return t.references.length - t.replaced == n;
                }
                function re(e, n) {
                    var t = S.get(e.name);
                    if (!t || Fe(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== b) return true;
                    x = false;
                }
                function oe(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof rt) return false;
                    if (n.scope !== ue) return true;
                    if (E && c.exposed(n)) return true;
                    return !Fe(n.references, function(e) {
                        return e.scope.resolve() === ue;
                    });
                }
                function ae(e, n) {
                    if (e instanceof Rn) return ae(e.left, true);
                    if (e instanceof Cn) return ae(e.expression, true);
                    if (e instanceof An) return e.value && ae(e.value);
                    if (n) {
                        if (e instanceof qn) return ae(e.expression, true);
                        if (e instanceof Fn) return ae(e.expression, true);
                        if (e instanceof st) return e.definition().scope !== ue;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof Je) {
                        if (Fe(i.body, function(e) {
                            return !(e instanceof Tn || e instanceof On);
                        })) {
                            ce = true;
                            r(i.body);
                            [].splice.apply(e, [ t, 1 ].concat(i.body));
                            t += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof Ue) {
                        if (Ee(i.value, n)) {
                            ce = true;
                            e.splice(t, 1);
                            continue;
                        }
                        n.push(i.value);
                    }
                    if (i instanceof Be) {
                        ce = true;
                        e.splice(t, 1);
                        continue;
                    }
                    t++;
                }
            }
            function o(t, r) {
                var o = r.self();
                var e = r.parent();
                var i = w(function(e) {
                    return e instanceof an;
                });
                var n = i && e && e.TYPE == "Call";
                var a = g(t);
                for (var s = t.length; --s >= 0; ) {
                    var f = t[s];
                    var u = T(s);
                    var c = t[u];
                    if (i && !c && f instanceof pn) {
                        if (!f.value) {
                            ce = true;
                            t.splice(s, 1);
                            continue;
                        }
                        if (f.value instanceof Nn && f.value.operator == "void") {
                            ce = true;
                            t[s] = ve(Ye, f, {
                                body: f.value.expression
                            });
                            continue;
                        }
                    }
                    if (f instanceof mn) {
                        var l = M(f.body);
                        if (k(l)) {
                            if (l.label) Me(l.label.thedef.references, l);
                            ce = true;
                            f = f.clone();
                            f.condition = f.condition.negate(r);
                            var p = S(f.body, l);
                            f.body = ve(Je, f, {
                                body: D(f.alternative).concat(E())
                            });
                            f.alternative = ve(Je, f, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (l && !f.alternative && f.body instanceof Je && c instanceof cn) {
                            var d = f.condition.negate(r);
                            if (d.print_to_string().length <= f.condition.print_to_string().length) {
                                ce = true;
                                f = f.clone();
                                f.condition = d;
                                t[u] = f.body;
                                f.body = c;
                                t[s] = f;
                                t[s] = f.transform(r);
                                continue;
                            }
                        }
                        var h = M(f.alternative);
                        if (k(h)) {
                            if (h.label) Me(h.label.thedef.references, h);
                            ce = true;
                            f = f.clone();
                            f.body = ve(Je, f.body, {
                                body: D(f.body).concat(E())
                            });
                            var p = S(f.alternative, h);
                            f.alternative = ve(Je, f.alternative, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (l && !h) {
                                F(f.condition, null, ve(Je, o, {
                                    body: t.slice(s + 1)
                                }));
                            }
                            if (!l && h) {
                                F(f.condition, ve(Je, o, {
                                    body: t.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof mn && f.body instanceof pn) {
                        var v = f.body.value;
                        var _ = f.body.in_bool || c instanceof pn && c.in_bool;
                        if (!v && !f.alternative && (i && !c || c instanceof pn && !c.value)) {
                            ce = true;
                            t[s] = ve(Ye, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if (!f.alternative && c instanceof pn) {
                            ce = true;
                            f = f.clone();
                            f.alternative = c;
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && i && (_ || v && a)) {
                            ce = true;
                            f = f.clone();
                            f.alternative = ve(pn, f, {
                                value: null
                            });
                            t.splice(s, 1, f.transform(r));
                            continue;
                        }
                        var m = t[O(s)];
                        if (r.option("sequences") && i && !f.alternative && (!m && n || m instanceof mn && m.body instanceof pn) && T(u) == t.length && c instanceof Ye) {
                            ce = true;
                            f = f.clone();
                            f.alternative = ve(Je, c, {
                                body: [ c, ve(pn, c, {
                                    value: null
                                }) ]
                            });
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                    }
                }
                function g(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof mn && i.body instanceof pn) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function b(e) {
                    return !e || e instanceof Nn && e.operator == "void";
                }
                function y(e, n) {
                    var t = e.lastIndexOf(n);
                    if (t < 0) return false;
                    while (++t < e.length) {
                        if (!z(e[t])) return false;
                    }
                    return true;
                }
                function w(e) {
                    var n = o, t, i = 0;
                    do {
                        do {
                            if (e(n)) return true;
                            n = r.parent(i++);
                        } while (n instanceof mn && (t = n));
                    } while ((n instanceof Je || n instanceof rn) && y(n.body, t));
                }
                function x(n) {
                    return w(function(e) {
                        return e === n;
                    });
                }
                function k(e) {
                    if (e instanceof pn) return i && b(e.value);
                    if (!(e instanceof hn)) return false;
                    var n = r.loopcontrol_target(e);
                    if (e instanceof _n) return x(A(n));
                    if (n instanceof Xe) return false;
                    return x(n);
                }
                function E() {
                    var e = t.slice(s + 1);
                    t.length = s + 1;
                    return e.filter(function(e) {
                        if (e instanceof un) {
                            t.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function S(e, n) {
                    var t = D(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) t.push(ve(Ye, n.value, {
                        body: n.value.expression
                    }));
                    return t;
                }
                function T(e) {
                    for (var n = e + 1; n < t.length; n++) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
                function O(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
            }
            function a(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, o = 0, a = n.length; r < a; r++) {
                    var s = n[r];
                    if (s instanceof hn) {
                        var f = t.loopcontrol_target(s);
                        if (s instanceof vn && !(f instanceof Xe) && A(f) === i || s instanceof _n && A(f) === i) {
                            if (s.label) Me(s.label.thedef.references, s);
                        } else {
                            n[o++] = s;
                        }
                    } else {
                        n[o++] = s;
                    }
                    if (M(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = o;
                ce = o != a;
                if (e) e.forEach(function(e) {
                    k(t, e, n);
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = V(t[0], t);
                    n[i++] = ve(Ye, e, {
                        body: e
                    });
                    t = [];
                }
                for (var o = 0, a = n.length; o < a; o++) {
                    var s = n[o];
                    if (s instanceof Ye) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) _(t, f);
                    } else if (z(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != a) ce = true;
            }
            function p(e, n) {
                if (!(e instanceof Je)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof Dn && m(r)) {
                        n.push(r);
                    } else if (t || r instanceof Tn || r instanceof On) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    ce = true;
                    var n = r.body;
                    return V(n, [ n, e ]);
                }
                var i = 0, r;
                for (var o = 0; o < e.length; o++) {
                    var a = e[o];
                    if (r) {
                        if (a instanceof ln) {
                            a.value = t(a.value || ve(vt, a)).transform(n);
                        } else if (a instanceof en) {
                            if (!(a.init instanceof Sn)) {
                                var s = false;
                                r.body.walk(new wt(function(e) {
                                    if (s || e instanceof rn) return true;
                                    if (e instanceof Hn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (a.init) a.init = t(a.init); else {
                                        a.init = r.body;
                                        i--;
                                        ce = true;
                                    }
                                }
                            }
                        } else if (a instanceof nn) {
                            a.object = t(a.object);
                        } else if (a instanceof mn) {
                            a.condition = t(a.condition);
                        } else if (a instanceof gn) {
                            a.expression = t(a.expression);
                        } else if (a instanceof tn) {
                            a.expression = t(a.expression);
                        }
                    }
                    if (n.option("conditionals") && a instanceof mn) {
                        var f = [];
                        var u = p(a.body, f);
                        var c = p(a.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(ve(mn, a, {
                                condition: a.condition,
                                body: u || ve(Be, a.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            o += l;
                            i += l + 1;
                            r = null;
                            ce = true;
                            continue;
                        }
                    }
                    e[i++] = a;
                    r = a instanceof Ye ? a : null;
                }
                e.length = i;
            }
            function c(e, n, t) {
                var i;
                if (n instanceof Rn) {
                    i = [ n ];
                } else if (n instanceof jn) {
                    i = n.expressions.slice();
                }
                if (!i) return;
                var r = false;
                for (var o = i.length - 1; --o >= 0; ) {
                    var a = i[o];
                    if (!(a instanceof Rn)) continue;
                    if (a.operator != "=") continue;
                    if (!(a.left instanceof st)) continue;
                    var s = i.slice(o + 1);
                    if (!h(a.left, a.right, s)) continue;
                    r = true;
                    i = i.slice(0, o + 1).concat(s);
                }
                if (e instanceof Sn) {
                    t = t || 0;
                    for (var o = e.definitions.length; --o >= 0; ) {
                        var f = e.definitions[o];
                        if (!f.value) continue;
                        if (h(f.name, f.value, i)) r = true;
                        if (l(f, i, t)) r = true;
                        break;
                    }
                    if (e instanceof Dn && d(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function l(e, n, t) {
                if (!f.option("conditionals")) return;
                if (e.name instanceof Bn) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var o = P(f, r, e.value, n[0]);
                    if (!o) break;
                    e.value = o;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function d(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof Rn)) break;
                    if (r.operator != "=") break;
                    var o = r.left;
                    if (!(o instanceof st)) break;
                    if (X(o)) break;
                    if (o.scope.resolve() !== ue) break;
                    var a = o.definition();
                    if (a.scope !== ue) break;
                    if (a.orig.length > a.eliminated + 1) break;
                    if (a.orig[0].TYPE != "SymbolVar") break;
                    var s = ve(tt, o, o);
                    e.push(ve(An, r, {
                        name: s,
                        value: r.right
                    }));
                    a.orig.push(s);
                    a.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function h(e, n, t) {
                if (!(n instanceof Wn)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof Rn)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof Mn)) break;
                    var o = r.left.expression;
                    if (!(o instanceof st)) break;
                    if (e.name != o.name) break;
                    if (!r.right.is_constant_expression(ue)) break;
                    var a = r.left.property;
                    if (a instanceof He) {
                        a = a.evaluate(f);
                    }
                    if (a instanceof He) break;
                    a = "" + a;
                    var s = a == "__proto__" || f.has_directive("use strict") ? function(e) {
                        return typeof e.key == "string" && e.key != a;
                    } : function(e) {
                        if (e instanceof Kn || e instanceof Xn) {
                            return typeof e.key == "string" && e.key != a;
                        }
                        return true;
                    };
                    if (!Fe(n.properties, s)) break;
                    n.properties.push(ve(Gn, r, {
                        key: a,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function v(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var o = e[t];
                    if (i instanceof Sn) {
                        if (o && o.TYPE == i.TYPE) {
                            o.definitions = o.definitions.concat(i.definitions);
                            ce = true;
                        } else if (r && r.TYPE == i.TYPE && m(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            ce = true;
                        } else {
                            e[++t] = i;
                            if (i instanceof Dn) r = i;
                        }
                        continue;
                    } else if (i instanceof ln) {
                        i.value = f(i.value);
                    } else if (i instanceof en) {
                        var a = c(o, i.init);
                        if (a) {
                            ce = true;
                            i.init = a.length ? V(i.init, a) : null;
                        } else if (o instanceof Dn && (!i.init || i.init.TYPE == o.TYPE)) {
                            if (i.init) {
                                o.definitions = o.definitions.concat(i.init.definitions);
                            }
                            r = i.init = o;
                            e[t] = u(i);
                            ce = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && m(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            ce = true;
                        } else if (i.init instanceof Dn) {
                            r = i.init;
                        }
                    } else if (i instanceof nn) {
                        if (r && r.TYPE == i.init.TYPE) {
                            var s = r.definitions.slice();
                            i.init = i.init.definitions[0].name.convert_symbol(st, function(e, n) {
                                s.push(ve(An, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            r.definitions = s;
                            ce = true;
                        }
                        i.object = f(i.object);
                    } else if (i instanceof mn) {
                        i.condition = f(i.condition);
                    } else if (i instanceof Ye) {
                        var a = c(o, i.body);
                        if (a) {
                            ce = true;
                            if (!a.length) continue;
                            i.body = V(i.body, a);
                        }
                    } else if (i instanceof gn) {
                        i.expression = f(i.expression);
                    } else if (i instanceof tn) {
                        i.expression = f(i.expression);
                    }
                    e[++t] = r ? u(i) : i;
                }
                e.length = t + 1;
                function f(e) {
                    var n = c(o, e, 1);
                    if (!n) return e;
                    ce = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return V(e, n);
                }
                function u(e) {
                    return e.transform(new Tt(function(e, n, t) {
                        if (e instanceof Sn) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof nn && i.init === e) return e;
                            if (!m(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            ce = true;
                            if (i instanceof en && i.init === e) return null;
                            return t ? ze.skip : ve(Be, e);
                        }
                        if (e instanceof rn) return e;
                        if (!(e instanceof Ie)) return e;
                    }));
                }
            }
        }
        function k(r, o, a) {
            if (!(o instanceof Sn || o instanceof un)) {
                He.warn("Dropping unreachable code [{file}:{line},{col}]", o.start);
            }
            var s;
            o.walk(new wt(function(e, n) {
                if (e instanceof Sn) {
                    var t = [];
                    if (e.remove_initializers(r, t)) {
                        He.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        f(e);
                    }
                    return true;
                }
                if (e instanceof un) {
                    f(e);
                    return true;
                }
                if (e instanceof rn) return true;
                if (e instanceof Le) {
                    var i = s;
                    s = [];
                    n();
                    if (s.required) {
                        a.push(ve(Je, o, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(a, s);
                    }
                    s = i;
                    return true;
                }
            }));
            function f(e) {
                if (s) {
                    s.push(e);
                    if (e instanceof Tn || e instanceof On) s.required = true;
                } else {
                    a.push(e);
                }
            }
        }
        function $(e, n) {
            return e.is_undefined || e instanceof vt || e instanceof Nn && e.operator == "void" && !e.expression.has_side_effects(n);
        }
        (function(e) {
            e(He, Te);
            e(Un, Oe);
            e(Rn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(an, Oe);
            e(Wn, Oe);
            e(pt, Oe);
            e(jn, function() {
                return this.tail_node().is_truthy();
            });
            e(st, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = Te;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(He, Oe);
            e(Un, Te);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof ut) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                    return true;

                  default:
                    return false;
                }
            }
            e(Rn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(Hn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(ut, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(an, Te);
            e(Wn, Te);
            e(pt, Te);
            e(jn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(st, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = Oe;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(Nn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            He.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function t(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(He, t);
            e(Un, Te);
            e(Rn, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof st)) return true;
                if (n instanceof Hn && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(Hn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(In, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(ut, Te);
            e(qn, function(e) {
                if (!t(e)) return false;
                var n = this.expression;
                if (n instanceof st) n = n.fixed_value();
                return !(n instanceof an && this.property == "prototype");
            });
            e(an, Te);
            e(dt, Oe);
            e(Wn, function(e) {
                return t(e) && !Fe(this.properties, function(e) {
                    return e instanceof Gn;
                });
            });
            e(jn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(st, function(e) {
                if (this.is_undefined) return true;
                if (!t(e)) return false;
                if (X(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                if (pe(this.definition())) return false;
                var n = this.fixed_value();
                if (!n) return true;
                this._dot_throw = Oe;
                if (n._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = Te;
                return false;
            });
            e(ft, function(e) {
                return t(e) && !this.scope.new;
            });
            e(Nn, function() {
                return this.operator == "void";
            });
            e(Pn, Te);
            e(vt, Oe);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(He, Te);
            e(Un, Oe);
            e(Rn, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(Hn, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(In, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(ut, Oe);
            e(an, Oe);
            e(Wn, Oe);
            e(jn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(st, function(e) {
                if (this.is_undefined) return false;
                if (X(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = Te;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(Nn, function() {
                return this.operator != "void";
            });
            e(Pn, Oe);
            e(vt, Te);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(He, Te);
            e(Rn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = qe("in instanceof == != === !== < <= >= >");
            e(Hn, function(e) {
                return n[this.operator] || be[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(gt, Oe);
            var t = qe("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(zn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof qn && (t[n.property] || n.property == "test" && n.expression instanceof pt);
            });
            e(In, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e($n, Te);
            e(jn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(st, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = Te;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = qe("! delete");
            e(Nn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(He, Te);
            var n = qe("- * / % & | ^ << >> >>>");
            e(Rn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(Hn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = qe([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(zn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof qn && (t[n.property] || X(n.expression) && n.expression.name == "Math");
            });
            e(In, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e($n, Te);
            e(lt, Oe);
            e(jn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(st, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = Te;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = qe("+ - ~ ++ --");
            e(Cn, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(He, Te);
            e(Rn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(Hn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = qe([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(zn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof qn && t[n.property];
            });
            e(In, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(jn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(ct, Oe);
            e(st, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = Te;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Nn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var be = qe("&& ||");
        var ye = qe("++ --");
        var j = qe("delete ++ --");
        function we(e, n) {
            if (n instanceof Rn) return n.left === e && e;
            if (n instanceof Bn) return e;
            if (n instanceof Ln) return e;
            if (n instanceof Cn) return j[n.operator] && n.expression;
        }
        (function(e) {
            function r(e, n) {
                if (e instanceof He) return e.clone(true);
                if (Array.isArray(e)) return ve(Un, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (Ne(e, i)) {
                        t.push(ve(Gn, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return ve(Wn, n, {
                        properties: t
                    });
                }
                return O(e, n);
            }
            function a(e) {
                He.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            on.DEFMETHOD("resolve_defines", function(o) {
                if (!o.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: o.option("ie8")
                });
                return this.transform(new Tt(function(e) {
                    var n = e._find_defs(o, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof Mn)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (we(i, r)) {
                        a(e);
                        return;
                    }
                    return n;
                }));
            });
            e(He, Se);
            e(qn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(Zn, function(e) {
                if (!this.definition().global) return;
                if (Ne(e.option("global_defs"), this.name)) a(this);
            });
            e(st, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (Ne(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function Q(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function o(e, n, t) {
            return Q(ve(Ye, e, {
                body: e
            }), ve(Ye, n, {
                body: n
            }), t).body;
        }
        function Z(e, n, t, i) {
            return (Pe(e) ? o : Q)(n, t, i);
        }
        function r(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = qe(n[e]);
            });
            return t;
        }
        an.DEFMETHOD("first_statement", function() {
            var e = this.body;
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof Ue)) return t;
            }
        });
        function ee(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = O(t, n).optimize(e);
            return Z(e, n, t, e.eval_threshold);
        }
        var s = [ "constructor", "toString", "valueOf" ];
        var g = r({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(s),
            Boolean: s,
            Function: s,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(s),
            Object: s,
            RegExp: [ "exec", "test" ].concat(s),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(s)
        });
        var b = r({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            He.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var n = qe("! ~ - + void");
            He.DEFMETHOD("is_constant", function() {
                if (this instanceof ut) {
                    return !(this instanceof pt);
                } else {
                    return this instanceof Nn && this.expression instanceof ut && n[this.operator];
                }
            });
            var u = new wt(function(e) {
                if (e instanceof Rn) c(e.left);
                if (e instanceof Cn && ye[e.operator]) c(e.expression);
            });
            function c(e) {
                if (e instanceof Mn) {
                    c(e.expression);
                } else if (e instanceof st) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(Ie, function() {
                throw new Error(je("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(sn, De);
            e(He, De);
            e(ut, function() {
                return this.value;
            });
            e(Rn, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof st)) return this;
                    if (!Ne(r, "_eval")) {
                        if (!r.fixed) return this;
                        var o = r.definition();
                        if (!o.fixed) return this;
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                        if (o.single_use == "m") return this;
                    }
                }
                var a = this.operator;
                var s;
                if (!Ne(r, "_eval") && r instanceof st && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (a == "=") {
                    r.walk(u);
                    s = this.right;
                } else {
                    s = ve(Hn, this, {
                        operator: a.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                c(r);
                return f;
            });
            e(jn, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var o = 0, a = r.length - 1; o < a; o++) {
                    r[o].walk(u);
                }
                var s = r[a];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(an, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Un, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var o = 0; o < this.elements.length; o++) {
                        var a = this.elements[o];
                        if (a instanceof _t) return this;
                        var s = a._eval(e, n, t, i);
                        if (a === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(Wn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var o = 0; o < this.properties.length; o++) {
                        var a = this.properties[o];
                        if (!(a instanceof Gn)) return this;
                        var s = a.key;
                        if (s instanceof He) {
                            s = s._eval(e, n, t, i);
                            if (s === a.key) return this;
                        }
                        if (a.value instanceof fn && typeof Object.prototype[s] == "function") return this;
                        r[s] = a.value._eval(e, n, t, i);
                        if (r[s] === a.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var f = qe("! typeof void");
            e(Nn, function(e, n, t, i) {
                var r = this.expression;
                var o = this.operator;
                if (e.option("typeofs") && o == "typeof" && (r instanceof an || r instanceof st && r.fixed_value() instanceof an)) {
                    return typeof function() {};
                }
                var a = r instanceof st && r.definition();
                if (!f[o] && !(a && a.fixed)) i++;
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && o == "void") return;
                    return this;
                }
                switch (o) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!a) return this;
                    if (!n) {
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                    if (Ne(r, "_eval")) s = +(o[0] + 1) + +s;
                    c(r);
                    return s;
                }
                return this;
            });
            e(Pn, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof st)) {
                    if (!n) return this;
                } else if (!Ne(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var o = r.definition();
                        if (!o.fixed) return this;
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof st && r.definition().fixed)) i++;
                var a = r._eval(e, n, t, i);
                if (a === r) return this;
                c(r);
                return +a;
            });
            var l = qe("&& || === !==");
            e(Hn, function(e, n, t, i) {
                if (!l[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var o = n && !(r && typeof r == "object");
                var a = this.right._eval(e, o, t, i);
                if (a === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && a;
                    break;

                  case "||":
                    s = r || a;
                    break;

                  case "|":
                    s = r | a;
                    break;

                  case "&":
                    s = r & a;
                    break;

                  case "^":
                    s = r ^ a;
                    break;

                  case "+":
                    s = r + a;
                    break;

                  case "-":
                    s = r - a;
                    break;

                  case "*":
                    s = r * a;
                    break;

                  case "/":
                    s = r / a;
                    break;

                  case "%":
                    s = r % a;
                    break;

                  case "<<":
                    s = r << a;
                    break;

                  case ">>":
                    s = r >> a;
                    break;

                  case ">>>":
                    s = r >>> a;
                    break;

                  case "==":
                    s = r == a;
                    break;

                  case "===":
                    s = r === a;
                    break;

                  case "!=":
                    s = r != a;
                    break;

                  case "!==":
                    s = r !== a;
                    break;

                  case "<":
                    s = r < a;
                    break;

                  case "<=":
                    s = r <= a;
                    break;

                  case ">":
                    s = r > a;
                    break;

                  case ">=":
                    s = r >= a;
                    break;

                  case "in":
                    if (a && typeof a == "object" && Ne(a, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(tn) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(a));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(In, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var o = r ? this.consequent : this.alternative;
                var a = o._eval(e, n, t, i);
                return a === o ? this : a;
            });
            function a(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new wt(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof rn) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(st, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var o;
                if (Ne(r, "_eval")) {
                    o = r._eval();
                } else {
                    this._eval = De;
                    o = r._eval(e, n, t, i);
                    delete this._eval;
                    if (o === r) return this;
                    r._eval = function() {
                        return o;
                    };
                    t.push(r);
                }
                return o && typeof o == "object" && !a(this, i) ? this : o;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var p = r({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var d = qe("global ignoreCase multiline source");
            e(Mn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var o = this.expression;
                    if (!X(o)) {
                        r = o._eval(e, n, t, i + 1);
                        if (r == null || r === o) return this;
                    }
                    var a = this.property;
                    if (a instanceof He) {
                        a = a._eval(e, n, t, i);
                        if (a === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = p[o.name];
                        if (!s || !s[a]) return this;
                        r = _[o.name];
                    } else if (r instanceof RegExp) {
                        if (!d[a]) return this;
                    } else if (typeof r == "object") {
                        if (!Ne(r, a)) return this;
                    } else if (typeof r == "function") switch (a) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.argnames.length;

                      default:
                        return this;
                    }
                    return r[a];
                }
                return this;
            });
            e(zn, function(o, a, s, f) {
                var e = this.expression;
                var n = e instanceof st ? e.fixed_value() : e;
                if (n instanceof an) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(o)) return this;
                    if (!Fe(n.argnames, function(e) {
                        return !(e instanceof Bn);
                    })) return this;
                    var r = v(this.args);
                    if (!r && !a) return this;
                    var t = n.first_statement();
                    if (!(t instanceof pn)) {
                        if (a) {
                            var i = false;
                            n.walk(new wt(function(e) {
                                if (i) return true;
                                if (e instanceof pn) {
                                    if (e.value && e.value._eval(o, true, s, f) !== undefined) {
                                        i = true;
                                    }
                                    return true;
                                }
                                if (e instanceof rn && e !== n) return true;
                            }));
                            if (!i) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!r || Fe(n.argnames, function(e, n) {
                        var t = r[n];
                        var i = e.definition();
                        if (i.orig[i.orig.length - 1] !== e) return false;
                        i.references.forEach(function(e) {
                            e._eval = function() {
                                return t;
                            };
                            c.push(e);
                        });
                        return true;
                    }) || a) {
                        n.evaluating = true;
                        u = u._eval(o, a, s, f);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (o.option("unsafe") && e instanceof Mn) {
                    var l = e.property;
                    if (l instanceof He) {
                        l = l._eval(o, a, s, f);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (X(p)) {
                        var d = b[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(o, a, s, f + 1);
                        if (u == null || u === p) return this;
                        var h = g[u.constructor.name];
                        if (!h || !h[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof pt)) return this;
                    }
                    var r = v(this.args);
                    if (!r) return this;
                    if (l == "replace" && typeof r[1] == "function") return this;
                    try {
                        return u[l].apply(u, r);
                    } catch (e) {
                        He.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e) {
                    var n = [];
                    for (var t = 0; t < e.length; t++) {
                        var i = e[t];
                        var r = i._eval(o, a, s, f);
                        if (i === r) return;
                        n.push(r);
                    }
                    return n;
                }
            });
            e($n, De);
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function o(e) {
                return ve(Nn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = o(e);
                if (t) {
                    var r = ve(Ye, n, {
                        body: n
                    });
                    return Q(i, r) === r ? n : i;
                }
                return Q(i, n);
            }
            e(He, function() {
                return o(this);
            });
            e(Ie, function() {
                throw new Error("Cannot negate a statement");
            });
            e(fn, function() {
                return o(this);
            });
            e(Nn, function() {
                if (this.operator == "!") return this.expression;
                return o(this);
            });
            e(jn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return V(this, n);
            });
            e(In, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(Hn, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return o(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var f = qe("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        zn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (X(n) && f[n.name]) return true;
                if (n instanceof qn && X(n.expression)) {
                    var t = b[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        He.DEFMETHOD("is_call_pure", Te);
        zn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof qn)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof Un) {
                i = g.Array;
            } else if (t.is_boolean(e)) {
                i = g.Boolean;
            } else if (t.is_number(e)) {
                i = g.Number;
            } else if (t instanceof pt) {
                i = g.RegExp;
            } else if (t.is_string(e)) {
                i = g.String;
                if (r == "replace") {
                    var o = this.args[1];
                    if (o && !o.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = g.Object;
            }
            return i && i[r];
        });
        (function(e) {
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].has_side_effects(n)) return true;
                return false;
            }
            e(He, Oe);
            e(Un, function(e) {
                return n(this.elements, e);
            });
            e(Rn, function(e) {
                var n = this.left;
                if (!(n instanceof Mn)) return true;
                var t = n.expression;
                return !(t instanceof ft) || !t.scope.new || n instanceof Fn && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Hn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !xe(this.right);
            });
            e(We, function(e) {
                return n(this.body, e);
            });
            e(zn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e);
            });
            e(wn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(In, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(ut, Te);
            e(Sn, function(e) {
                return n(this.definitions, e);
            });
            e(Yn, function(e) {
                return n(this.elements, e);
            });
            e(Ln, function(e) {
                return this.key instanceof He && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Vn, function(e) {
                return n(this.properties, e);
            });
            e(qn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Be, Te);
            e(mn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(Ge, function(e) {
                return this.body.has_side_effects(e);
            });
            e(an, Te);
            e(Wn, function(e) {
                return n(this.properties, e);
            });
            e(Jn, function(e) {
                return this.key instanceof He && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Fn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(jn, function(e) {
                return n(this.expressions, e);
            });
            e(Ye, function(e) {
                return this.body.has_side_effects(e);
            });
            e(gn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(Zn, Te);
            e(st, function(e) {
                return !this.is_declared(e) || !de(this);
            });
            e(ft, Te);
            e(xn, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(Cn, function(e) {
                return j[this.operator] || this.expression.has_side_effects(e);
            });
            e(An, function(e) {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(He, Oe);
            e(ut, Te);
            e(Be, Te);
            e(an, Te);
            e(Zn, Te);
            e(ft, Te);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(Un, function(e) {
                return n(this.elements, e);
            });
            e(Rn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof st) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(Hn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !xe(this.right);
            });
            e(We, function(e) {
                return n(this.body, e);
            });
            e(zn, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof an) || n(this.expression.body, e);
            });
            e(wn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(In, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Sn, function(e) {
                return n(this.definitions, e);
            });
            e(qn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(mn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(Ge, function(e) {
                return this.body.may_throw(e);
            });
            e(Wn, function(e) {
                return n(this.properties, e);
            });
            e(Jn, function(e) {
                return this.key instanceof He && this.key.may_throw(e) || this.value.may_throw(e);
            });
            e(pn, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(jn, function(e) {
                return n(this.expressions, e);
            });
            e(Ye, function(e) {
                return this.body.may_throw(e);
            });
            e(Fn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(gn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(st, function(e) {
                return !this.is_declared(e);
            });
            e(xn, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(Cn, function(e) {
                if (this.operator == "typeof" && this.expression instanceof st) return false;
                return this.expression.may_throw(e);
            });
            e(An, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(He, Te);
            e(Un, function() {
                return n(this.elements);
            });
            e(Hn, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression() && (this.operator != "in" || xe(this.right));
            });
            e(ut, Oe);
            e(an, function(r) {
                var o = this;
                var a = true;
                var s = [];
                o.walk(new wt(function(e, n) {
                    if (!a) return true;
                    if (e instanceof Le) {
                        if (e === o) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof st) {
                        if (o.inlined || e.redef) {
                            a = false;
                            return true;
                        }
                        if (o.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Ee(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e);
                            if (t.undeclared ? !i : i === t) {
                                a = "f";
                                return true;
                            }
                        }
                        a = false;
                        return true;
                    }
                }));
                return a;
            });
            e(Wn, function() {
                return n(this.properties);
            });
            e(Jn, function() {
                return typeof this.key == "string" && this.value.is_constant_expression();
            });
            e(Cn, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function M(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Ie, Ae);
            e(cn, De);
            function n() {
                var e = this.body.length;
                return e > 0 && M(this.body[e - 1]);
            }
            e(Je, n);
            e(bn, n);
            e(mn, function() {
                return this.alternative && M(this.body) && M(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var c = qe([ "use asm", "use strict" ]);
        e(Ue, function(e, n) {
            if (n.option("directives") && (!c[e.value] || n.has_directive(e.value) !== e)) {
                return ve(Be, e);
            }
            return e;
        });
        e(Re, function(e, n) {
            if (n.option("drop_debugger")) return ve(Be, e);
            return e;
        });
        e(Ge, function(e, n) {
            if (n.option("dead_code") && e.body instanceof vn && n.loopcontrol_target(e.body) === e.body) {
                return ve(Be, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(We, function(e, n) {
            e.body = u(e.body, n);
            return e;
        });
        function p(e) {
            switch (e.body.length) {
              case 0:
                return ve(Be, e);

              case 1:
                var n = e.body[0];
                if (!(n instanceof Tn || n instanceof On)) return n;
            }
            return e;
        }
        e(Je, function(e, n) {
            e.body = u(e.body, n);
            return p(e);
        });
        e(fn, function(n, e) {
            n.body = u(n.body, e);
            if (e.option("inline")) for (var t = 0; t < n.body.length; t++) {
                var i = n.body[t];
                if (i instanceof Ue) continue;
                if (i instanceof pn) {
                    var r = i.value;
                    if (!r || r.TYPE != "Call") break;
                    if (r.is_expr_pure(e)) break;
                    var o = r.expression;
                    if (o instanceof st) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof an)) break;
                    if (o.uses_arguments) break;
                    if (o === r.expression) {
                        if (o.parent_scope !== n) break;
                        if (!Fe(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.contains_this()) break;
                    var a = o.argnames.length;
                    if (a > 0 && e.option("inline") < 2) break;
                    if (a > n.argnames.length) break;
                    for (var s = 0; s < a; s++) {
                        var f = r.args[s];
                        if (!(f instanceof st)) break;
                        if (f.definition() !== n.argnames[s].definition()) break;
                    }
                    if (s < a) break;
                    for (;s < r.args.length; s++) {
                        if (r.args[s].has_side_effects(e)) break;
                    }
                    if (s < r.args.length) break;
                    if (a < n.argnames.length && !e.drop_fargs(n, e.parent())) {
                        if (!e.drop_fargs(o, r)) break;
                        do {
                            o.argnames.push(o.make_var(it, o, "argument_" + a));
                        } while (++a < n.argnames.length);
                    }
                    return r.expression;
                }
                break;
            }
            return n;
        });
        rn.DEFMETHOD("merge_variables", function(a) {
            if (!a.option("merge_vars")) return;
            var l = this, p = {}, d;
            var s = [], f = [], u = 0;
            var h = new Ce();
            var v = Object.create(null);
            var c = Object.create(null);
            var _ = new wt(function(r, e) {
                if (r instanceof Rn) {
                    var n = r.left;
                    if (n instanceof Bn) {
                        r.right.walk(_);
                        var t = new wt(function(e) {
                            if (e instanceof Bn) return;
                            if (e instanceof Ln) {
                                if (e.key instanceof He) {
                                    w();
                                    e.key.walk(_);
                                    x();
                                    w();
                                    e.value.walk(t);
                                    x();
                                } else {
                                    e.value.walk(t);
                                }
                            } else if (e instanceof st) {
                                k(e, false, true);
                            } else {
                                e.walk(_);
                            }
                            return true;
                        });
                        n.walk(t);
                        return true;
                    }
                    if (n instanceof st) {
                        if (r.operator != "=") k(n, true, false);
                        r.right.walk(_);
                        k(n, false, true);
                        return true;
                    }
                    return;
                }
                if (r instanceof Hn) {
                    if (!be[r.operator]) return;
                    r.left.walk(_);
                    w();
                    r.right.walk(_);
                    x();
                    return true;
                }
                if (r instanceof vn) {
                    var i = _.loopcontrol_target(r);
                    if (!(i instanceof Xe)) E(i);
                    return true;
                }
                if (r instanceof zn) {
                    var o = r.expression;
                    var a = o.tail_node();
                    if (!(a instanceof fn)) return;
                    if (o !== a) o.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(_);
                    });
                    r.args.forEach(function(e) {
                        e.walk(_);
                    });
                    a.walk(_);
                    return true;
                }
                if (r instanceof In) {
                    r.condition.walk(_);
                    w();
                    r.consequent.walk(_);
                    x();
                    w();
                    r.alternative.walk(_);
                    x();
                    return true;
                }
                if (r instanceof _n) {
                    var i = _.loopcontrol_target(r);
                    if (i instanceof Qe) E(i);
                    return true;
                }
                if (r instanceof Qe) {
                    w();
                    p.block = r;
                    p.loop = true;
                    var s = p;
                    r.body.walk(_);
                    if (p.inserted === r) p = s;
                    r.condition.walk(_);
                    x();
                    return true;
                }
                if (r instanceof en) {
                    if (r.init) r.init.walk(_);
                    w();
                    p.block = r;
                    p.loop = true;
                    if (r.condition) r.condition.walk(_);
                    r.body.walk(_);
                    if (r.step) r.step.walk(_);
                    x();
                    return true;
                }
                if (r instanceof nn) {
                    r.object.walk(_);
                    w();
                    p.block = r;
                    p.loop = true;
                    r.init.walk(_);
                    r.body.walk(_);
                    x();
                    return true;
                }
                if (r instanceof mn) {
                    r.condition.walk(_);
                    w();
                    r.body.walk(_);
                    x();
                    if (r.alternative) {
                        w();
                        r.alternative.walk(_);
                        x();
                    }
                    return true;
                }
                if (r instanceof Ge) {
                    w();
                    p.block = r;
                    var s = p;
                    r.body.walk(_);
                    if (p.inserted === r) p = s;
                    x();
                    return true;
                }
                if (r instanceof rn) {
                    w();
                    p.block = r;
                    if (r === l) d = p;
                    if (r instanceof an) {
                        if (r.name) v[r.name.definition().id] = false;
                        var t = r.uses_arguments && !_.has_directive("use strict") ? function(e) {
                            if (e instanceof it) v[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof it) k(e, false, true);
                        };
                        var f = new wt(function(e) {
                            if (!(e instanceof st)) return;
                            var n = e.definition();
                            var t = r.variables.get(e.name);
                            if (t && (t === n || n.undeclared || r.parent_scope.find_variable(e) === n)) {
                                v[n.id] = false;
                                v[t.id] = false;
                            } else {
                                var i = p;
                                x();
                                k(e, true, false);
                                p = i;
                            }
                            return true;
                        });
                        r.argnames.forEach(function(e) {
                            e.mark_symbol(t, f);
                        });
                    }
                    Ve(r, _);
                    x();
                    return true;
                }
                if (r instanceof gn) {
                    r.expression.walk(_);
                    var s = p;
                    r.body.forEach(function(e) {
                        if (e instanceof yn) return;
                        e.expression.walk(_);
                        if (s === p) w();
                    });
                    p = s;
                    r.body.forEach(function(e) {
                        w();
                        p.block = r;
                        var n = p;
                        Ve(e, _);
                        if (p.inserted === r) p = n;
                        x();
                    });
                    return true;
                }
                if (r instanceof st) {
                    k(r, true, false);
                    return true;
                }
                if (r instanceof xn) {
                    w();
                    p.block = r;
                    Ve(r, _);
                    x();
                    if (r.bcatch) {
                        if (r.bcatch.argname) {
                            var u = r.bcatch.argname.definition();
                            v[u.id] = false;
                            if (u = u.redefined()) v[u.id] = false;
                        }
                        w();
                        if (r.bfinally) p.block = r.bcatch;
                        Ve(r.bcatch, _);
                        x();
                    }
                    if (r.bfinally) r.bfinally.walk(_);
                    return true;
                }
                if (r instanceof Cn) {
                    if (!ye[r.operator]) return;
                    var c = r.expression;
                    if (!(c instanceof st)) return;
                    k(c, true, true);
                    return true;
                }
                if (r instanceof An) {
                    if (r.value) r.value.walk(_);
                    r.name.mark_symbol(r.value ? function(e) {
                        if (!(e instanceof Zn)) return;
                        if (e instanceof tt) {
                            k(e, false, true);
                        } else {
                            v[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof Zn)) return;
                        var n = e.definition().id;
                        if (!(e instanceof tt)) {
                            v[n] = false;
                        } else if (!(n in v)) {
                            h.add(n, e);
                        } else if (v[n]) {
                            v[n].push(e);
                        }
                        return true;
                    }, _);
                    return true;
                }
                if (r instanceof Ze) {
                    w();
                    p.block = r;
                    p.loop = true;
                    e();
                    x();
                    return true;
                }
            });
            _.directives = Object.create(a.directives);
            l.walk(_);
            var e = Object.create(null);
            while (s.length && f.length) {
                var n = s.pop();
                var t = n.definition;
                if (!(t.id in c)) continue;
                if (!v[t.id]) continue;
                var i = {
                    start: v[t.id].start
                };
                while (t.id in e) t = e[t.id];
                i.end = v[t.id].end;
                var r = [];
                do {
                    var o = f.pop();
                    if (!o) continue;
                    if (o.index > n.index) continue;
                    var m = o.definition.id;
                    var g = v[m];
                    if (!g) continue;
                    if (i.start.block !== g.start.block || !T(i, g) || i.start.loop && !T(g, i) || !Fe(g, function(e) {
                        return e.scope.find_variable(t.name) === t;
                    })) {
                        r.unshift(o);
                        continue;
                    }
                    var b = [], y = [];
                    g.forEach(function(e) {
                        e.thedef = t;
                        e.name = t.name;
                        if (e instanceof st) {
                            y.push(e);
                        } else {
                            b.push(e);
                        }
                    });
                    t.orig = b.concat(t.orig);
                    t.references = y.concat(t.references);
                    t.fixed = o.definition.fixed && t.fixed;
                    e[m] = t;
                    break;
                } while (f.length);
                if (r.length) f = f.concat(r);
            }
            function w() {
                p = Object.create(p);
            }
            function x() {
                p = Object.getPrototypeOf(p);
            }
            function k(e, n, t) {
                var i = e.definition(), r;
                if (i.id in v) {
                    var o = v[i.id];
                    if (!o) return;
                    if (o.start.block !== p.block) return v[i.id] = false;
                    o.push(e);
                    o.end = p;
                    if (i.id in c) {
                        f[c[i.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((r = l.variables.get(i.name)) !== i) {
                    if (r && d === p) v[r.id] = false;
                    return v[i.id] = false;
                } else if (a.exposed(i) || e.name == "arguments") {
                    return v[i.id] = false;
                } else {
                    var o = h.get(i.id) || [];
                    o.push(e);
                    v[i.id] = o;
                    if (!n) {
                        o.start = p;
                        return s.push({
                            index: u++,
                            definition: i
                        });
                    }
                    if (p.block !== l) return v[i.id] = false;
                    o.start = d;
                }
                c[i.id] = f.length;
                f.push({
                    index: u++,
                    definition: i
                });
            }
            function E(e) {
                var n = [];
                while (true) {
                    if (Ne(p, "block")) {
                        var t = p.block;
                        if (t instanceof Ge) t = t.body;
                        if (t === e) break;
                    }
                    n.push(p);
                    x();
                }
                p.inserted = p.block;
                w();
                while (n.length) {
                    var i = n.pop();
                    w();
                    if (Ne(i, "block")) p.block = i.block;
                    if (Ne(i, "loop")) p.loop = i.loop;
                }
            }
            function S(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function T(e, n) {
                return S(e.start, e.end) || S(e.start, n.start);
            }
        });
        rn.DEFMETHOD("drop_unused", function(k) {
            if (!k.option("unused")) return;
            var d = this;
            var h = !(d instanceof on) || k.toplevel.funcs;
            var E = !(d instanceof on) || k.toplevel.vars;
            var S = /keep_assign/.test(k.option("unused")) ? Te : function(e, n) {
                var t, i = false;
                if (e instanceof Rn) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof Cn) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(k.option("pure_getters"))) {
                    while (t instanceof Mn && !t.expression.may_throw_on_access(k)) {
                        if (t instanceof Fn) n.unshift(t.property);
                        t = t.expression;
                        i = true;
                    }
                }
                if (!(t instanceof st)) return;
                if (k.exposed(t.definition())) return;
                if (!de(t, i)) return;
                return t;
            };
            var T = Object.create(null);
            var O = Object.create(null);
            var p = [];
            var D = Object.create(null);
            var v = Object.create(null);
            var _ = Object.create(null);
            if (d instanceof on && k.top_retain) {
                d.variables.each(function(e) {
                    if (k.top_retain(e) && !(e.id in D)) {
                        D[e.id] = true;
                        p.push(e);
                    }
                });
            }
            var m = new Ce();
            var A = new Ce();
            var g = new Ce();
            var z = this;
            var b = new wt(function(o, e) {
                if (o instanceof an && o.uses_arguments && !b.has_directive("use strict")) {
                    o.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in D)) {
                            D[n.id] = true;
                            p.push(n);
                        }
                    });
                }
                if (o === d) return;
                if (z === d) {
                    if (o instanceof un) {
                        var n = o.name.definition();
                        if (!h && !(n.id in D)) {
                            D[n.id] = true;
                            p.push(n);
                        }
                        g.add(n.id, o);
                        return true;
                    }
                    if (o instanceof Sn) {
                        o.definitions.forEach(function(i) {
                            var r = i.value && (i.name instanceof Bn || i.value.has_side_effects(k));
                            i.name.mark_symbol(function(e) {
                                if (!(e instanceof Zn)) return;
                                var n = e.definition();
                                A.add(n.id, i);
                                if (o instanceof Dn && n.orig[0] instanceof at) {
                                    var t = n.redefined();
                                    if (t) A.add(t.id, i);
                                }
                                if (!(n.id in D) && (!E || (o instanceof Tn ? n.redefined() : n.const_redefs) || !(o instanceof Dn || U(n)))) {
                                    D[n.id] = true;
                                    p.push(n);
                                }
                                if (i.value) {
                                    if (!r) g.add(n.id, i.value);
                                    m.add(n.id, i);
                                }
                                return true;
                            }, b);
                            if (r) i.value.walk(b);
                        });
                        return true;
                    }
                    if (o instanceof it) {
                        var n = o.definition();
                        A.add(n.id, o);
                        m.add(n.id, o);
                        return true;
                    }
                }
                return t(o, e, true);
            });
            b.directives = Object.create(k.directives);
            d.walk(b);
            b = new wt(t);
            for (var e = 0; e < p.length; e++) {
                var n = g.get(p[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(b);
                });
            }
            Object.keys(T).forEach(function(e) {
                var t = T[e];
                if (!t) {
                    delete T[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        $e(n, e);
                    });
                    return n;
                }, []);
                var n = (m.get(e) || []).filter(function(n) {
                    return ce(n instanceof Cn ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof Cn) return false;
                        return ge(e) === ge(n);
                    }, t);
                });
                if (t.length == n.length) {
                    T[e] = n;
                } else {
                    delete T[e];
                }
            });
            var $ = k.option("keep_fnames") ? Te : k.option("ie8") ? function(e) {
                return !k.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in D)) return true;
                if (e.orig.length < 2) return false;
                if (e.orig[1] instanceof it) return true;
                return Fe(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            var j = [];
            var M = [];
            var q = [];
            var F = new Tt(function(v, e, n) {
                var _ = F.parent();
                if (E) {
                    var t = [], i = S(v, t);
                    if (i) {
                        var r = i.definition();
                        var o = r.id in D;
                        var a;
                        if (v instanceof Rn) {
                            if (!o || v.left === i && H(r, v) < 0) {
                                a = I(v);
                                if (v.write_only === true) {
                                    a = a.drop_side_effect_free(k) || ve(lt, v, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!o || v.expression === i && H(r, v) < 0) {
                            a = ve(lt, v, {
                                value: 0
                            });
                        }
                        if (a) {
                            if (_ instanceof jn && _.tail_node() !== v) {
                                a = a.drop_side_effect_free(k);
                            }
                            if (a) t.push(a);
                            switch (t.length) {
                              case 0:
                                return ze.skip;

                              case 1:
                                return _e(k, _, v, t[0].transform(F));

                              default:
                                return V(v, t.map(function(e) {
                                    return e.transform(F);
                                }));
                            }
                        }
                    } else if (v instanceof Pn && v.expression instanceof st && H(v.expression.definition(), v) < 0) {
                        return ve(Nn, v, {
                            operator: "+",
                            expression: v.expression
                        });
                    }
                }
                if (v instanceof zn) M.push(v);
                if (z !== d) return;
                if (v instanceof an) {
                    if (h && v !== d && v instanceof un) {
                        var r = v.name.definition();
                        if (!(r.id in D)) {
                            C(v.name, "Dropping unused function {name}");
                            r.eliminated++;
                            return n ? ze.skip : ve(Be, v);
                        }
                    }
                    if (v instanceof fn && v.name && $(v.name.definition())) {
                        j.push(v);
                    }
                    if (!(v instanceof sn)) {
                        var s = k.drop_fargs(v, _);
                        for (var f = v.argnames, u = f.length; --u >= 0; ) {
                            var i = f[u];
                            if (i instanceof Bn) {
                                i.transform(new Tt(function(e) {
                                    if (e instanceof Yn) {
                                        var n = true;
                                        for (var t = e.elements.length; --t >= 0; ) {
                                            var i = e.elements[t];
                                            if (!(i instanceof it)) {
                                                e.elements[t] = i.transform(this);
                                                n = false;
                                            } else if (i.definition().id in D) {
                                                n = false;
                                            } else if (n) {
                                                e.elements.pop();
                                            } else {
                                                e.elements[t] = ve(_t, i);
                                            }
                                        }
                                        return e;
                                    }
                                    if (e instanceof Ln) {
                                        if (!(e.value instanceof it)) {
                                            e.value = e.value.transform(this);
                                            return e;
                                        }
                                        if (typeof e.key != "string") return e;
                                        if (e.value.definition().id in D) return e;
                                        return ze.skip;
                                    }
                                }));
                                s = false;
                                continue;
                            }
                            var r = i.definition();
                            if (r.id in D) {
                                s = false;
                                if (H(r, i) < 0) i.__unused = null;
                            } else {
                                i.__unused = true;
                                if (s) {
                                    C(i, "Dropping unused function argument {name}");
                                    f.pop();
                                }
                            }
                        }
                        q.push(v);
                    }
                }
                if (v instanceof Sn && !(_ instanceof nn && _.init === v)) {
                    var m = [], g = [], b = [];
                    var y = [];
                    var w = 0;
                    var x = v instanceof Dn;
                    v.definitions.forEach(function(n) {
                        if (n.value) n.value = n.value.transform(F);
                        if (n.name instanceof Bn) {
                            var s = n.value;
                            var f = new Tt(function(e) {
                                if (e instanceof Yn) {
                                    var n = s;
                                    if (s instanceof st) s = s.fixed_value();
                                    var i = s instanceof Un && s.elements;
                                    var t = [];
                                    e.elements.forEach(function(e, n) {
                                        if (e instanceof _t) return;
                                        s = i && i[n];
                                        e = e.transform(f);
                                        if (e) t[n] = e;
                                    });
                                    s = n;
                                    if (i && t.length == 0) return null;
                                    for (var r = t.length; --r >= 0; ) {
                                        if (!t[r]) t[r] = ve(_t, e.elements[r] || e);
                                    }
                                    e.elements = t;
                                    return e;
                                }
                                if (e instanceof Vn) {
                                    var n = s;
                                    if (s instanceof st) s = s.fixed_value();
                                    var i;
                                    if (s instanceof Wn) {
                                        i = Object.create(null);
                                        for (var r = 0; r < s.properties.length; r++) {
                                            var o = s.properties[r];
                                            if (typeof o.key != "string") {
                                                i = null;
                                                break;
                                            }
                                            i[o.key] = o.value;
                                        }
                                    }
                                    var a = [];
                                    e.properties.forEach(function(e) {
                                        var n;
                                        if (e.key instanceof He) {
                                            e.key = e.key.transform(F);
                                            s = null;
                                            n = e.key.has_side_effects(k);
                                        } else {
                                            s = i && i[e.key];
                                            n = false;
                                        }
                                        if (n && e.value instanceof Zn) {
                                            a.push(e);
                                        } else {
                                            var t = e.value.transform(f);
                                            if (t) {
                                                e.value = t;
                                                a.push(e);
                                            }
                                        }
                                    });
                                    s = n;
                                    if (a.length == 0 && s && !s.may_throw_on_access(k)) {
                                        return null;
                                    }
                                    e.properties = a;
                                    return e;
                                }
                                if (e instanceof Zn) {
                                    if (!E) return e;
                                    if (e.definition().id in D) return e;
                                    if (l(e)) return e;
                                    if (x && !de(e)) return e;
                                    return null;
                                }
                            });
                            var e = n.name.transform(f);
                            if (e) {
                                h();
                            } else {
                                s = s.drop_side_effect_free(k);
                                if (s) y.push(s);
                            }
                            return;
                        }
                        var t = n.name.definition();
                        var i = x ? de(n.name) : U(t);
                        if (!i || !E || t.id in D) {
                            if (n.value && H(t, n) < 0) {
                                var r = n.value.write_only;
                                var s = n.value.drop_side_effect_free(k);
                                if (n.value !== s) {
                                    n.value = s && V(n.value, [ s, ve(lt, n.value, {
                                        value: 0
                                    }) ]);
                                } else if (n.value.write_only !== r) {
                                    n.value.write_only = r;
                                }
                            }
                            var o, a = A.get(t.id);
                            if (!n.value && !(v instanceof On)) {
                                if (i && a.length > 1) {
                                    He.info("Dropping declaration of variable {name} [{file}:{line},{col}]", N(n.name));
                                    Me(a, n);
                                    t.eliminated++;
                                } else {
                                    g.push(n);
                                }
                            } else if (k.option("functions") && !k.option("ie8") && !(v instanceof Tn || v instanceof On) && a.length == 1 && t.assignments == 0 && n.value instanceof fn && (t.references.length ? Fe(t.references, function(e) {
                                return n.value === e.fixed_value();
                            }) : n.value === n.name.fixed_value()) && (!n.value.name || (o = n.value.name.definition()).assignments == 0 && (o.name == n.name.name || Fe(o.references, function(e) {
                                return e.scope.find_variable(n.name) === n.name.definition();
                            }))) && d() && p(n.value, n.name.name)) {
                                He.warn("Declaring {name} as function [{file}:{line},{col}]", N(n.name));
                                var u = ve(un, n, n.value);
                                u.name = ve(rt, n.name, n.name);
                                var c = n.name.scope.resolve().def_function(u.name);
                                if (o) o.references.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference({});
                                });
                                m.push(u);
                            } else {
                                if (i && a.length > 1 && t.orig.indexOf(n.name) > t.eliminated) {
                                    Me(a, n);
                                    w++;
                                }
                                h();
                            }
                        } else if (l(n.name)) {
                            var s = n.value && n.value.drop_side_effect_free(k);
                            if (s) y.push(s);
                            var a = A.get(t.id);
                            if (a.length > 1) {
                                He.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", N(n.name));
                                Me(a, n);
                                t.eliminated++;
                            } else {
                                n.value = null;
                                g.push(n);
                            }
                        } else {
                            var s = n.value && !n.value.single_use && n.value.drop_side_effect_free(k);
                            if (s) {
                                He.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", N(n.name));
                                y.push(s);
                            } else {
                                C(n.name, "Dropping unused variable {name}");
                            }
                            t.eliminated++;
                        }
                        function l(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof at && n.scope.resolve() === e.scope.resolve();
                        }
                        function p(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                        function d() {
                            if (k.has_directive("use strict")) return _ instanceof rn;
                            return _ instanceof We || _ instanceof en && _.init === v || _ instanceof mn;
                        }
                        function h() {
                            if (y.length > 0) {
                                if (b.length == 0) {
                                    m.push(ve(Ye, v, {
                                        body: V(v, y)
                                    }));
                                } else if (n.value) {
                                    y.push(n.value);
                                    n.value = V(n.value, y);
                                } else {
                                    n.value = ve(Nn, n, {
                                        operator: "void",
                                        expression: V(n, y)
                                    });
                                }
                                y = [];
                            }
                            b.push(n);
                        }
                    });
                    switch (g.length) {
                      case 0:
                        if (b.length == 0) break;
                        if (b.length == w) {
                            [].unshift.apply(y, b.map(function(e) {
                                He.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", N(e.name));
                                var n = e.name.definition();
                                var t = ve(st, e.name, e.name);
                                n.references.push(t);
                                var i = ve(Rn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = H(n, e);
                                if (r >= 0) T[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (b.length == 0) {
                            var c = g[0].name.definition().id;
                            if (c in O) {
                                v.definitions = g;
                                O[c].init = v;
                                break;
                            }
                        }

                      default:
                        v.definitions = g.concat(b);
                        m.push(v);
                    }
                    if (y.length > 0) {
                        m.push(ve(Ye, v, {
                            body: V(v, y)
                        }));
                    }
                    return P(m, v, n);
                }
                if (v instanceof Ge && v.body instanceof en) {
                    e(v, F);
                    if (v.body instanceof Je) {
                        var l = v.body;
                        v.body = l.body.pop();
                        l.body.push(v);
                        return n ? ze.splice(l.body) : l;
                    }
                    return v;
                }
                if (v instanceof rn) {
                    var p = z;
                    z = v;
                    e(v, F);
                    z = p;
                    return v;
                }
            }, function(e, n) {
                if (e instanceof Je) switch (e.body.length) {
                  case 0:
                    return n ? ze.skip : ve(Be, e);

                  case 1:
                    var t = e.body[0];
                    if (!(t instanceof Tn || t instanceof On)) return t;
                } else if (e instanceof en) {
                    var i;
                    if (e.init instanceof Je) {
                        i = e.init;
                        e.init = i.body.pop();
                        i.body.push(e);
                    }
                    if (e.init instanceof un) {
                        if (!i) {
                            i = ve(Je, e, {
                                body: [ e ]
                            });
                        }
                        i.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof Ye) {
                        e.init = e.init.body;
                    } else if (J(e.init)) {
                        e.init = null;
                    }
                    return !i ? e : n ? ze.splice(i.body) : i;
                } else if (e instanceof nn) {
                    if (!E || !k.option("loops")) return;
                    if (!J(e.body)) return;
                    var r = e.init;
                    if (r instanceof Sn) {
                        r = r.definitions[0].name;
                    } else while (r instanceof Mn) {
                        r = r.expression.tail_node();
                    }
                    if (r instanceof Bn) return;
                    var o = r.definition();
                    if (!o) return;
                    if (o.id in D) return;
                    if (o.scope !== d) {
                        var a = d.find_variable(r);
                        if ((a && a.redefined() || a) === o) return;
                    }
                    C(r, "Dropping unused loop variable {name}");
                    if (O[o.id] === e) delete O[o.id];
                    var s = [];
                    var f = e.object.drop_side_effect_free(k);
                    if (f) {
                        He.warn("Side effects in object of for-in loop [{file}:{line},{col}]", f.start);
                        s.push(ve(Ye, e, {
                            body: f
                        }));
                    }
                    if (e.init instanceof Sn && o.orig[0] instanceof at) {
                        s.push(e.init);
                    }
                    return P(s, e, n);
                } else if (e instanceof jn) {
                    if (e.expressions.length == 1) return e.expressions[0];
                }
            });
            F.push(k.parent());
            d.transform(F);
            if (d instanceof an && d.body.length == 1 && d.body[0] instanceof Ue && d.body[0].value == "use strict") {
                d.body.length = 0;
            }
            j.forEach(function(e) {
                e.name = null;
            });
            M.forEach(function(e) {
                ie(e, k, q);
            });
            function C(e, n) {
                He[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", N(e));
            }
            function N(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function P(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? ze.skip : ve(Be, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? ze.splice(e) : ve(Je, n, {
                        body: e
                    });
                }
            }
            function y(e, n) {
                if (e.scope !== d) return false;
                if (!e.fixed || !n.fixed) T[e.id] = false;
                return T[e.id] !== false;
            }
            function w(e, n) {
                if (!T[e.id]) T[e.id] = [];
                if (n.fixed.assigns) $e(T[e.id], n.fixed.assigns);
            }
            function H(e, n) {
                var t = T[e.id];
                return t && t.indexOf(n);
            }
            function x(e, n, t) {
                if (e.id in D) return;
                if (n && t) {
                    D[e.id] = true;
                    p.push(e);
                } else {
                    v[e.id] = n;
                    _[e.id] = t;
                }
            }
            function I(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof Hn && be[n.operator])) return n;
                if (!(n.left instanceof st)) return n;
                if (!(e.left instanceof st)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(k)) return n;
                if (y(t, n.left)) w(t, n.left);
                return n.right;
            }
            function t(e, n, t) {
                if (e instanceof Rn && e.left instanceof st) {
                    var i = e.left.definition();
                    if (i.scope === d) m.add(i.id, e);
                }
                if (e instanceof Cn && e.expression instanceof st) {
                    var i = e.expression.definition();
                    if (i.scope === d) m.add(i.id, e);
                }
                var r, o = [], a = S(e, o);
                if (a && d.variables.get(a.name) === (r = a.definition())) {
                    o.forEach(function(e) {
                        e.walk(b);
                    });
                    if (e instanceof Rn) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(k)) return;
                        var s = I(e);
                        if (t && e.write_only === true && r.scope === d && !s.has_side_effects(k)) {
                            g.add(r.id, s);
                        } else {
                            s.walk(b);
                        }
                        if (e.left === a) {
                            if (!e.write_only) {
                                x(r, true, _[r.id]);
                            }
                        } else {
                            var f = a.fixed_value();
                            if (!f || !f.is_constant()) {
                                x(r, v[r.id], true);
                            }
                        }
                    }
                    if (y(r, a) && we(a, e) !== a) w(r, a);
                    return true;
                }
                if (e instanceof nn) {
                    if (e.init instanceof st && z === d) {
                        var u = e.init.definition().id;
                        if (!(u in O)) O[u] = e;
                    }
                    if (!E || !k.option("loops")) return;
                    if (!J(e.body)) return;
                    if (e.init instanceof Bn) return;
                    if (e.init.has_side_effects(k)) return;
                    e.object.walk(b);
                    return true;
                }
                if (e instanceof st) {
                    r = e.definition();
                    if (!(r.id in D)) {
                        D[r.id] = true;
                        p.push(r);
                    }
                    if (R(r.scope, e.scope)) {
                        var c = r.redefined();
                        if (c && !(c.id in D)) {
                            D[c.id] = true;
                            p.push(c);
                        }
                    }
                    if (y(r, e)) w(r, e);
                    return true;
                }
                if (e instanceof rn) {
                    var l = z;
                    z = e;
                    n();
                    z = l;
                    return true;
                }
            }
        });
        rn.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var o = r.option("hoist_funs");
            var a = r.option("hoist_vars");
            var s = this;
            if (a) {
                var n = 0;
                s.walk(new wt(function(e) {
                    if (n > 1) return true;
                    if (e instanceof rn && e !== s) return true;
                    if (e instanceof Dn) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) a = false;
            }
            if (!o && !a) return;
            var f = [];
            var u = [];
            var c = new Ce(), l = 0;
            var p = new Tt(function(e) {
                if (e === s) return;
                if (e instanceof Ue) {
                    f.push(e);
                    return ve(Be, e);
                }
                if (o && e instanceof un && (p.parent() === s || !r.has_directive("use strict"))) {
                    u.push(e);
                    return ve(Be, e);
                }
                if (a && e instanceof Dn) {
                    e.definitions.forEach(function(e) {
                        c.set(e.name.name, e);
                        ++l;
                    });
                    var n = e.to_assignments();
                    var t = p.parent();
                    if (t instanceof nn && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return ve(st, i, i);
                    }
                    if (t instanceof en && t.init === e) return n;
                    if (!n) return ve(Be, e);
                    return ve(Ye, e, {
                        body: n
                    });
                }
                if (e instanceof rn) return e;
            });
            s.transform(p);
            if (l > 0) {
                var t = [];
                c.each(function(e, n) {
                    if (s instanceof an && !Fe(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        c.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        t.push(e);
                        c.set(n, e);
                    }
                });
                if (t.length > 0) {
                    for (var e = 0; e < s.body.length; ) {
                        if (s.body[e] instanceof Ye) {
                            var i = s.body[e].body, d, h;
                            if (i instanceof Rn && i.operator == "=" && (d = i.left) instanceof Qn && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = i.right;
                                Me(t, v);
                                t.push(v);
                                s.body.splice(e, 1);
                                continue;
                            }
                            if (i instanceof jn && (h = i.expressions[0]) instanceof Rn && h.operator == "=" && (d = h.left) instanceof Qn && c.has(d.name)) {
                                var v = c.get(d.name);
                                if (v.value) break;
                                v.value = h.right;
                                Me(t, v);
                                t.push(v);
                                s.body[e].body = V(i, i.expressions.slice(1));
                                continue;
                            }
                        }
                        if (s.body[e] instanceof Be) {
                            s.body.splice(e, 1);
                            continue;
                        }
                        if (s.body[e] instanceof Je) {
                            var _ = [ e, 1 ].concat(s.body[e].body);
                            s.body.splice.apply(s.body, _);
                            continue;
                        }
                        break;
                    }
                    t = ve(Dn, s, {
                        definitions: t
                    });
                    u.push(t);
                }
            }
            s.body = f.concat(u, s.body);
        });
        function d(n, t) {
            n.walk(new wt(function(e) {
                if (e instanceof pn) {
                    t(e);
                    return true;
                }
                if (e instanceof rn && e !== n) return true;
            }));
        }
        function h(e) {
            var i = Object.create(null);
            d(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof st) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function v(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function y(e, i) {
            d(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(i, true);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? V(e.value, [ n, ve(lt, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (t && !(t instanceof He)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? V(e.value, [ n, ve(lt, e.value, {
                            value: 1
                        }) ]) : ve(lt, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        rn.DEFMETHOD("process_boolean_returns", Se);
        un.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = h(this);
            if (!v(this.name.definition(), n, e)) return;
            y(this, e);
        });
        fn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = h(this);
            if (this.name && !v(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof Rn) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof st)) return;
                if (!v(i.definition(), n, e)) return;
            } else if (t instanceof zn && t.expression !== this) {
                var r = t.expression;
                if (r instanceof st) r = r.fixed_value();
                if (!(r instanceof an)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i && !v(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var o = e.in_boolean_context();
                e.push(this);
                if (!o) return;
            } else return;
            y(this, e);
        });
        Le.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        rn.DEFMETHOD("make_var", function(e, n, t) {
            var i = [ this ];
            if (n instanceof Zn) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (Ee(n, i)) return;
                do {
                    $e(i, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var r = t;
            for (var o = 0; !Fe(i, function(e) {
                return !e.var_names()[r];
            }); o++) r = t + "$" + o;
            var a = ve(e, n, {
                name: r,
                scope: this
            });
            var s = this.def_variable(a);
            i.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names()[r] = true;
            });
            return a;
        });
        rn.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var r = f instanceof on && e.top_retain || Te;
            var u = Object.create(null);
            f.transform(new Tt(function(i, e) {
                if (i instanceof Rn) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== f) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new Ce();
                    var o = [];
                    var a = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        a.push(ve(An, i, {
                            name: n,
                            value: null
                        }));
                        var t = ve(st, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference({});
                        o.push(ve(Rn, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, ve(Dn, i, {
                        definitions: a
                    }));
                    return V(i, o);
                }
                if (i instanceof rn) return i === f ? undefined : i;
                if (i instanceof An) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new Ce();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(ve(An, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return ze.splice(n);
                }
                function s(e, n) {
                    var t = f.make_var(tt, e, e.name + "_" + n);
                    r.set(n, t.definition());
                    return t;
                }
            }));
            f.transform(new Tt(function(i, e) {
                if (i instanceof Hn) return o("right");
                if (i instanceof Mn) {
                    if (!(i.expression instanceof st)) return;
                    var n = u[i.expression.definition().id];
                    if (!n) return;
                    var t = n.get(i.getProperty());
                    var r = ve(st, i, {
                        name: t.name,
                        scope: i.expression.scope,
                        thedef: t
                    });
                    r.reference({});
                    return r;
                }
                if (i instanceof Cn) {
                    if (j[i.operator]) return;
                    return o("expression");
                }
                function o(e) {
                    var n = i[e];
                    if (!(n instanceof st)) return;
                    if (!(n.definition().id in u)) return;
                    var t = i.clone();
                    t[e] = ve(Wn, n, {
                        properties: []
                    });
                    return t;
                }
            }));
            function t(e, n, t) {
                if (!(e instanceof Qn)) return;
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof Wn && n.properties.length > 0 && Fe(n.properties, function(e) {
                    return e instanceof Gn && typeof e.key == "string";
                }) && Fe(i.references, function(e) {
                    return e.fixed_value() === n;
                }) && de(e);
            }
        });
        function ne(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return Fe(t.references, function(e) {
                return !(e instanceof st);
            });
        }
        (function(e) {
            function u(e, n, t) {
                var i = e.length;
                if (!i) return null;
                var r = [], o = false;
                for (var a = 0; a < i; a++) {
                    var s = e[a].drop_side_effect_free(n, t);
                    o |= s !== e[a];
                    if (s) {
                        r.push(s);
                        t = false;
                    }
                }
                return o ? r.length ? r : null : e;
            }
            e(He, De);
            e(sn, Ae);
            e(Un, function(e, n) {
                var t = u(this.elements, e, n);
                return t && V(this, t);
            });
            e(Rn, function(e) {
                var n = this.left;
                if (n instanceof Mn) {
                    var t = n.expression;
                    if (t instanceof Rn && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (me(n).is_constant_expression(e.find_parent(rn))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(Hn, function(e, n) {
                if (this.operator == "in" && !xe(this.right)) {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (t === this.left) return this;
                    var i = this.clone();
                    i.left = t || ve(lt, this.left, {
                        value: 0
                    });
                    return i;
                }
                var r = this.right.drop_side_effect_free(e, n);
                if (!r) return this.left.drop_side_effect_free(e, n);
                if (be[this.operator] && !(r instanceof fn)) {
                    var i = this;
                    if (r !== i.right) {
                        i = this.clone();
                        i.right = r.drop_side_effect_free(e);
                    }
                    return (n ? o : Q)(i, ve(Hn, this, {
                        operator: i.operator == "&&" ? "||" : "&&",
                        left: i.left.negate(e, n),
                        right: i.right
                    }));
                } else {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (!t) return r;
                    return V(this, [ t, r.drop_side_effect_free(e) ]);
                }
            });
            e(zn, function(t, e) {
                var n = this;
                if (n.is_expr_pure(t)) {
                    if (n.pure) He.warn("Dropping __PURE__ call [{file}:{line},{col}]", n.start);
                    var i = u(n.args, t, e);
                    return i && V(n, i);
                }
                var r = n.expression;
                if (n.is_call_pure(t)) {
                    var o = n.args.slice();
                    o.unshift(r.expression);
                    o = u(o, t, e);
                    return o && V(n, o);
                }
                var a;
                if (r instanceof fn && !(r.name && (a = r.name.definition()).references.length > a.replaced)) {
                    r.process_expression(false, function(e) {
                        var n = e.value && e.value.drop_side_effect_free(t, true);
                        return n ? ve(Ye, e, {
                            body: n
                        }) : ve(Be, e);
                    });
                    d(r, function(e) {
                        if (e.value) e.value = e.value.drop_side_effect_free(t);
                    });
                    n = n.clone();
                }
                if (n instanceof $n) {
                    var s = r;
                    if (s instanceof st) s = s.fixed_value();
                    if (s instanceof an) {
                        s.new = true;
                        var f = Fe(s.body, function(e) {
                            return !e.has_side_effects(t);
                        });
                        delete s.new;
                        if (f) {
                            var o = n.args.slice();
                            o.unshift(r);
                            o = u(o, t, e);
                            return o && V(n, o);
                        }
                        if (!s.contains_this()) return ve(zn, n, n);
                    }
                }
                return n;
            });
            e(In, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie8")) {
                    i = [];
                    if (n instanceof fn) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof fn) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? ve(Hn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = ve(Hn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie8")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : V(this, i);
            });
            e(ut, Ae);
            e(qn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(fn, function(e) {
                return ne(this, e) ? null : this;
            });
            e(Wn, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e.key instanceof He) t.push(e.key);
                    t.push(e.value);
                });
                var i = u(t, e, n);
                return i && V(this, i);
            });
            e(jn, function(e, n) {
                var t = u(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r, o, a;
                if (e.option("conditionals") && i > 0 && (r = t[i - 1]) instanceof Rn && r.operator == "=" && (a = r.left) instanceof st && (o = P(e, a.definition(), r.right, t[i]))) {
                    r = r.clone();
                    r.right = o;
                    t = t.slice(0, -2);
                    t.push(r);
                }
                return t === this.expressions ? this : V(this, t);
            });
            e(Fn, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return V(this, [ t, i ]);
            });
            e(st, function(e) {
                return this.is_declared(e) && de(this) ? null : this;
            });
            e(ft, Ae);
            e(Cn, function(e, n) {
                var t = this.expression;
                if (j[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof st && de(t)) return null;
                var i = t.drop_side_effect_free(e, n);
                if (n && i && G(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(Ye, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    He.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return ve(Be, e);
                }
                if (i !== t) {
                    return ve(Ye, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(Ze, function(e, n) {
            return n.option("loops") ? ve(en, e, e).optimize(n) : e;
        });
        function q(n, e, t) {
            if (!t) t = hn;
            var i = false;
            var r = new wt(function(e) {
                if (i || e instanceof rn) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof Ge) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(Qe, function(t, e) {
            if (!e.option("loops")) return t;
            var n = t.condition.is_truthy() || t.condition.evaluate(e, true);
            if (!(n instanceof He)) {
                if (n && !q(t, e.parent(), _n)) return ve(en, t, {
                    body: ve(Je, t.body, {
                        body: [ t.body, ve(Ye, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!q(t, e.parent())) return ve(Je, t.body, {
                    body: [ t.body, ve(Ye, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof Je && !q(t, e.parent(), _n)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var o = i[r];
                    if (o instanceof mn && !o.alternative && o.body instanceof vn && e.loopcontrol_target(o.body) === t) {
                        if (a(o.condition)) break;
                        t.condition = ve(Hn, t, {
                            operator: "&&",
                            left: o.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (o instanceof Ye) {
                        if (a(o.body)) break;
                        t.condition = V(t, [ o.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!z(o)) {
                        break;
                    }
                }
                t.body = p(t.body);
            }
            if (t.body instanceof Be) return ve(en, t, t).optimize(e);
            if (t.body instanceof Ye) return ve(en, t, {
                condition: V(t.condition, [ t.body.body, t.condition ]),
                body: ve(Be, t)
            }).optimize(e);
            return t;
            function a(e) {
                var n = false;
                e.walk(new wt(function(e) {
                    if (n) return true;
                    if (e instanceof st) {
                        if (!Ee(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function w(n, t) {
            var e = a(n.body);
            if (t.option("dead_code") && (e instanceof vn || e instanceof _n && s(e) || e instanceof ln)) {
                var i = [];
                if (n.init instanceof Ie) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(ve(Ye, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof ln;
                if (n.condition && r) {
                    i.push(ve(mn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(ve(Ye, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                k(t, n.body, i);
                return ve(Je, n, {
                    body: i
                });
            }
            if (e instanceof mn) {
                var o = a(e.body);
                if (o instanceof vn && !s(o)) {
                    if (n.condition) {
                        n.condition = ve(Hn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = D(e.alternative);
                    k(t, e.body, i);
                    return f(i);
                }
                o = a(e.alternative);
                if (o instanceof vn && !s(o)) {
                    if (n.condition) {
                        n.condition = ve(Hn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = D(e.body);
                    k(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function a(e) {
                return e instanceof Je ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof Je) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = ve(Je, n.body, {
                        body: e
                    }).transform(t);
                }
                return w(n, t);
            }
        }
        e(en, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof He) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var i = e.condition;
                    e.condition = O(t, e.condition);
                    e.condition = Q(e.condition.transform(n), i);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (e.init instanceof Ie) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(ve(Ye, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(ve(Ye, e.condition, {
                            body: e.condition
                        }));
                        k(n, e.body, r);
                        return ve(Je, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof He)) {
                    e.body = ve(Je, e.body, {
                        body: [ ve(Ye, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return w(e, n);
        });
        e(nn, function(e, n) {
            if (n.option("varify") && (e.init instanceof Tn || e.init instanceof On)) {
                var t = e.init.definitions[0].name;
                if ((t instanceof Bn || t instanceof nt) && !t.match_symbol(function(e) {
                    if (e instanceof Zn) return S(n, e.definition());
                })) {
                    e.init = C(e.init);
                }
            }
            return e;
        });
        function F(e, n, t) {
            if (!(e instanceof Hn)) return;
            if (!(e.left instanceof ct)) {
                switch (e.operator) {
                  case "&&":
                    F(e.left, n);
                    F(e.right, n);
                    break;

                  case "||":
                    F(f(e.left), t);
                    F(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof Nn)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!X(i)) return;
            var r;
            var o = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = o ? t : n;
                break;

              case "!=":
                r = o ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var a = i.definition();
            var s = new wt(function(e) {
                if (e instanceof rn) {
                    var n = s.parent();
                    if (n instanceof zn && n.expression === e) return;
                    return true;
                }
                if (e instanceof st && e.definition() === a) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof Hn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        e(mn, function(e, f) {
            if (J(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            var n = e.condition.evaluate(f);
            if (!f.option("dead_code") && !(n instanceof He)) {
                var t = e.condition;
                e.condition = O(n, t);
                e.condition = Q(e.condition.transform(f), t);
            }
            if (f.option("dead_code")) {
                if (n instanceof He) {
                    n = e.condition.is_truthy() || e.condition.evaluate(f, true);
                }
                if (!n) {
                    He.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [ ve(Ye, e.condition, {
                        body: e.condition
                    }) ];
                    k(f, e.body, i);
                    if (e.alternative) i.push(e.alternative);
                    return ve(Je, e, {
                        body: i
                    }).optimize(f);
                } else if (!(n instanceof He)) {
                    He.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [ ve(Ye, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) k(f, e.alternative, i);
                    return ve(Je, e, {
                        body: i
                    }).optimize(f);
                }
            }
            var r = e.condition.negate(f);
            var o = e.condition.print_to_string().length;
            var a = r.print_to_string().length;
            var s = a < o;
            if (e.alternative && s) {
                s = false;
                e.condition = r;
                var u = e.body;
                e.body = e.alternative || ve(Be, e);
                e.alternative = u;
            }
            var i = [], c = [], l = [];
            var p = _(e.body, i, c, l);
            var d = _(e.alternative, i, c, l);
            if (p && d) {
                if (c.length > 0) i.push(ve(Dn, e, {
                    definitions: c
                }));
                if (p.length == 0) {
                    i.push(ve(Ye, e.condition, {
                        body: d.length > 0 ? ve(Hn, e, {
                            operator: "||",
                            left: e.condition,
                            right: V(e.alternative, d)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (d.length == 0) {
                    if (o === a && !s && e.condition instanceof Hn && e.condition.operator == "||") {
                        s = true;
                    }
                    i.push(ve(Ye, e, {
                        body: ve(Hn, e, {
                            operator: s ? "||" : "&&",
                            left: s ? r : e.condition,
                            right: V(e.body, p)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    i.push(ve(Ye, e, {
                        body: ve(In, e, {
                            condition: e.condition,
                            consequent: V(e.body, p),
                            alternative: V(e.alternative, d)
                        })
                    }).optimize(f));
                }
                l.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return ve(Je, e, {
                    body: i
                }).optimize(f);
            }
            if (J(e.body)) {
                e = ve(mn, e, {
                    condition: r,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof ln && e.alternative instanceof ln && e.body.TYPE == e.alternative.TYPE) {
                var h = ve(e.body.CTOR, e, {
                    value: ve(In, e, {
                        condition: e.condition,
                        consequent: e.body.value || ve(vt, e.body).transform(f),
                        alternative: e.alternative.value || ve(vt, e.alternative).transform(f)
                    })
                });
                if (h instanceof pn) {
                    h.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return h;
            }
            if (e.body instanceof mn && !e.body.alternative && !e.alternative) {
                e = ve(mn, e, {
                    condition: ve(Hn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (M(e.body)) {
                if (e.alternative) {
                    var v = e.alternative;
                    e.alternative = null;
                    return ve(Je, e, {
                        body: [ e, v ]
                    }).optimize(f);
                }
            }
            if (M(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = s ? r : e.condition.negate(f);
                e.alternative = null;
                return ve(Je, e, {
                    body: [ e, i ]
                }).optimize(f);
            }
            if (f.option("typeofs")) F(e.condition, e.body, e.alternative);
            return e;
            function _(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof Je) {
                    var r = [];
                    for (var o = 0; o < e.body.length; o++) {
                        var a = e.body[o];
                        if (a instanceof un) {
                            n.push(a);
                        } else if (a instanceof Be) {
                            continue;
                        } else if (a instanceof Ye) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(a.body);
                        } else if (a instanceof Dn) {
                            if (!f.option("sequences") && r.length > 0) return;
                            a.remove_initializers(f, t);
                            a.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (e instanceof un) {
                    n.push(e);
                    return [];
                }
                if (e instanceof Be) return [];
                if (e instanceof Ye) return [ e.body ];
                if (e instanceof Dn) {
                    var r = [];
                    e.remove_initializers(f, t);
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    if (!e.value) return;
                    r.push(ve(Rn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(st, function(e) {
                            i.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(gn, function(i, t) {
            if (!t.option("switches")) return i;
            var e;
            var n = i.expression.evaluate(t);
            if (!(n instanceof He)) {
                var r = i.expression;
                i.expression = O(n, r);
                i.expression = Q(i.expression.transform(t), r);
            }
            if (!t.option("dead_code")) return i;
            if (n instanceof He) {
                n = i.expression.evaluate(t, true);
            }
            var o = [];
            var a = [];
            var s;
            var f;
            for (var u = 0, c = i.body.length; u < c && !f; u++) {
                e = i.body[u];
                if (e instanceof yn) {
                    var l = a[a.length - 1];
                    if (s || b(e.body[0], t) && (!l || M(l))) {
                        w(e, l);
                        continue;
                    } else {
                        s = e;
                    }
                } else if (!(n instanceof He)) {
                    var p = e.expression.evaluate(t);
                    if (!(p instanceof He) && p !== n) {
                        w(e, a[a.length - 1]);
                        continue;
                    }
                    if (p instanceof He) p = e.expression.evaluate(t, true);
                    if (p === n) {
                        f = e;
                        if (s) {
                            var d = a.indexOf(s);
                            a.splice(d, 1);
                            w(s, a[d - 1]);
                            s = null;
                        }
                    }
                }
                if (M(e)) {
                    var l = a[a.length - 1];
                    if (M(l) && l.body.length == e.body.length && ve(Je, l, l).equivalent_to(ve(Je, e, e))) {
                        l.body = [];
                    }
                }
                a.push(e);
            }
            while (u < c) w(i.body[u++], a[a.length - 1]);
            while (e = a[a.length - 1]) {
                var h = e.body[e.body.length - 1];
                if (b(h, t)) e.body.pop();
                if (e === s) {
                    if (!x(e)) break;
                } else if (e.expression.has_side_effects(t)) {
                    break;
                } else if (s) {
                    if (!x(s)) break;
                    if (a[a.length - 2] !== s) break;
                    s.body = s.body.concat(e.body);
                    e.body = [];
                } else if (!x(e)) break;
                w(e);
                if (a.pop() === s) s = null;
            }
            if (a.length == 0) {
                return ve(Je, i, {
                    body: o.concat(ve(Ye, i.expression, {
                        body: i.expression
                    }))
                }).optimize(t);
            }
            a[0].body = o.concat(a[0].body);
            i.body = a;
            if (t.option("conditionals")) switch (a.length) {
              case 1:
                if (!y(a[0])) break;
                var p = a[0].expression;
                var v = a[0].body.slice();
                if (a[0] !== s && a[0] !== f) return ve(mn, i, {
                    condition: ve(Hn, i, {
                        operator: "===",
                        left: i.expression,
                        right: p
                    }),
                    body: ve(Je, i, {
                        body: v
                    }),
                    alternative: null
                }).optimize(t);
                if (p) v.unshift(ve(Ye, p, {
                    body: p
                }));
                v.unshift(ve(Ye, i.expression, {
                    body: i.expression
                }));
                return ve(Je, i, {
                    body: v
                }).optimize(t);

              case 2:
                if (!Ee(s, a) || !y(a[1])) break;
                var v = a[0].body.slice();
                var _ = v.length && b(v[v.length - 1], t);
                if (_) v.pop();
                if (!Fe(v, y)) break;
                var m = a[1].body.length && ve(Je, a[1], a[1]);
                var g = ve(mn, i, {
                    condition: ve(Hn, i, a[0] === s ? {
                        operator: "!==",
                        left: i.expression,
                        right: a[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: a[0].expression
                    }),
                    body: ve(Je, a[0], {
                        body: v
                    }),
                    alternative: _ && m || null
                });
                if (!_ && m) g = ve(Je, i, {
                    body: [ g, m ]
                });
                return g.optimize(t);
            }
            return i;
            function b(e, n) {
                return e instanceof vn && n.loopcontrol_target(e) === i;
            }
            function y(e) {
                var n = false;
                var t = new wt(function(e) {
                    if (n || e instanceof an || e instanceof Ye) return true;
                    if (b(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function w(e, n) {
                if (n && !M(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    k(t, e, o);
                }
            }
        });
        e(xn, function(e, n) {
            e.body = u(e.body, n);
            if (n.option("dead_code")) {
                if (x(e) && !(e.bcatch && e.bcatch.argname && !de(e.bcatch.argname))) {
                    var t = [];
                    if (e.bcatch) {
                        k(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof Dn)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(ve(Je, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(ve(Je, e.bfinally, e.bfinally).optimize(n));
                    }
                    return ve(Je, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && x(e.bfinally)) {
                    var t = ve(Je, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return ve(Je, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function E(r) {
            return function(n, t) {
                var i = false;
                this.definitions.forEach(function(e) {
                    if (e.value) i = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof Zn) t.push(ve(An, e, {
                            name: e,
                            value: r(n, e)
                        }));
                    }, true);
                });
                return i;
            };
        }
        Tn.DEFMETHOD("remove_initializers", E(function(e, n) {
            return ve(vt, n).optimize(e);
        }));
        On.DEFMETHOD("remove_initializers", E(Ae));
        Dn.DEFMETHOD("remove_initializers", E(Ae));
        Sn.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, n) {
                var t = n.name.definition();
                if (n.value) {
                    var i = ve(st, n.name, n.name);
                    e.push(ve(Rn, n, {
                        operator: "=",
                        left: i,
                        right: n.value
                    }));
                    t.references.push(i);
                }
                t.eliminated++;
                return e;
            }, []);
            if (e.length == 0) return null;
            return V(this, e);
        });
        function U(e) {
            return e.orig.length < (e.orig[0] instanceof ot ? 3 : 2);
        }
        function S(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var i = n.scope; i !== t; ) {
                i = i.parent_scope;
                if (i.var_names()[n.name]) return true;
            }
        }
        function C(e) {
            return ve(Dn, e, {
                definitions: e.definitions.map(function(e) {
                    return ve(An, e, {
                        name: e.name.convert_symbol(tt, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var i = t.scope.resolve();
                            if (t.scope === i) return;
                            t.scope = i;
                            i.variables.set(t.name, t);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function N(e, t) {
            return t.option("varify") && Fe(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof Zn) {
                        var n = e.definition();
                        return !e.fixed_value() || !U(n) || S(t, n);
                    }
                }, true);
            }) ? C(e) : e;
        }
        e(Tn, N);
        e(On, N);
        function te(e, n) {
            var t = e.expression;
            if (!(t instanceof jn)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return V(e, i);
        }
        function ie(e, t, n) {
            var i = e.expression;
            var r = i instanceof st ? i.fixed_value() : i;
            if (!(r instanceof an)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (n && n.indexOf(r) < 0) return;
            var o = e.args;
            var a = 0, s = 0;
            var f = r === i && !r.name && t.drop_fargs(r, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof Yn) {
                    return e.elements.length == 0 && n instanceof Un;
                }
                if (e instanceof Vn) {
                    return e.properties.length == 0 && n && !n.may_throw_on_access(t);
                }
                return e.__unused;
            } : Te;
            var u = [];
            for (var c = 0; c < o.length; c++) {
                var l = r.argnames[c];
                if (!l || "__unused" in l) {
                    var p = o[c].drop_side_effect_free(t);
                    if (f(l)) {
                        if (l) r.argnames.splice(c, 1);
                        o.splice(c, 1);
                        if (p) u.push(p);
                        c--;
                        continue;
                    } else if (p) {
                        u.push(p);
                        o[a++] = V(e, u);
                        u = [];
                    } else if (l) {
                        if (u.length) {
                            o[a++] = V(e, u);
                            u = [];
                        } else {
                            o[a++] = ve(lt, o[c], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (l && f(l, o[c])) {
                    var p = o[c].drop_side_effect_free(t);
                    r.argnames.splice(c, 1);
                    o.splice(c, 1);
                    if (p) u.push(p);
                    c--;
                    continue;
                } else {
                    u.push(o[c]);
                    o[a++] = V(e, u);
                    u = [];
                }
                s = a;
            }
            for (;c < r.argnames.length; c++) {
                if (f(r.argnames[c])) r.argnames.splice(c--, 1);
            }
            o.length = s;
            if (!u.length) return;
            var d = V(e, u);
            o.push(o.length < r.argnames.length ? ve(Nn, e, {
                operator: "void",
                expression: d
            }) : d);
        }
        e(zn, function(f, u) {
            var a = f.expression;
            if (u.option("sequences")) {
                if (a instanceof Mn) {
                    var e = te(a, u);
                    if (e !== a) {
                        var n = f.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(u);
                    }
                } else if (!W(u, a.tail_node())) {
                    var e = te(f, u);
                    if (e !== f) return e.optimize(u);
                }
            }
            if (u.option("unused")) ie(f, u);
            if (u.option("unsafe")) {
                if (X(a)) switch (a.name) {
                  case "Array":
                    if (f.args.length == 1) {
                        var t = f.args[0];
                        if (t instanceof lt) try {
                            var i = t.value;
                            if (i > 6) break;
                            var r = Array(i);
                            for (var o = 0; o < i; o++) r[o] = ve(_t, f);
                            return ve(Un, f, {
                                elements: r
                            });
                        } catch (e) {
                            He.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: i,
                                file: f.start.file,
                                line: f.start.line,
                                col: f.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(u) && !t.is_string(u)) break;
                    }
                    return ve(Un, f, {
                        elements: f.args
                    });

                  case "Object":
                    if (f.args.length == 0) {
                        return ve(Wn, f, {
                            properties: []
                        });
                    }
                    break;

                  case "String":
                    if (f.args.length == 0) return ve(ct, f, {
                        value: ""
                    });
                    if (f.args.length <= 1) return ve(Hn, f, {
                        left: f.args[0],
                        operator: "+",
                        right: ve(ct, f, {
                            value: ""
                        })
                    }).optimize(u);
                    break;

                  case "Number":
                    if (f.args.length == 0) return ve(lt, f, {
                        value: 0
                    });
                    if (f.args.length == 1) return ve(Nn, f, {
                        expression: f.args[0],
                        operator: "+"
                    }).optimize(u);

                  case "Boolean":
                    if (f.args.length == 0) return ve(bt, f);
                    if (f.args.length == 1) return ve(Nn, f, {
                        expression: ve(Nn, f, {
                            expression: f.args[0],
                            operator: "!"
                        }),
                        operator: "!"
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var s = [];
                    if (Fe(f.args, function(e) {
                        var n = e.evaluate(u);
                        s.unshift(n);
                        return e !== n;
                    })) {
                        try {
                            return Z(u, f, ve(pt, f, {
                                value: RegExp.apply(RegExp, s)
                            }));
                        } catch (e) {
                            He.warn("Error converting {expr} [{file}:{line},{col}]", {
                                expr: f,
                                file: f.start.file,
                                line: f.start.line,
                                col: f.start.col
                            });
                        }
                    }
                    break;
                } else if (a instanceof qn) switch (a.property) {
                  case "toString":
                    if (f.args.length == 0 && !a.expression.may_throw_on_access(u)) {
                        return ve(Hn, f, {
                            left: ve(ct, f, {
                                value: ""
                            }),
                            operator: "+",
                            right: a.expression
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (a.expression instanceof Un) e: {
                        var c;
                        if (f.args.length > 0) {
                            c = f.args[0].evaluate(u);
                            if (c === f.args[0]) break e;
                        }
                        var r = [];
                        var l = [];
                        a.expression.elements.forEach(function(e) {
                            var n = e.evaluate(u);
                            if (n !== e) {
                                l.push(n);
                            } else {
                                if (l.length > 0) {
                                    r.push(ve(ct, f, {
                                        value: l.join(c)
                                    }));
                                    l.length = 0;
                                }
                                r.push(e);
                            }
                        });
                        if (l.length > 0) {
                            r.push(ve(ct, f, {
                                value: l.join(c)
                            }));
                        }
                        if (r.length == 0) return ve(ct, f, {
                            value: ""
                        });
                        if (r.length == 1) {
                            if (r[0].is_string(u)) {
                                return r[0];
                            }
                            return ve(Hn, r[0], {
                                operator: "+",
                                left: ve(ct, f, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (c == "") {
                            var t;
                            if (r[0].is_string(u) || r[1].is_string(u)) {
                                t = r.shift();
                            } else {
                                t = ve(ct, f, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return ve(Hn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(u);
                        }
                        var p = f.clone();
                        p.expression = p.expression.clone();
                        p.expression.expression = p.expression.expression.clone();
                        p.expression.expression.elements = r;
                        return Z(u, f, p);
                    }
                    break;

                  case "charAt":
                    if (f.args.length < 2) {
                        var p = ve(Fn, f, {
                            expression: a.expression,
                            property: f.args.length ? ve(Hn, f.args[0], {
                                operator: "|",
                                left: ve(lt, f, {
                                    value: 0
                                }),
                                right: f.args[0]
                            }) : ve(lt, f, {
                                value: 0
                            })
                        });
                        p.is_string = Oe;
                        return p.optimize(u);
                    }
                    break;

                  case "apply":
                    if (f.args.length == 2 && f.args[1] instanceof Un) {
                        var d = f.args[1].elements.slice();
                        d.unshift(f.args[0]);
                        return ve(zn, f, {
                            expression: ve(qn, a, {
                                expression: a.expression,
                                property: "call"
                            }),
                            args: d
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var h = a.expression;
                    if (h instanceof st) {
                        h = h.fixed_value();
                    }
                    if (h instanceof an && !h.contains_this()) {
                        return (f.args.length ? V(this, [ f.args[0], ve(zn, f, {
                            expression: a.expression,
                            args: f.args.slice(1)
                        }) ]) : ve(zn, f, {
                            expression: a.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && X(a) && a.name == "Function") {
                if (f.args.length == 0) return ve(fn, f, {
                    argnames: [],
                    body: []
                }).init_vars(a.scope);
                if (Fe(f.args, function(e) {
                    return e instanceof ct;
                })) {
                    try {
                        var v = "n(function(" + f.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join(",") + "){" + f.args[f.args.length - 1].value + "})";
                        var _ = St(v);
                        var m = {
                            ie8: u.option("ie8")
                        };
                        _.figure_out_scope(m);
                        var g = new Dt(u.options);
                        _ = _.transform(g);
                        _.figure_out_scope(m);
                        _.compute_char_frequency(m);
                        _.mangle_names(m);
                        var b;
                        _.walk(new wt(function(e) {
                            if (b) return true;
                            if (e instanceof an) {
                                b = e;
                                return true;
                            }
                        }));
                        var v = Ot();
                        Je.prototype._codegen.call(b, v);
                        f.args = [ ve(ct, f, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join(",")
                        }), ve(ct, f.args[f.args.length - 1], {
                            value: v.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return f;
                    } catch (e) {
                        if (e instanceof kt) {
                            He.warn("Error parsing code passed to new Function [{file}:{line},{col}]", f.args[f.args.length - 1].start);
                            He.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = a instanceof st ? a.fixed_value() : a;
            var w = y instanceof an;
            var x = w && y.first_statement();
            var k = w && u.option("inline") && !f.is_expr_pure(u) && Fe(y.argnames, function(e) {
                return !(e instanceof Bn);
            });
            if (k && x instanceof pn) {
                var E = x.value;
                if (a === y && (!E || E.is_constant_expression())) {
                    var d = f.args.concat(E || ve(vt, f));
                    return V(f, d).optimize(u);
                }
            }
            if (w) {
                var S, E, T = false;
                if (k && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof fn) && (a === y || !ke(u, S = a.definition()) && y.is_constant_expression(L(u))) && (E = q(x)) && !y.contains_this()) {
                    var O = a === y || S.single_use && S.references.length - S.replaced == 1;
                    if (C()) {
                        var d = f.args.slice();
                        var D = [];
                        d.push(E.clone(true).transform(new Tt(function(e) {
                            if (e instanceof st) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    D.push(e);
                                    return e;
                                }
                                var t = F(n);
                                var i = d[t];
                                if (!i) return ve(vt, f);
                                d[t] = null;
                                var r = this.parent();
                                return r ? _e(u, r, e, i) : i;
                            }
                        })));
                        var p = V(f, d.filter(function(e) {
                            return e;
                        })).optimize(u);
                        p = _e(u, u.parent(), u.self(), p);
                        if (O || Q(p, f) === p) {
                            D.forEach(function(e) {
                                var n = e.definition();
                                n.references.push(e);
                                if (O) n.replaced++;
                            });
                            return p;
                        }
                    }
                    var A, z, $;
                    if (O && I()) {
                        y._squeezed = true;
                        if (a !== y) y.parent_scope = a.scope;
                        var p = V(f, Y()).optimize(u);
                        return _e(u, u.parent(), u.self(), p);
                    }
                }
                if (u.option("side_effects") && Fe(y.body, J) && Fe(y.argnames, function(e) {
                    return !(e instanceof Bn);
                }) && (y !== a || ne(y, u))) {
                    var d = f.args.concat(ve(vt, f));
                    return V(f, d).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (a instanceof Mn) {
                    var j = a.expression;
                    while (j.expression) {
                        j = j.expression;
                    }
                    if (X(j) && j.name == "console") {
                        return ve(vt, f).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && u.parent() instanceof Ye && G(f)) {
                return f.negate(u, true);
            }
            return ee(u, f);
            function M(e) {
                if (!e) return ve(vt, f);
                if (e instanceof pn) return e.value || ve(vt, f);
                if (e instanceof Ye) return ve(Nn, e, {
                    operator: "void",
                    expression: e.body
                });
            }
            function q(e) {
                var n = y.body.length;
                if (u.option("inline") < 3) {
                    return n == 1 && M(e);
                }
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = y.body[t];
                    if (i instanceof Dn) {
                        var r = T || !Fe(i.definitions, function(e) {
                            return !e.value;
                        });
                        if (r) {
                            T = true;
                            if (e) return false;
                        }
                    } else if (i instanceof un || i instanceof Be) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return M(e);
            }
            function F(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function C() {
                if (T) return;
                if (u.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof it;
                })) return;
                var r = false;
                var o;
                var a = [];
                var s = false;
                E.walk(new wt(function(e, n) {
                    if (r) return true;
                    if (e instanceof Hn && be[e.operator] || e instanceof In) {
                        a = null;
                        return;
                    }
                    if (e instanceof rn) return r = true;
                    if (e instanceof st) {
                        var t = e.definition();
                        if (y.variables.get(e.name) !== t) {
                            a = null;
                            return;
                        }
                        if (t.init instanceof un) return r = true;
                        if (we(e, this.parent())) return r = true;
                        var i = F(t);
                        if (!(o < i)) o = i;
                        if (!a) return;
                        if (s) {
                            a = null;
                        } else {
                            a.push(y.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        s = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = f.args.length;
                if (a && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > o && y.argnames[e] === a.pop()) ;
                    e++;
                }
                var n = s && !a && u.find_parent(rn);
                return e <= o || Fe(f.args.slice(o, e), n ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function N(e, n) {
                return e[n] || K[n] || $.var_names()[n];
            }
            function P(e, n, t) {
                for (var i = 0; i < y.argnames.length; i++) {
                    var r = y.argnames[i];
                    if (r.__unused) continue;
                    if (!t || N(e, r.name)) return false;
                    n[r.name] = true;
                    if (z) z.push(r.definition());
                }
                return true;
            }
            function H(n, e, t) {
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (r instanceof un) {
                        if (!t || N(e, r.name.name)) return false;
                        if (!Fe(r.enclosed, function(e) {
                            return e.scope === r || !n[e.name];
                        })) return false;
                        continue;
                    }
                    if (!(r instanceof Dn)) continue;
                    if (!t) return false;
                    for (var o = r.definitions.length; --o >= 0; ) {
                        var a = r.definitions[o].name;
                        if (N(n, a.name)) return false;
                        if (z) z.push(a.definition());
                    }
                }
                return true;
            }
            function I() {
                var n = Object.create(null);
                var e = 0, t;
                $ = u.self();
                while (!($ instanceof rn)) {
                    if ($.variables) $.variables.each(function(e) {
                        n[e.name] = true;
                    });
                    t = $;
                    $ = u.parent(e++);
                    if ($ instanceof Ke) {
                        z = [];
                    } else if ($ instanceof en) {
                        if ($.init === t) continue;
                        z = [];
                    } else if ($ instanceof nn) {
                        if ($.init === t) continue;
                        if ($.object === t) continue;
                        z = [];
                    } else if ($ instanceof st) {
                        if ($.fixed_value() instanceof rn) return false;
                    }
                }
                A = $.body.indexOf(t) + 1;
                if (!A) return false;
                var i = (!($ instanceof on) || u.toplevel.vars) && (a !== y || y.parent_scope.resolve() === u.find_parent(rn));
                var r = u.option("inline");
                var o = Object.create(n);
                if (!P(n, o, r >= 2 && i)) return false;
                if (!H(n, o, r >= 3 && i)) return false;
                return !z || z.length == 0 || !ae(y, z);
            }
            function R(e, n, t, i) {
                var r = t.definition();
                $.variables.set(t.name, r);
                $.enclosed.push(r);
                if (!$.var_names()[t.name]) {
                    $.var_names()[t.name] = true;
                    e.push(ve(An, t, {
                        name: t,
                        value: null
                    }));
                }
                if (!i) return;
                var o = ve(st, t, t);
                r.references.push(o);
                n.push(ve(Rn, f, {
                    operator: "=",
                    left: o,
                    right: i
                }));
            }
            function U(e, n) {
                var t = y.argnames.length;
                for (var i = f.args.length; --i >= t; ) {
                    n.push(f.args[i]);
                }
                for (i = t; --i >= 0; ) {
                    var r = y.argnames[i];
                    var o = f.args[i];
                    if (r.__unused || $.var_names()[r.name]) {
                        if (o) n.push(o);
                    } else {
                        var a = ve(tt, r, r);
                        r.definition().orig.push(a);
                        if (!o && z) o = ve(vt, f);
                        if ("__unused" in r) {
                            R(e, n, a);
                            if (o) n.push(o);
                        } else {
                            R(e, n, a, o);
                        }
                    }
                }
                e.reverse();
                n.reverse();
            }
            function B(e, n) {
                var t = n.length;
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (!(r instanceof Dn)) continue;
                    for (var o = 0; o < r.definitions.length; o++) {
                        var a = r.definitions[o];
                        var s = a.name;
                        var f = s.definition().redefined();
                        if (f) {
                            s = s.clone();
                            s.thedef = f;
                        }
                        R(e, n, s, a.value);
                        if (z && Fe(y.argnames, function(e) {
                            return e.name != s.name;
                        })) {
                            var u = y.variables.get(s.name);
                            var c = ve(st, s, s);
                            u.references.push(c);
                            n.splice(t++, 0, ve(Rn, a, {
                                operator: "=",
                                left: c,
                                right: ve(vt, s)
                            }));
                        }
                    }
                }
            }
            function Y() {
                var e = [];
                var n = [];
                U(e, n);
                B(e, n);
                n.push(E);
                var t = y.body.filter(function(e) {
                    if (e instanceof un) {
                        var n = e.name.definition();
                        $.functions.set(n.name, n);
                        $.variables.set(n.name, n);
                        $.enclosed.push(n);
                        $.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift(A, 0);
                if (e.length) t.push(ve(Dn, y, {
                    definitions: e
                }));
                [].splice.apply($.body, t);
                y.enclosed.forEach(function(e) {
                    if ($.var_names()[e.name]) return;
                    $.enclosed.push(e);
                    $.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e($n, function(e, n) {
            if (n.option("sequences")) {
                var t = te(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (X(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return ve(zn, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function P(t, i, e, n) {
            if (!(n instanceof Hn)) return;
            if (!be[n.operator]) return;
            if (!(n.right instanceof Rn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof st)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? ve(In, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : ve(In, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new wt(function(e) {
                    if (n) return true;
                    if (e instanceof st && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(jn, function(e, o) {
            var r = n();
            var a = r.length - 1;
            i();
            t();
            if (a == 0) {
                e = _e(o, o.parent(), o.self(), r[0]);
                if (!(e instanceof jn)) e = e.optimize(o);
                return e;
            }
            e.expressions = r;
            return e;
            function n() {
                if (!o.option("side_effects")) return e.expressions;
                var t = [];
                var i = Pe(o);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(o, i);
                    if (e) {
                        _(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!o.option("side_effects")) return;
                while (a > 0 && $(r[a], o)) a--;
                if (a < r.length - 1) {
                    r[a] = ve(Nn, e, {
                        operator: "void",
                        expression: r[a]
                    });
                    r.length = a + 1;
                }
            }
            function i() {
                if (!o.option("conditionals")) return;
                for (var e = 1; e < a; e++) {
                    var n = r[e - 1];
                    if (!(n instanceof Rn)) continue;
                    if (n.operator != "=") continue;
                    if (!(n.left instanceof st)) continue;
                    var t = n.left.definition();
                    var i = P(o, t, n.right, r[e]);
                    if (!i) continue;
                    n.right = i;
                    r.splice(e, 1);
                    a--;
                }
            }
        });
        e(Pn, function(e, n) {
            if (n.option("sequences")) {
                var t = te(e, n);
                if (t !== e) return t.optimize(n);
            }
            return ee(n, e);
        });
        var H = qe("+ -");
        var I = qe("* / %");
        e(Nn, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("evaluate") && t == "delete" && !(i instanceof st || i instanceof Mn || a(i))) {
                if (i instanceof jn) {
                    i = i.expressions.slice();
                    i.push(ve(yt, e));
                    return V(e, i).optimize(n);
                }
                return V(e, [ i, ve(yt, e) ]).optimize(n);
            }
            if (n.option("sequences") && !(t == "typeof" && X(i.tail_node()))) {
                var r = te(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && t == "void") {
                i = i.drop_side_effect_free(n);
                if (!i) return ve(vt, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("booleans")) {
                if (t == "!" && i.is_truthy()) {
                    return V(e, [ i, ve(bt, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (t) {
                  case "!":
                    if (i instanceof Nn && i.operator == "!") {
                        return i.expression;
                    }
                    if (i instanceof Hn) {
                        e = Z(n, e, i.negate(n, Pe(n)));
                    }
                    break;

                  case "typeof":
                    He.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    var o = [ ve(yt, e) ];
                    if (!(i instanceof st && de(i))) o.unshift(i);
                    return V(e, o).optimize(n);
                }
            }
            if (t == "-" && i instanceof mt) i = i.transform(n);
            if (n.option("evaluate") && i instanceof Hn && H[t] && I[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return ve(Hn, e, {
                    operator: i.operator,
                    left: ve(Nn, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return t == "-" && (i instanceof lt || i instanceof mt) ? e : ee(n, e);
        });
        Hn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Mn) {
                if (!(this.left.expression instanceof jn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return V(this, n);
            }
            if (this.left instanceof jn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return V(this, n);
            }
            if (this.right instanceof jn) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof st;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var o = 0; o < r; o++) {
                    if (!i && n[o].has_side_effects(e)) break;
                }
                if (o == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return V(this, n);
                }
                if (o > 0) {
                    var t = this.clone();
                    t.right = V(this.right, n.slice(o));
                    n = n.slice(0, o);
                    n.push(t);
                    return V(this, n);
                }
            }
            return this;
        });
        var B = qe("indexOf lastIndexOf");
        var Y = qe("== === != !== * & | ^");
        function xe(e) {
            if (e instanceof Rn) return e.operator == "=" && xe(e.right);
            if (e instanceof jn) return xe(e.tail_node());
            if (e instanceof st) return xe(e.fixed_value());
            return e instanceof Un || e instanceof an || e instanceof $n || e instanceof Wn;
        }
        function re(e, n) {
            if (n instanceof qn) return re(e, n.expression);
            if (n instanceof Fn) {
                return re(e, n.expression) && re(e, n.property);
            }
            if (n instanceof Qn) return true;
            return !n.has_side_effects(e);
        }
        e(Hn, function(i, a) {
            function t() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(a) && !i.right.has_side_effects(a);
            }
            function e(e) {
                if (t()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function n() {
                var e = i.right;
                i.left = ve(Hn, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(a);
            }
            if (Y[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof Hn && Et[i.left.operator] >= Et[i.operator])) {
                e();
            }
            if (a.option("sequences")) {
                var r = i.lift_sequences(a);
                if (r !== i) return r.optimize(a);
            }
            if (a.option("assignments") && be[i.operator]) {
                var o = i.right;
                if (i.left instanceof st && o instanceof Rn && o.operator == "=" && i.left.equivalent_to(o.left)) {
                    i.right = o.right;
                    o.right = i;
                    return o;
                }
            }
            if (a.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if ($(i.left, a) && i.right.is_defined(a)) {
                    He.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return V(i, [ i.right, ve(i.operator == "===" ? bt : yt, i) ]).optimize(a);
                }
                var s = true;
                if (i.left.is_string(a) && i.right.is_string(a) || i.left.is_number(a) && i.right.is_number(a) || i.left.is_boolean(a) && i.right.is_boolean(a) || re(a, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && $(i.left, a)) {
                    i.left = ve(dt, i.left);
                } else if (a.option("typeofs") && i.left instanceof ct && i.left.value == "undefined" && i.right instanceof Nn && i.right.operator == "typeof") {
                    var f = i.right.expression;
                    if (f instanceof st ? f.is_declared(a) : !(f instanceof Mn && a.option("ie8"))) {
                        i.right = f;
                        i.left = ve(vt, i.left).optimize(a);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof st && i.right instanceof st && i.left.definition() === i.right.definition() && xe(i.left)) {
                    return ve(i.operator[0] == "=" ? yt : bt, i).optimize(a);
                }
                break;

              case "&&":
              case "||":
                var u = i.left;
                if (u.operator == i.operator) {
                    u = u.right;
                }
                if (u instanceof Hn && u.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof Hn && u.operator == i.right.operator && ($(u.left, a) && i.right.left instanceof dt || u.left instanceof dt && $(i.right.left, a)) && !u.right.has_side_effects(a) && u.right.equivalent_to(i.right.right)) {
                    var c = ve(Hn, i, {
                        operator: u.operator.slice(0, -1),
                        left: ve(dt, i),
                        right: u.right
                    });
                    if (u !== i.left) {
                        c = ve(Hn, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = a.option("booleans") && a.in_boolean_context();
            if (l) switch (i.operator) {
              case "+":
                var p = i.left.evaluate(a);
                var d = i.right.evaluate(a);
                if (p && typeof p == "string") {
                    He.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return V(i, [ i.right, ve(yt, i) ]).optimize(a);
                }
                if (d && typeof d == "string") {
                    He.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return V(i, [ i.left, ve(yt, i) ]).optimize(a);
                }
                break;

              case "==":
                if (i.left instanceof ct && i.left.value == "" && i.right.is_string(a)) {
                    return ve(Nn, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(a);
                }
                break;

              case "!=":
                if (i.left instanceof ct && i.left.value == "" && i.right.is_string(a)) {
                    return i.right.optimize(a);
                }
                break;
            }
            var h = a.parent();
            if (a.option("comparisons") && i.is_boolean(a)) {
                if (!(h instanceof Hn) || h instanceof Rn) {
                    var v = Z(a, i, ve(Nn, i, {
                        operator: "!",
                        expression: i.negate(a, Pe(a))
                    }));
                    if (v !== i) return v;
                }
                switch (i.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (a.option("conditionals") && be[i.operator] && i.right instanceof Hn && i.operator == i.right.operator) {
                n();
            }
            if (a.option("strings") && i.operator == "+") {
                if (i.right instanceof ct && i.right.value == "" && i.left.is_string(a)) {
                    return i.left.optimize(a);
                }
                if (i.left instanceof ct && i.left.value == "" && i.right.is_string(a)) {
                    return i.right.optimize(a);
                }
                if (i.left instanceof Hn && i.left.operator == "+" && i.left.left instanceof ct && i.left.left.value == "" && i.right.is_string(a)) {
                    i.left = i.left.right;
                    return i.optimize(a);
                }
                if (i.right instanceof Hn && i.operator == i.right.operator && (i.left.is_string(a) && i.right.is_string(a) || i.right.left.is_string(a) && (i.left.is_constant() || !i.right.right.has_side_effects(a)))) {
                    n();
                }
            }
            if (a.option("evaluate")) {
                var _ = true;
                switch (i.operator) {
                  case "&&":
                    var p = T(i.left);
                    if (!p) {
                        He.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return _e(a, h, a.self(), i.left).optimize(a);
                    } else if (!(p instanceof He)) {
                        He.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return V(i, [ i.left, i.right ]).optimize(a);
                    }
                    var d = i.right.evaluate(a);
                    if (!d) {
                        if (l) {
                            He.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return V(i, [ i.left, ve(bt, i) ]).optimize(a);
                        } else i.falsy = true;
                    } else if (!(d instanceof He)) {
                        if (l || h.operator == "&&" && h.left === a.self()) {
                            He.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(a);
                        }
                    }
                    if (i.left.operator == "||") {
                        var m = i.left.right.evaluate(a, true);
                        if (!m) return ve(In, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(a);
                    }
                    break;

                  case "||":
                    var p = T(i.left);
                    if (!p) {
                        He.warn("Condition left of || always false [{file}:{line},{col}]", i.start);
                        return V(i, [ i.left, i.right ]).optimize(a);
                    } else if (!(p instanceof He)) {
                        He.warn("Condition left of || always true [{file}:{line},{col}]", i.start);
                        return _e(a, h, a.self(), i.left).optimize(a);
                    }
                    var d = i.right.evaluate(a);
                    if (!d) {
                        if (l || h.operator == "||" && h.left === a.self()) {
                            He.warn("Dropping side-effect-free || [{file}:{line},{col}]", i.start);
                            return i.left.optimize(a);
                        }
                    } else if (!(d instanceof He)) {
                        if (l) {
                            He.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return V(i, [ i.left, ve(yt, i) ]).optimize(a);
                        } else i.truthy = true;
                    }
                    if (i.left.operator == "&&") {
                        var m = i.left.right.is_truthy() || i.left.right.evaluate(a, true);
                        if (m && !(m instanceof He)) return ve(In, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(a);
                    }
                    break;

                  case "+":
                    if (i.left instanceof ut && i.right instanceof Hn && i.right.operator == "+" && i.right.left instanceof ut && i.right.is_string(a)) {
                        i = ve(Hn, i, {
                            operator: "+",
                            left: ve(ct, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof ut && i.left instanceof Hn && i.left.operator == "+" && i.left.right instanceof ut && i.left.is_string(a)) {
                        i = ve(Hn, i, {
                            operator: "+",
                            left: i.left.left,
                            right: ve(ct, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof Nn && i.right.operator == "-" && i.left.is_number(a)) {
                        i = ve(Hn, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof Nn && i.left.operator == "-" && t() && i.right.is_number(a)) {
                        i = ve(Hn, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (a.option("unsafe_math") && i.left instanceof Hn && Et[i.left.operator] == Et[i.operator] && i.right.is_constant() && (i.right.is_boolean(a) || i.right.is_number(a)) && i.left.is_number(a) && !i.left.right.is_constant() && (i.left.left.is_boolean(a) || i.left.left.is_number(a))) {
                        i = ve(Hn, i, {
                            operator: i.left.operator,
                            left: ve(Hn, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof Nn && i.right.operator == "-" && i.left.is_number(a) && i.right.expression.is_number(a)) {
                        i = ve(Hn, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    _ = a.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof Nn && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(a) || t.is_number(a) || t.is_string(a)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(a) || i.left.is_number(a)) && (i.right.is_boolean(a) || i.right.is_number(a)) && t() && !(i.left instanceof Hn && i.left.operator != i.operator && Et[i.left.operator] >= Et[i.operator])) {
                        var g = ve(Hn, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof ut && !(i.left instanceof ut)) {
                            i = Z(a, g, i);
                        } else {
                            i = Z(a, i, g);
                        }
                    }
                    if (!_ || !i.is_number(a)) break;
                    if (i.right instanceof Hn && i.right.operator != "%" && Et[i.right.operator] == Et[i.operator] && i.right.is_number(a) && (i.operator != "+" || i.right.left.is_boolean(a) || i.right.left.is_number(a)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(a))) {
                        i = ve(Hn, i, {
                            operator: E(i.operator, i.right.operator),
                            left: ve(Hn, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(a) && !i.right.is_number(a)) {
                            i.right = ve(Nn, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof ut && i.left instanceof Hn && i.left.operator != "%" && Et[i.left.operator] == Et[i.operator] && i.left.is_number(a)) {
                        if (i.left.left instanceof ut) {
                            var u = S(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = S(i, i.left.operator, ee(a, u), i.left.right);
                        } else if (i.left.right instanceof ut) {
                            var b = E(i.left.operator, i.operator);
                            var y = ee(a, S(i.left, b, i.left.right, i.right));
                            if (y.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +y.value == 0 && i.left.left.is_negative_zero())) {
                                i = S(i, i.left.operator, i.left.left, y);
                            }
                        }
                    }
                    break;
                }
                if (!(h instanceof Nn && h.operator == "delete")) {
                    if (i.left instanceof lt && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(a)) return ve(Nn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(a);
                            if (i.right.is_number(a) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(a) ? i.right : ve(Nn, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(a);
                        }
                        break;
                    }
                    if (i.right instanceof lt && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(a)) return ve(Nn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(a);
                            if (i.left.is_number(a) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(a) ? i.left : ve(Nn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(a);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(a) ? i.left : ve(Nn, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(a);
                        }
                        break;
                    }
                }
            }
            if (a.option("typeofs")) switch (i.operator) {
              case "&&":
                F(i.left, i.right, null);
                break;

              case "||":
                F(i.left, null, i.right);
                break;
            }
            if (a.option("unsafe")) {
                var w = O(i.right);
                if (l && w && (i.operator == "==" || i.operator == "!=") && i.left instanceof lt && i.left.value == 0) {
                    return (i.operator == "==" ? ve(Nn, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(a);
                }
                var x = O(i.left);
                if (a.option("comparisons") && D()) {
                    var k = ve(Nn, i, {
                        operator: "!",
                        expression: ve(Nn, i, {
                            operator: "~",
                            expression: x ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (x) break;

                      case "<=":
                      case "!=":
                        k = ve(Nn, i, {
                            operator: "!",
                            expression: k
                        });
                        break;
                    }
                    return k.optimize(a);
                }
            }
            return ee(a, i);
            function E(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function S(e, n, t, i, r, o) {
                if (n == "+") {
                    if (!t.is_boolean(a) && !t.is_number(a)) {
                        t = ve(Nn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(a) && !i.is_number(a)) {
                        i = ve(Nn, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return ve(Hn, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: o
                });
            }
            function T(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(a, true);
            }
            function O(e) {
                return e.TYPE == "Call" && e.expression instanceof qn && B[e.expression.property];
            }
            function D() {
                switch (i.operator) {
                  case "<=":
                    return w && i.left instanceof lt && i.left.value == 0;

                  case "<":
                    if (x && i.right instanceof lt && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!w) return false;
                    return i.left instanceof lt && i.left.value == -1 || i.left instanceof Nn && i.left.operator == "-" && i.left.expression instanceof lt && i.left.expression.value == 1;
                }
            }
        });
        function ke(e, n) {
            var t = 0, i = e.self();
            do {
                if (i instanceof an && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(t++));
        }
        e(st, function(e, n) {
            if (!n.option("ie8") && X(e) && !(e.scope.resolve().uses_with && n.find_parent(tn))) {
                switch (e.name) {
                  case "undefined":
                    return ve(vt, e).optimize(n);

                  case "NaN":
                    return ve(ht, e).optimize(n);

                  case "Infinity":
                    return ve(mt, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && we(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var o = i.single_use && !(t instanceof zn && t.is_expr_pure(n));
                if (o) {
                    if (r instanceof an) {
                        if ((i.scope !== e.scope.resolve() || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            o = false;
                        } else if (ke(n, i)) {
                            o = false;
                        } else if (r.name && r.name.definition() !== i) {
                            o = false;
                        } else if (r.parent_scope !== e.scope.resolve() || i.orig[0] instanceof it) {
                            o = r.is_constant_expression(e.scope);
                            if (o == "f") {
                                var a = e.scope;
                                do {
                                    if (a instanceof un || a instanceof fn) {
                                        a.inlined = true;
                                    }
                                } while (a = a.parent_scope);
                            }
                        }
                        if (o) r.parent_scope = e.scope;
                    } else if (!r || !r.is_constant_expression()) {
                        o = false;
                    }
                }
                if (o) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof un) {
                        r = ve(fn, r, r);
                        r.name = ve(ot, r.name, r.name);
                    }
                    if (r instanceof an) {
                        var a = e.scope.resolve();
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (a.var_names()[e.name]) return;
                            a.enclosed.push(e);
                            a.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        if (!(c instanceof ot)) {
                            c = ve(ot, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s.def_function(c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new wt(function(e) {
                            if (!(e instanceof st)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof an)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        s = r.optimize(n);
                        if (s === r) s = s.transform(new Tt(function(e, n) {
                            if (e instanceof rn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                var l = e.fixed !== i.fixed;
                if (r && (l || i.should_replace !== false)) {
                    var p;
                    if (r instanceof ft) {
                        if (!(i.orig[0] instanceof it) && g(i)) {
                            p = r;
                        }
                    } else {
                        var d = r.evaluate(n, true);
                        if (d !== r && typeof d != "function" && (typeof d != "object" || d instanceof RegExp && n.option("unsafe_regexp") && !i.cross_loop && g(i))) {
                            p = O(d, r);
                        }
                    }
                    if (p) {
                        if (!l && i.should_replace === undefined) {
                            var h = p.optimize(n).print_to_string().length;
                            if (!b(r)) {
                                h = Math.min(h, r.print_to_string().length);
                            }
                            var v = i.name.length;
                            if (n.option("unused") && !n.exposed(i)) {
                                var _ = i.references.length - i.replaced;
                                v += (v + 2 + h) / (_ - i.assignments);
                            }
                            var m = h - Math.floor(v);
                            i.should_replace = m < n.eval_threshold;
                        }
                        if (l || i.should_replace) {
                            var s;
                            if (b(r)) {
                                s = p.optimize(n);
                                if (s === p) s = s.clone(true);
                            } else {
                                s = Q(p.optimize(n), r);
                                if (s === p || s === r) s = s.clone(true);
                            }
                            i.replaced++;
                            return s;
                        }
                    }
                }
            }
            return e;
            function g(e) {
                var n = e.scope.resolve();
                return Fe(e.references, function(e) {
                    return n === e.scope.resolve();
                });
            }
            function b(e) {
                var n;
                e.walk(new wt(function(e) {
                    if (e instanceof st) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function oe(e, n) {
            return e instanceof st || e.TYPE === n.TYPE;
        }
        e(vt, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = L(n).find_variable("undefined");
                if (t) {
                    var i = ve(st, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = we(n.self(), n.parent());
            if (r && oe(r, e)) return e;
            return ve(Nn, e, {
                operator: "void",
                expression: ve(lt, e, {
                    value: 0
                })
            });
        });
        e(mt, function(e, n) {
            var t = we(n.self(), n.parent());
            if (t && oe(t, e)) return e;
            if (n.option("keep_infinity") && !(t && !oe(t, e)) && !L(n).find_variable("Infinity")) return e;
            return ve(Hn, e, {
                operator: "/",
                left: ve(lt, e, {
                    value: 1
                }),
                right: ve(lt, e, {
                    value: 0
                })
            });
        });
        e(ht, function(e, n) {
            var t = we(n.self(), n.parent());
            if (t && !oe(t, e) || L(n).find_variable("NaN")) {
                return ve(Hn, e, {
                    operator: "/",
                    left: ve(lt, e, {
                        value: 0
                    }),
                    right: ve(lt, e, {
                        value: 0
                    })
                });
            }
            return e;
        });
        function ae(t, n) {
            var i = false;
            var r = new wt(function(e) {
                if (i) return true;
                if (e instanceof st && Ee(e.definition(), n)) {
                    return i = true;
                }
            });
            var o = new wt(function(e) {
                if (i) return true;
                if (e instanceof rn && e !== t) {
                    var n = o.parent();
                    if (n instanceof zn && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(o);
            return i;
        }
        var se = qe("+ - * / % >> << >>> | ^ &");
        var fe = qe("* | ^ &");
        e(Rn, function(o, a) {
            if (a.option("dead_code")) {
                if (o.left instanceof Mn) {
                    if (o.operator == "=") {
                        if (o.__drop) {
                            var e = [ o.left.expression ];
                            if (o.left instanceof Fn) e.push(o.left.property);
                            e.push(o.right);
                            return V(o, e).optimize(a);
                        }
                        if (o.left.equivalent_to(o.right) && !o.left.has_side_effects(a)) {
                            return o.right;
                        }
                        var n = o.left.expression;
                        if (n instanceof an || !a.has_directive("use strict") && n instanceof ut && !n.may_throw_on_access(a)) {
                            return o.left instanceof qn ? o.right : V(o, [ o.left.property, o.right ]).optimize(a);
                        }
                    }
                } else if (o.left instanceof st && Fe(o.left.definition().orig, function(e) {
                    return !(e instanceof et);
                })) {
                    var t;
                    if (o.operator == "=" && o.left.equivalent_to(o.right) && !((t = a.parent()) instanceof Nn && t.operator == "delete")) {
                        return o.right;
                    }
                    if (o.left.is_immutable()) return d();
                    var i = o.left.definition();
                    var s = i.scope.resolve();
                    var r = s === a.find_parent(an);
                    var f = 0, u;
                    t = o;
                    do {
                        u = t;
                        t = a.parent(f++);
                        if (t instanceof Rn) {
                            if (t.left instanceof Mn) break;
                            if (!(t.left instanceof st)) continue;
                            if (t.left.definition() !== i) continue;
                            if (p(f, t)) break;
                            i.fixed = false;
                            return d();
                        } else if (t instanceof ln) {
                            if (!r) break;
                            if (p(f, t)) break;
                            if (ae(s, [ i ])) break;
                            i.fixed = false;
                            return d();
                        } else if (t instanceof An) {
                            if (!(t.name instanceof Zn)) continue;
                            if (t.name.definition() !== i) continue;
                            if (p(f, t)) break;
                            i.fixed = false;
                            return d();
                        }
                    } while (t instanceof Hn && t.right === u || t instanceof jn && t.tail_node() === u || t instanceof Nn);
                }
            }
            if (a.option("sequences")) {
                var c = o.lift_sequences(a);
                if (c !== o) return c.optimize(a);
            }
            if (a.option("assignments")) {
                if (o.operator == "=" && o.left instanceof st && o.right instanceof Hn) {
                    if (o.right.left instanceof st && o.right.left.name == o.left.name && se[o.right.operator]) {
                        return ve(Rn, o, {
                            operator: o.right.operator + "=",
                            left: o.left,
                            right: o.right.right
                        }).optimize(a);
                    } else if (o.right.right instanceof st && o.right.right.name == o.left.name && fe[o.right.operator] && !o.right.left.has_side_effects(a)) {
                        return ve(Rn, o, {
                            operator: o.right.operator + "=",
                            left: o.left,
                            right: o.right.left
                        }).optimize(a);
                    }
                }
                if ((o.operator == "-=" || o.operator == "+=" && (o.left.is_boolean(a) || o.left.is_number(a))) && o.right instanceof lt && o.right.value == 1) {
                    var l = o.operator.slice(0, -1);
                    return ve(Nn, o, {
                        operator: l + l,
                        expression: o.left
                    });
                }
            }
            return ee(a, o);
            function p(e, n) {
                var t = o.right;
                o.right = ve(dt, t);
                var i = n.may_throw(a);
                o.right = t;
                var r;
                while (r = a.parent(e++)) {
                    if (r === s) return false;
                    if (r instanceof xn) {
                        if (r.bfinally) return true;
                        if (i && r.bcatch) return true;
                    }
                }
            }
            function d() {
                return (o.operator != "=" ? ve(Hn, o, {
                    operator: o.operator.slice(0, -1),
                    left: o.left,
                    right: o.right
                }) : _e(a, a.parent(), o, o.right)).optimize(a);
            }
        });
        e(In, function(o, n) {
            if (n.option("sequences") && o.condition instanceof jn) {
                var e = o.condition.expressions.slice();
                o.condition = e.pop();
                e.push(o);
                return V(o, e);
            }
            if (!n.option("conditionals")) return o;
            var a = o.condition.is_truthy() || o.condition.evaluate(n, true);
            if (!a) {
                He.warn("Condition always false [{file}:{line},{col}]", o.start);
                return V(o, [ o.condition, o.alternative ]).optimize(n);
            } else if (!(a instanceof He)) {
                He.warn("Condition always true [{file}:{line},{col}]", o.start);
                return V(o, [ o.condition, o.consequent ]).optimize(n);
            }
            var t = a.negate(n, Pe(n));
            if (Z(n, a, t) === t) {
                o = ve(In, o, {
                    condition: t,
                    consequent: o.alternative,
                    alternative: o.consequent
                });
                t = a;
                a = o.condition;
            }
            var i = o.consequent;
            var r = o.alternative;
            if (re(n, a)) {
                if (a.equivalent_to(i)) return ve(Hn, o, {
                    operator: "||",
                    left: a,
                    right: r
                }).optimize(n);
                if (a.equivalent_to(r)) return ve(Hn, o, {
                    operator: "&&",
                    left: a,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof Rn) {
                var f = s.operator == "=";
                var u = f ? r.tail_node() : r;
                if ((f || i === s) && u instanceof Rn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof st || !a.has_side_effects(n) && y(i) && y(r))) {
                    return ve(Rn, o, {
                        operator: s.operator,
                        left: s.left,
                        right: ve(In, o, {
                            condition: a,
                            consequent: w(i),
                            alternative: w(r)
                        })
                    });
                }
            }
            if (i.equivalent_to(r)) return V(o, [ a, i ]).optimize(n);
            var c = b(i, r, true);
            if (c) return c;
            var l;
            if (i instanceof zn && r.TYPE == i.TYPE && (l = m(i, r)) >= 0 && i.expression.equivalent_to(r.expression) && !a.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var p = i.clone();
                p.args[l] = ve(In, o, {
                    condition: a,
                    consequent: i.args[l],
                    alternative: r.args[l]
                });
                return p;
            }
            if (i instanceof In && i.alternative.equivalent_to(r)) {
                return ve(In, o, {
                    condition: ve(Hn, o, {
                        left: a,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: r
                });
            }
            if (i instanceof In && i.consequent.equivalent_to(r)) {
                return ve(In, o, {
                    condition: ve(Hn, o, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: r,
                    alternative: i.alternative
                });
            }
            if (r instanceof In && i.equivalent_to(r.consequent)) {
                return ve(In, o, {
                    condition: ve(Hn, o, {
                        left: a,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: i,
                    alternative: r.alternative
                });
            }
            if (r instanceof In && i.equivalent_to(r.alternative)) {
                return ve(In, o, {
                    condition: ve(Hn, o, {
                        left: t,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: i
                });
            }
            if ((i instanceof jn || r instanceof jn) && i.tail_node().equivalent_to(r.tail_node())) {
                return V(o, [ ve(In, o, {
                    condition: a,
                    consequent: x(i),
                    alternative: x(r)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof Hn && i.operator == "&&" && i.right.equivalent_to(r)) {
                return ve(Hn, o, {
                    operator: "&&",
                    left: ve(Hn, o, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (i instanceof Hn && i.operator == "||" && i.right.equivalent_to(r)) {
                return ve(Hn, o, {
                    operator: "||",
                    left: ve(Hn, o, {
                        operator: "&&",
                        left: a,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (r instanceof Hn && r.operator == "&&" && r.right.equivalent_to(i)) {
                return ve(Hn, o, {
                    operator: "&&",
                    left: ve(Hn, o, {
                        operator: "||",
                        left: a,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (r instanceof Hn && r.operator == "||" && r.right.equivalent_to(i)) {
                return ve(Hn, o, {
                    operator: "||",
                    left: ve(Hn, o, {
                        operator: "&&",
                        left: t,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            var d = n.option("booleans") && n.in_boolean_context();
            if (v(i)) {
                if (_(r)) {
                    return h(a);
                }
                return ve(Hn, o, {
                    operator: "||",
                    left: h(a),
                    right: r
                });
            }
            if (_(i)) {
                if (v(r)) {
                    return h(a.negate(n));
                }
                return ve(Hn, o, {
                    operator: "&&",
                    left: h(a.negate(n)),
                    right: r
                });
            }
            if (v(r)) {
                return ve(Hn, o, {
                    operator: "||",
                    left: h(a.negate(n)),
                    right: i
                });
            }
            if (_(r)) {
                return ve(Hn, o, {
                    operator: "&&",
                    left: h(a),
                    right: i
                });
            }
            if (n.option("typeofs")) F(a, i, r);
            return o;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return ve(Nn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function v(e) {
                return e instanceof yt || d && e instanceof ut && e.value || e instanceof Nn && e.operator == "!" && e.expression instanceof ut && !e.expression.value;
            }
            function _(e) {
                return e instanceof bt || d && (e instanceof ut && !e.value || e instanceof Nn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof Nn && e.operator == "!" && e.expression instanceof ut && e.expression.value;
            }
            function m(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var o = 0; o < r; o++) {
                    if (!t[o].equivalent_to(i[o])) {
                        for (var a = o + 1; a < r; a++) {
                            if (!t[a].equivalent_to(i[a])) return -2;
                        }
                        return o;
                    }
                }
                return -1;
            }
            function g(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e instanceof zn) {
                    if (m(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Mn || n.expression instanceof Mn) || g(e.expression, n.expression);
                }
                if (e instanceof qn) return e.property == n.property;
                if (e instanceof Fn) return e.property.equivalent_to(n.property);
            }
            function b(e, n, t) {
                if (!g(e, n)) return !t && ve(In, o, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var i = b(e.expression, n.expression);
                if (!i) return;
                var r = e.clone();
                r.expression = i;
                return r;
            }
            function y(e) {
                return e === e.tail_node() || Fe(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function w(e) {
                if (!(e instanceof jn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return V(e, n);
            }
            function x(e) {
                if (!(e instanceof jn)) return ve(lt, e, {
                    value: 0
                });
                return V(e, e.expressions.slice(0, -1));
            }
        });
        e(gt, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return ve(lt, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof Hn && (t.operator == "==" || t.operator == "!=")) {
                He.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return ve(lt, e, {
                    value: +e.value
                });
            }
            return ve(Nn, e, {
                operator: "!",
                expression: ve(lt, e, {
                    value: 1 - e.value
                })
            });
        });
        function ue(e, n) {
            if (e instanceof st) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof an)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(Fn, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var o = parseFloat(r);
                            if (o.toString() == r) {
                                r = o;
                            }
                        }
                    }
                    i = e.property = Q(i, O(r, i).transform(t));
                    var a = "" + r;
                    if (xt(a) && a.length <= i.print_to_string().length + 1) {
                        return ve(qn, e, {
                            expression: n,
                            property: a
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f = we(t.self(), s);
            var u, c, l;
            if (t.option("arguments") && n instanceof st && pe(u = n.definition()) && i instanceof lt && (c = n.scope.resolve()) === E() && !(f && c.uses_arguments === "d")) {
                var p = i.value;
                if (s instanceof Nn && s.operator == "delete") {
                    if (!u.deleted) u.deleted = [];
                    u.deleted[p] = true;
                }
                var d = c.argnames[p];
                if (u.deleted && u.deleted[p]) {
                    d = null;
                } else if (d && (t.has_directive("use strict") || !(l instanceof zn && p < l.args.length))) {
                    var h = d.definition();
                    if (!t.option("reduce_vars") || u.reassigned || h.assignments || h.orig.length > 1) {
                        d = null;
                    }
                } else if (!d && p < c.argnames.length + 5 && t.drop_fargs(c, l)) {
                    while (p >= c.argnames.length) {
                        d = c.make_var(it, c, "argument_" + c.argnames.length);
                        c.argnames.push(d);
                    }
                }
                if (d && ce(function(e) {
                    return e.name === d.name;
                }, c.argnames) === d) {
                    u.reassigned = false;
                    var v = ve(st, e, d);
                    v.reference({});
                    delete d.__unused;
                    return v;
                }
            }
            if (f) return e;
            if (t.option("sequences") && s.TYPE != "Call" && !(s instanceof nn && s.init === e)) {
                var _ = te(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (r !== i) {
                var m = e.flatten_object(a, t);
                if (m) {
                    n = e.expression = m.expression;
                    i = e.property = m.property;
                }
            }
            if (t.option("properties") && t.option("side_effects") && i instanceof lt && n instanceof Un) {
                var p = i.value;
                var g = n.elements;
                var b = g[p];
                if (ue(b, t)) {
                    var y = b instanceof _t;
                    var w = !y;
                    var x = [];
                    for (var k = g.length; --k > p; ) {
                        var o = g[k].drop_side_effect_free(t);
                        if (o) {
                            x.unshift(o);
                            if (w && o.has_side_effects(t)) w = false;
                        }
                    }
                    if (!w) x.unshift(b);
                    while (--k >= 0) {
                        var o = g[k].drop_side_effect_free(t);
                        if (o) {
                            x.unshift(o);
                        } else if (y) {
                            x.unshift(ve(_t, g[k]));
                        } else {
                            p--;
                        }
                    }
                    if (w) {
                        x.push(b);
                        return V(e, x).optimize(t);
                    } else return ve(Fn, e, {
                        expression: ve(Un, n, {
                            elements: x
                        }),
                        property: ve(lt, i, {
                            value: p
                        })
                    });
                }
            }
            return ee(t, e);
            function E() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof an) {
                        if (n instanceof sn) return;
                        l = t.parent(e);
                        return n;
                    }
                }
            }
        });
        rn.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new wt(function(e) {
                if (n) return true;
                if (e instanceof ft) return n = true;
                if (e !== t && e instanceof rn) return true;
            }));
            return n;
        });
        Mn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof Wn) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var o = i[r];
                    if (o.key != e) continue;
                    if (!Fe(i, function(e) {
                        return e instanceof Gn && typeof e.key == "string";
                    })) break;
                    if (!ue(o.value, n)) break;
                    return ve(Fn, this, {
                        expression: ve(Un, t, {
                            elements: i.map(function(e) {
                                return e.value;
                            })
                        }),
                        property: ve(lt, this, {
                            value: r
                        })
                    });
                }
            }
        });
        e(qn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                He.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (we(n.self(), t)) return e;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof nn && t.init === e)) {
                var i = te(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof qn && e.expression.property == "prototype") {
                var r = e.expression.expression;
                if (X(r)) switch (r.name) {
                  case "Array":
                    e.expression = ve(Un, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = ve(fn, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(r.scope);
                    break;

                  case "Number":
                    e.expression = ve(lt, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = ve(Wn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = ve(pt, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = ve(ct, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return ee(n, e);
        });
        e(Ln, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof He) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(Wn, function(t, n) {
            if (!n.option("objects") || n.has_directive("use strict")) return t;
            for (var e = t.properties.length; --e >= 0; ) {
                var i = t.properties[e];
                var r = i.key;
                if (r instanceof He) r = r.evaluate(n);
                if (typeof r != "string" || /[0-9]+/.test(r)) break;
                if (r !== i.key) i.key = "" + r;
            }
            var o = new Ce();
            var a = [];
            t.properties.forEach(function(e) {
                if (e instanceof Gn && typeof e.key == "string") {
                    if (e.value.has_side_effects(n)) s();
                    o.add(e.key, e.value);
                } else {
                    s();
                    a.push(e);
                }
            });
            s();
            if (t.properties.length != a.length) return ve(Wn, t, {
                properties: a
            });
            return t;
            function s() {
                o.each(function(e, n) {
                    a.push(ve(Gn, t, {
                        key: n,
                        value: V(t, e)
                    }));
                });
                o = new Ce();
            }
        });
        e(pn, function(e, n) {
            if (e.value && $(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var w = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var x = w.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function S(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, o = 0; r < n.length; r++) {
            var a = x[n[r]];
            t += (a & 31) << i;
            if (a & 32) {
                i += 5;
            } else {
                e[o++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return o;
    }
    function T(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += w[t];
        } while (e);
        return n;
    }
    function O() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!Ne(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function D(l) {
        var f = O();
        var o = l.includeSources && Object.create(null);
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, S(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!o || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) o[n.sources[i]] = r;
            }
        });
        var p;
        var d = 1;
        var h = 0;
        var v = 0;
        var _ = 1;
        var m = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, o) {
                var a = l.orig[e];
                if (a) {
                    var s = a.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = a.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) o = a.names[f[4]];
                    }
                }
                b(e, n, t, i, r, o);
            } : b,
            setSourceContent: o ? function(e, n) {
                o[e] = n;
            } : Se,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: o ? f.map(function(e) {
                        return o[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, o) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                h = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += T(t - h);
            h = t;
            if (e == null) return;
            var a = f.index(e);
            c += T(a - v);
            v = a;
            c += T(i - _);
            _ = i;
            c += T(r - m);
            m = r;
            if (l.names && o != null) {
                var s = u.index(o);
                c += T(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof Ie && e[t].body instanceof ct) {
                    e[t] = new Ue({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof Ie && e[t].body instanceof ct)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new on({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new un({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new fn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new Ye({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new xn({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new En(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: "" + n[n.type == "Identifier" ? "name" : "value"],
                    value: u(e.value)
                };
                if (e.kind == "init") return new Gn(t);
                t.value = new sn(t.value);
                if (e.kind == "get") return new Kn(t);
                if (e.kind == "set") return new Xn(t);
            },
            ArrayExpression: function(e) {
                return new Un({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new _t() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new Wn({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new jn({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? Fn : qn)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? wn : yn)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new Dn({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new dt(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new pt(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new pt(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new ct(t);

                  case "number":
                    t.value = n;
                    return new lt(t);

                  case "boolean":
                    return new (n ? yt : bt)(t);
                }
            },
            Identifier: function(e) {
                var n = o[o.length - 2];
                return new (n.type == "LabeledStatement" ? se : n.type == "VariableDeclarator" && n.id === e ? tt : n.type == "FunctionExpression" ? n.id === e ? ot : it : n.type == "FunctionDeclaration" ? n.id === e ? rt : it : n.type == "CatchClause" ? at : n.type == "BreakStatement" || n.type == "ContinueStatement" ? fe : st)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            ThisExpression: function(e) {
                return new ft({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? Nn : Pn)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", Be);
        e("BlockStatement", Je, "body@body");
        e("IfStatement", mn, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", Ge, "label>label, body>body");
        e("BreakStatement", vn, "label>label");
        e("ContinueStatement", _n, "label>label");
        e("WithStatement", tn, "object>expression, body>body");
        e("SwitchStatement", gn, "discriminant>expression, cases@body");
        e("ReturnStatement", pn, "argument>value");
        e("ThrowStatement", dn, "argument>value");
        e("WhileStatement", Ze, "test>condition, body>body");
        e("DoWhileStatement", Qe, "test>condition, body>body");
        e("ForStatement", en, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", nn, "left>init, right>object, body>body");
        e("DebuggerStatement", Re);
        e("VariableDeclarator", An, "id>name, init>value");
        e("CatchClause", kn, "param>argname, body%body");
        e("BinaryExpression", Hn, "operator=operator, left>left, right>right");
        e("LogicalExpression", Hn, "operator=operator, left>left, right>right");
        e("AssignmentExpression", Rn, "operator=operator, left>left, right>right");
        e("ConditionalExpression", In, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", $n, "callee>expression, arguments@args");
        e("CallExpression", zn, "callee>expression, arguments@args");
        c(on, function e(n) {
            return d("Program", n);
        });
        c(un, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(fn, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(Ue, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(Ye, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(bn, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(xn, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(kn, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(Sn, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(jn, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(Mn, function e(n) {
            var t = n instanceof Fn;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(Cn, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof Nn,
                argument: l(n.expression)
            };
        });
        c(Hn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(Un, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(Wn, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(Jn, function e(n) {
            var t = {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof Gn) {
                i = "init";
            } else if (n instanceof Kn) {
                i = "get";
            } else if (n instanceof Xn) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(Qn, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(ft, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(pt, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c(ut, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(v, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        gt.DEFMETHOD("to_mozilla_ast", ut.prototype.to_mozilla_ast);
        dt.DEFMETHOD("to_mozilla_ast", ut.prototype.to_mozilla_ast);
        _t.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        We.DEFMETHOD("to_mozilla_ast", Je.prototype.to_mozilla_ast);
        an.DEFMETHOD("to_mozilla_ast", fn.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var o = "function From_Moz_" + e + "(M){\n";
            o += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var a = "function To_Moz_" + e + "(M){\n";
            a += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                o += ",\n" + r + ": ";
                a += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    o += "M." + t + ".map(from_moz)";
                    a += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    o += "from_moz(M." + t + ")";
                    a += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    o += "M." + t;
                    a += "M." + r;
                    break;

                  case "%":
                    o += "from_moz(M." + t + ").body";
                    a += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            o += "\n})\n}";
            a += "\n}\n}";
            o = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + o + ")")(h, s, f, u);
            a = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + a + ")")(l, p, d);
            i[e] = o;
            c(n, a);
        }
        var o = null;
        function u(e) {
            o.push(e);
            var n = e != null ? i[e.type](e) : null;
            o.pop();
            return n;
        }
        He.from_mozilla_ast = function(e) {
            var n = o;
            o = [];
            var t = u(e);
            o = n;
            t.walk(new wt(function(e) {
                if (e instanceof fe) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof rn) break;
                        if (t instanceof Ge && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        le("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof Ye && n.body[0].body instanceof ct) {
                t.unshift(l(new Be(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var A = function() {
        var n = [];
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return qe(n);
        function t(e) {
            n.push(e);
        }
    }();
    function z(e, n) {
        e.walk(new wt(function(e) {
            if (e instanceof Jn) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Fn) {
                $(e.property, t);
            }
        }));
        function t(e) {
            $e(n, e);
        }
    }
    function $(e, n) {
        if (e instanceof In) {
            $(e.consequent, n);
            $(e.alternative, n);
        } else if (e instanceof jn) {
            $(e.tail_node(), n);
        } else if (e instanceof ct) {
            n(e.value);
        }
    }
    function Y(e, t) {
        t = ae(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = Object.create(t.builtins ? null : A);
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n[e] = true;
        });
        var i = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n[e] = true;
            });
        } else {
            r = new Ce();
        }
        var o = t.regex;
        var a = t.debug !== false;
        var s;
        if (a) s = t.debug === true ? "" : t.debug;
        var f = Object.create(null);
        var u = Object.create(n);
        e.walk(new wt(function(e) {
            if (e instanceof Hn) {
                if (e.operator == "in") $(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof qn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof st)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    $(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    $(e.args[0], p);
                    break;
                }
            } else if (e instanceof qn) {
                p(e.property);
            } else if (e instanceof Jn) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof Fn) {
                $(e.property, p);
            }
        }));
        e.walk(new wt(function(e) {
            if (e instanceof Hn) {
                if (e.operator == "in") h(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof qn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof st)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    h(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    h(e.args[0]);
                    break;
                }
            } else if (e instanceof qn) {
                e.property = d(e.property);
            } else if (e instanceof Jn) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof Fn) {
                if (!t.keep_quoted) h(e.property);
            }
        }));
        function c(e) {
            if (u[e]) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n[e]) return false;
            if (o && !o.test(e)) return false;
            return r.has(e) || f[e];
        }
        function p(e) {
            if (c(e)) f[e] = true;
            if (!l(e)) u[e] = true;
        }
        function d(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (a) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = y(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function h(e) {
            if (e instanceof jn) {
                h(e.expressions.tail_node());
            } else if (e instanceof ct) {
                e.value = d(e.value);
            } else if (e instanceof In) {
                h(e.consequent);
                h(e.alternative);
            }
        }
    }
    "use strict";
    var L, V;
    if (typeof Buffer == "undefined") {
        L = atob;
        V = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        L = function(e) {
            return new Buffer(e, "base64").toString();
        };
        V = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        L = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        V = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function W(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var o = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!o) break;
            if (o[1] == "sourceMappingURL") {
                o = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(o[2]);
                if (!o) break;
                return L(o[2]);
            }
        }
        He.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function J(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function G(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function X(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new Ce();
        } else if (!(e.props instanceof Ce)) {
            e.props = Ce.fromObject(e.props);
        }
    }
    function ie(e) {
        return {
            props: e.props.toObject()
        };
    }
    function re(i, r) {
        try {
            r = ae(r, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (r.validate) He.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) {
                r.rename = r.compress && r.mangle;
            }
            G("ie8", r, [ "compress", "mangle", "output" ]);
            G("keep_fnames", r, [ "compress", "mangle" ]);
            G("toplevel", r, [ "compress", "mangle" ]);
            G("webkit", r, [ "mangle", "output" ]);
            var n;
            if (r.mangle) {
                r.mangle = ae(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    webkit: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                X(r.mangle.cache);
                X(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = ae(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) He.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var o;
            if (i instanceof on) {
                o = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var a = r.sourceMap && r.sourceMap.content;
                if (typeof a == "string" && a != "inline") {
                    a = J(a);
                }
                if (a) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (Ne(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = o = St(i[s], r.parse);
                    if (a == "inline") {
                        var f = W(s, o);
                        if (f) {
                            r.sourceMap.orig[s] = J(f);
                        }
                    } else if (a) {
                        r.sourceMap.orig[s] = a;
                    }
                }
            }
            if (n) {
                z(o, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = o.print_to_string().slice(0, -1);
                o = o[e](n);
                i[o.start.file] = o.print_to_string().replace(t, "");
            });
            if (r.validate) o.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                o.figure_out_scope(r.mangle);
                o.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                o = new Dt(r.compress).compress(o);
                if (r.validate) o.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) o.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                o.compute_char_frequency(r.mangle);
                o.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) Y(o, r.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            if (r.output.ast) {
                u.ast = o;
            }
            if (!Ne(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = D(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof on) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (Ne(i, s)) {
                            r.output.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var c = Ot(r.output);
                o.print(c);
                u.code = c.get();
                if (r.sourceMap) {
                    u.map = r.output.source_map.toString();
                    var l = r.sourceMap.url;
                    if (l) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (l == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + V(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + l;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = ie(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = ie(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            He.log_function();
            He.disable_validation();
        }
    }
    h["Dictionary"] = Ce;
    h["List"] = ze;
    h["minify"] = re;
    h["parse"] = St;
    h["push_uniq"] = $e;
    h["TreeTransformer"] = Tt;
    h["TreeWalker"] = wt;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
